Package: prabclus
Title: Functions for Clustering and Testing of Presence-Absence,
        Abundance and Multilocus Genetic Data
Version: 2.3-4
Date: 2024-09-24
Authors@R: c(person("Christian", "Hennig", role = c("aut", "cre"),
             email = "christian.hennig@unibo.it"),
             person("Bernhard", "Hausdorf", role = "aut",
             email = "Hausdorf@zoologie.uni-hamburg.de"))
Depends: R (>= 2.10), MASS, mclust
Suggests: spdep, spatialreg, bootstrap, foreign, mvtnorm
Description: Distance-based parametric bootstrap tests for clustering with 
  spatial neighborhood information. Some distance measures, 
  Clustering of presence-absence, abundance and multilocus genetic data 
  for species delimitation, nearest neighbor 
  based noise detection. Genetic distances between communities.
  Tests whether various distance-based regressions
  are equal. Try package?prabclus for on overview. 
License: GPL
URL: https://www.unibo.it/sitoweb/christian.hennig/en/
NeedsCompilation: no
Packaged: 2024-09-24 10:06:15 UTC; chrish
Author: Christian Hennig [aut, cre],
  Bernhard Hausdorf [aut]
Maintainer: Christian Hennig <christian.hennig@unibo.it>
Repository: CRAN
Date/Publication: 2024-09-24 11:10:02 UTC

"con.comp" <-
function(comat){
  nc <- ncol(comat)
#  print(nc)
  ccn <- rep(0, times=nc) # con.comp number for each point
  fhist <- rep(FALSE, times=nc) # indicator if point had been under consideration  
  stn <- 0                  # current cc number
  pn <- 1                  # point nr. to which similar objects are looked for
  while(pn>0){
    stn <- stn+1
    repeat{
      sm <- 0              # smallest new point nr.
      ccn[pn] <- stn
      fhist[pn] <- TRUE
      if(nc>1)
      {
  	for(i in 2:nc)
        {
# print(comat[i,])
# cat(i, pn, ccn[i], comat[i,pn],"\n")
  	  if((ccn[i]==0) & (comat[i,pn]))
            ccn[i] <- stn
  	  if ((sm==0) & (ccn[i]==stn) & (fhist[i]==FALSE))
            sm <- i
  	} # for i
# cat("stn=", stn, "sm=", sm, "\n")
      } # if nc>1
      if (sm>0)
        pn <- sm
      else
        break
    } # repeat
#    print("repeat terminated")
    pn <- 0
    i <- 2
    while(i<=nc){
      if(ccn[i]==0){
        pn <- i
        i <- nc
      } # if
      i <- i+1
    } # while i
  } # while pn>0 (stn-loop)
  ccn
}

dicedist <- function(regmat) 
{
    nart <- ncol(regmat)
    jdist <- rep(0, nart * nart)
    dim(jdist) <- c(nart, nart)
    for (i in 1:(nart - 1)) {
        for (j in (i + 1):nart) {
            uij <- sum(regmat[, i] + regmat[, j] >= 0.99)
            srij <- sum(regmat[, i] + regmat[, j] >= 1.99)
            jdist[j, i] <- jdist[i, j] <- 1 - 2 * srij/(2*srij+uij)
            if (is.na(jdist[i, j])) 
                cat("Warning! NA at i=", i, ", j=", j, "\n")
        }
    }
    jdist
}


lociplots <- function(indclust,locclust,locprab,lcluster,
                      symbols=NULL,brightest.grey=0.8,darkest.grey=0,
                      mdsdim=1:2){
  if (is.null(symbols))
    symbols <- indclust$symbols
  locfreq <- greyvector <- numeric(0)
  clustloci <- rep(FALSE,length(locprab$nonempty.species))
  clustloci[locprab$nonempty.species] <- locclust==lcluster
  locn <- sum(clustloci)
#  print(clustloci)
  locfreqmin <- locfreqmax <- locfreqmean <- numeric(0)
  for (i in 1:locprab$n.regions)
    locfreq[i] <- sum(clustloci[locprab$nonempty.species] &
                      as.logical(locprab$prab[i,]))/locn
#  print(locfreq)
  ic <- indclust$clustering
  if (min(indclust$clustering)==0)
    ic <- ic+1
  for (i in 1:max(ic)){
    ifreqs <- locfreq[ic==i]
#    print(i)
#    print(ifreqs)
    locfreqmin[i] <- min(ifreqs)
    locfreqmax[i] <- max(ifreqs)
    locfreqmean[i] <- mean(ifreqs)
  }
  lmin <- min(locfreqmin)
  lmax <- max(locfreqmax)
#  print(lmin)
#  print(lmax)
  for (i in 1:locprab$n.regions){
    if (lmax-lmin>0)
      greyvector[i] <- darkest.grey+
        (brightest.grey-darkest.grey)*(lmax-locfreq[i])/(lmax-lmin)
    else
      greyvector[i] <- rep(1,length(locfreq))
  }
#  print(greyvector)
  plot(indclust$points[,mdsdim],pch=symbols,col=grey(greyvector),
       xlab=paste("MDS dimension ",mdsdim[1]),
       ylab=paste("MDS dimension ",mdsdim[2]),
       main=paste("Loci cluster ",lcluster, " max.loc.freq.=",
         format(lmax,digits=3)))
  out <- list(locfreq=locfreq,locfreqmin=locfreqmin,locfreqmax=locfreqmax,
              locfreqmean=locfreqmean)
  out
}



# set.seed(5678)
# indprab <- prabinit(file="MartinezOrtega04AFLP.dat", distance = "jaccard")
# indclust <- prabclust(indprab, mdsmethod="kruskal")
# 
# locprab <- prabinit(file="MartinezOrtega04AFLP.dat", rows.are.species = FALSE)
# locclust <- prabclust(locprab, mdsmethod="kruskal") 
# 
# lp1 <- lociplots(indclust,locclust,indprab,locprab,lcluster=1)
# lp2 <- lociplots(indclust,locclust,indprab,locprab,lcluster=2)
# lp3 <- lociplots(indclust,locclust,indprab,locprab,lcluster=3)
# 
# symvec <- 1:10
# lp3 <- lociplots(indclust,locclust,indprab,locprab,lcluster=3,
#                  symbols=symvec[indclust$clustering])
# 
# 
# (etc.) 

# test
# nb <- list()
# data(kykladspecreg)
# for (i in 1:80)
#    nb <- c(nb,list(scan(file="kykladnbcol.dat",
#                    skip=i-1,nlines=1)))
# kycol <- prabinitcols(prabmatrix=kykladspecreg, neighborhood=nb)
# kytest <- prabtestcols(kycol, times=50, pd=0.95)
# summary(kytest)
# kytest2 <- prabtestcols(kycol, times=50, ignore.richness=TRUE)
# summary(kytest2)

# Hier ist der Kram aus Marshal06.R

allelepaircomp <- function(allelepair1,allelepair2,method="sum"){
#  if (nachar %in% allelepair1 | nachar %in% allelepair2) out <- NA
  out <- sum(allelepair1==allelepair2)
  if (!is.na(out) & out==0)
    out <- sum(allelepair1==allelepair2[c(2,1)])
  if (!is.na(out) & method=="geometrical"){
    if (out==1 & ((allelepair1[1]==allelepair1[2])|
          (allelepair2[1]==allelepair2[2])))
      out <- sqrt(0.5)
    else
      out <- out/2
  }    
  out
}

# Expects list of paired vectors
alleledist <- function(allelelist,ni,np,count=FALSE){
#  ni <- nrow(alleleframe)  individuals
#  np <- ncol(alleleframe)
  jdist <- matrix(0,nrow=ni,ncol=ni)
  for (i in 1:(ni-1)){
    if (count) cat("Dissimilarity: processing row ",i,"\n")
    for (j in (i+1):ni){
      agreements <- numeric(0)
      for (k in 1:np)
        agreements[k] <- allelepaircomp(allelelist[[k]][[i]],allelelist[[k]][[j]])
      sagreements <- sum(agreements,na.rm=TRUE)
      snna <- sum(!is.na(agreements))
      if (snna>0)
        jdist[i,j] <- jdist[j,i] <- 1-sagreements/(2*snna)
      else{
        jdist[i,j] <- jdist[j,i] <- 1
#        cat("\n i=",i," j=",j,"\n")
        warning("Too many NAs, distance cannot be computed, set to 1.")
      }
    }
  }
  jdist
}

# # Expects list of paired vectors
# chorddist <- function(allelelist,ni,np,count=FALSE){
# #  ni <- nrow(alleleframe)  individuals
# #  np <- ncol(alleleframe)
#   jdist <- matrix(0,nrow=ni,ncol=ni)
#   for (i in 1:(ni-1)){
#     if (count) cat("Dissimilarity: processing row ",i,"\n")
#     for (j in (i+1):ni){
#       agreements <- numeric(0)
#       for (k in 1:np)
#         agreements[k] <- allelepaircomp(allelelist[[k]][[i]],allelelist[[k]][[j]],method="geometrical")
#       sagreements <- sum(sqrt(2*(1-agreements)),na.rm=TRUE)
#       snna <- sum(!is.na(agreements))
#       if (snna>0)
#         jdist[i,j] <- jdist[j,i] <- 2*sagreements/(pi*snna)
#       else{
#         jdist[i,j] <- jdist[j,i] <- 1
#         cat("\n i=",i," j=",j,"\n")
#         warning("Too many NAs, distance cannot be computed, set to 1.")
#       }
#     }
#   }
#   jdist
# }
# 
# # Expects list of paired vectors
# neidist <- function(allelelist,ni,np,count=FALSE){
# #  ni <- nrow(alleleframe)  individuals
# #  np <- ncol(alleleframe)
#   jdist <- matrix(0,nrow=ni,ncol=ni)
#   for (i in 1:(ni-1)){
#     if (count) cat("Dissimilarity: processing row ",i,"\n")
#     for (j in (i+1):ni){
#       agreements <- numeric(0)
#       for (k in 1:np)
#         agreements[k] <- allelepaircomp(allelelist[[k]][[i]],allelelist[[k]][[j]],method="geometrical")
#       sagreements <- sum(agreements,na.rm=TRUE)
#       snna <- sum(!is.na(agreements))
#       if (snna>0)
#         jdist[i,j] <- jdist[j,i] <- 1-sagreements/snna
#       else{
#         jdist[i,j] <- jdist[j,i] <- 1
#         cat("\n i=",i," j=",j,"\n")
#         warning("Too many NAs, distance cannot be computed, set to 1.")
#       }
#     }
#   }
#   jdist
# }
# 

build.ext.nblist <- function(neighbors,n.individuals=length(neighbors))
{
    ext.nblist <- list()
    for (i in seq(1,2*n.individuals-1,2)){
      ext.nblist[[i]] <- ext.nblist[[i+1]] <-
        c(2*neighbors[[floor((i+1)/2)]],2*neighbors[[floor((i+1)/2)]]-1)
      ext.nblist[[i]] <- c(ext.nblist[[i]],i+1)
      ext.nblist[[i+1]] <- c(ext.nblist[[i+1]],i)
    }
    ext.nblist
}
      
build.charmatrix <- function(allelelist,n.individuals,n.variables)
{
  cm <- matrix(nrow=2*n.individuals,ncol=n.variables)
  for (i in 1:n.individuals)
    for (k in 1:n.variables)
      cm[2*i-2+(1:2),k] <- allelelist[[k]][[i]]
  cm
}

unbuild.charmatrix <- function(charmatrix,n.individuals,n.variables)
{
  allelelist <- list()
  for (i in 1:n.variables){
    allelelist[[i]] <- list()
    for (k in 1:n.individuals){
      allelelist[[i]][[k]] <- charmatrix[2*k-2+(1:2),i]
      if (is.na(charmatrix[2*k-1,i])) allelelist[[i]][[k]] <- NA
    }
  }
  allelelist
}

nastats <- function(amatrix, nastr="--"){
  nano <- function(avector, nastr)
    sum(avector==nastr)
  
  narow <- apply(amatrix, 1, nano, nastr=nastr)
  nacol <- apply(amatrix, 2, nano, nastr=nastr)
  out <- list(narow=narow,nacol=nacol)
  out
}

# alleleconvert IS DOCUMENTED
# if file ("path/filename") is specified, data is read from file
# otherwise R-object strmatrix is read
# format.in can be "genepop" or "structure"
# format.out can be "prabclus" or "structurama"
# alength: length of allele entry in original genepop file
# orig.nachar: how are NAs specified in original data
# new.nachar: how are NAs specified in output
# firstcolname: ist first column of input individual name? (If so,
# will be added to output file)
# aletters: symbols for alleles in "prabclus" format
# outfile: filename to write output; if NULL, no file is written
alleleconvert <- function(file=NULL,strmatrix=NULL, format.in="genepop",
                          format.out="prabclus",
                          alength=3,orig.nachar="000",new.nachar="-",
                          rows.are.individuals=TRUE, firstcolname=FALSE,
                          aletters=intToUtf8(c(65:90,97:122),multiple=TRUE),
                          outfile=NULL){
  if (is.null(file))
    m1 <- strmatrix
  else
    m1 <- read.table(file,colClasses="character")
  if (firstcolname){
    if (format.in=="structure")
      colnamesv <- m1[seq(1,nrow(m1)-1,by=2),1]
    if (format.in=="genepop")  
      colnamesv <- m1[,1]
    m1 <- m1[,2:ncol(m1)]
  }
  if (!rows.are.individuals) 
        m1 <- t(m1)
  if (format.in=="genepop"){
    n.individuals <- nrow(m1)
    n.variables <- ncol(m1)
  }
  if (format.in=="structure"){
    n.individuals <- nrow(m1)/2
    n.variables <- ncol(m1)
  }
#  str(m1)
#  print(aletters)
  first.allele <- second.allele <- outmatrix <- matrix("",ncol=n.variables,
                                          nrow=n.individuals)
  double.out <- matrix("",ncol=n.variables, nrow=2*n.individuals)
  if (format.in=="genepop"){
    for (i in 1:n.individuals)
      for (j in 1:n.variables){
        first.allele[i,j] <- substring(m1[i,j],1,alength)
        second.allele[i,j] <- substring(m1[i,j],alength+1,2*alength)
      }
  }
  if (format.in=="structure"){
    for (i in 1:n.individuals)
      for (j in 1:n.variables){
        first.allele[i,j] <- m1[2*i-1,j]
        second.allele[i,j] <- m1[2*i,j]
      }
  }     
  double.allele <- rbind(first.allele,second.allele)
#  print(double.allele[c(1:10,300:319),])
  maxk <- 0
  for (j in 1:n.variables){
    jlevels <- levels(as.factor(double.allele[,j]))
    jlevels <- jlevels[jlevels!=orig.nachar]
    if (length(jlevels)>maxk) maxk <- length(jlevels)
#    print(jlevels)
    double.out[double.allele[,j]==orig.nachar,j] <- new.nachar
    if (format.out=="prabclus"){
      for (k in 1:length(jlevels))
        double.out[double.allele[,j]==jlevels[k],j] <- aletters[k]
      outmatrix[,j] <- mapply(paste,double.out[1:n.individuals,j],
                            double.out[(n.individuals+1):(2*n.individuals),j],
                            sep="")
      out <- structure(outmatrix,alevels=aletters[1:maxk])
    }
    if (format.out=="structurama"){
      for (k in 1:length(jlevels))
        double.out[double.allele[,j]==jlevels[k],j] <- jlevels[k]
      outmatrix[,j] <- mapply(paste,"(",double.out[1:n.individuals,j],",",
                            double.out[(n.individuals+1):(2*n.individuals),j],
                              ")",
                            sep="")
      out <- structure(outmatrix,alevels=jlevels)
    }
      
#    print(outmatrix[,j])
  }
  if(!is.null(outfile)){
    if (firstcolname)
      outmatrix <- cbind(colnamesv,outmatrix)
    write.table(outmatrix,outfile,quote=FALSE,col.names=FALSE)
  }     
  out
}

# alleleobject$amatrix rows are individuals
allele2zeroone <- function(alleleobject){
  lnumbers <- cumlnumbers <- numeric(0)
  cumlnumbers[1] <- 0
  for (i in 1:alleleobject$n.variables){
    lnumbers[i] <- sum(alleleobject$leveldist[,i]>0)
    cumlnumbers[i+1] <- cumlnumbers[i]+lnumbers[i]
  }
  nzeroone <- cumlnumbers[alleleobject$n.variables+1]
  imatrix <- matrix(0,nrow=alleleobject$n.individuals,ncol=nzeroone)
  for (i in 1:alleleobject$n.variables)
    for (j in 1:lnumbers[i])
      for (k in 1:alleleobject$n.individuals)
        imatrix[k,cumlnumbers[i]+j] <-
          as.integer(alleleobject$alevels[j] %in%
                     alleleobject$charmatrix[((k-1)*2+1):(k*2),i])
  imatrix
}

# See allelepop.nb for namode
# This assumes diploid organisms
# If nachar is only one of a pair, both will be set to nachar
# Note that the first index for allelelist is variable, the second one is
# individual. This is different from amatrix.
# Note! Taking allelematrix from alleleconvert is needed to guarantee a
# level coding of alleles starting from the same levels (usually "A")
# for all loci, which prevents allele2zeroone from producing empty columns.
# Example:
# alleleconvert(strmatrix=alleleobject$amatrix,alength=1,orig.nachar="-")
# distance can be "alleledist", "chord", "ney" and "none".
alleleinit <- function (file = NULL, allelematrix=NULL,
                        rows.are.individuals = TRUE, 
    neighborhood = "none", distance = "alleledist", namode="variables",
                       nachar="-", distcount=FALSE) 
{
    ieq <- function(level,fvector)
      sum(fvector==level,na.rm=TRUE)

    if(is.null(allelematrix))
      m1 <- read.table(file,stringsAsFactors=FALSE)
    else
      m1 <- as.data.frame(allelematrix,stringsAsFactors=FALSE)
    if (!rows.are.individuals) 
        m1 <- t(m1)    
#    m1 <- as.matrix(m1[, regperspec > 0])
#    regperspec <- regperspec[regperspec > 0]
    n.individuals <- nrow(m1)
    n.variables <- ncol(m1)
    nado <- !(namode=="none")
    napair <- paste(nachar,nachar,sep="")
    naprob=NULL
    
    allelelist <- list()
    for (i in 1:n.variables){
      allelelist[[i]] <- list()
      for (j in 1:n.individuals){
        allelelist[[i]][[j]] <- c(substring(m1[j,i],1,1),substring(m1[j,i],2,2))
        if (nado & nachar %in% allelelist[[i]][[j]]){
          allelelist[[i]][[j]] <- NA
          m1[j,i] <- napair
        }
      }
    }
    
    if (nado){
      nam1 <- nastats(m1,nastr=napair)
      nasum <- sum(nam1$narow)
      nallele <- n.individuals*n.variables
      if (namode=="single")
        naprob <- nasum/nallele
      if (namode=="individuals")
        naprob <- nam1$narow/n.variables
      if (namode=="variables")
        naprob <- nam1$nacol/n.individuals
    }
    
    prab <- t(as.matrix(as.data.frame(lapply(lapply(m1,as.factor),as.integer))))
    regperspec <- apply(prab, 2, sum)
    specperreg <- apply(prab, 1, sum)

    if (is.null(attr(allelematrix,"alevels"))){
      alevels <- levels(as.factor(unlist(allelelist)))
    }
    else
      alevels <- attr(allelematrix,"alevels")
    n.levels <- length(alevels)
    leveldist <- matrix(0,ncol=n.variables,nrow=n.levels)
    for (i in 1:n.variables){
      leveldist[,i] <- sapply(alevels,ieq,unlist(allelelist[[i]]))
      if (sum(leveldist[,i])==0) warning("Only NAs in variable ",i)
    }
                
    nb <- list()
    if (is.list(neighborhood)) 
        nb <- neighborhood
    else {
        if (identical(neighborhood,"none")) 
            for (i in 1:n.individuals) nb[[i]] <- numeric(0)
        else for (i in 1:n.individuals)
          nb <- c(nb, list(scan(file = neighborhood, 
            skip = i - 1, nlines = 1, quiet = TRUE)))
    }
    nbtest(nb, n.individuals)
    
    distmat <- switch(distance, alleledist = alleledist(allelelist,
                                  n.individuals,n.variables, count=distcount),
#                      chord = chorddist(allelelist,
#                                  n.individuals,n.variables, count=distcount),
#                      nei = neidist(allelelist,
#                                  n.individuals,n.variables, count=distcount),
                      none = NULL)

    ext.nblist <- build.ext.nblist(nb, n.individuals)
    charmatrix <- build.charmatrix(allelelist, n.individuals, n.variables)
    
    out <- list(distmat = distmat, amatrix = m1,
#                allelelist=allelelist,
                charmatrix=charmatrix,
                nb = nb, ext.nblist=ext.nblist,
                n.variables = n.variables, n.individuals = n.individuals,
                n.levels=n.levels, 
                n.species=n.individuals,
                alevels=alevels, leveldist=leveldist,
                prab=prab,
                regperspec=regperspec, specperreg=specperreg,
        distance = distance, namode=namode, naprob=naprob, nasum=nasum,
                nachar=nachar,
                spatial = (!identical(neighborhood, 
            "none")))
    class(out) <- "alleleobject"
    out
  }


print.alleleobject <- function (x, ...) 
{
    cat("Diploid allele/locus-data object\n")
    cat("Number of individuals: ",x$n.individuals,"\n")
    cat("Number of loci: ",x$n.variables,"\n")
    cat("Alleles (all loci): ",x$alevels,"\n")
    if (x$distance!="none")
      cat("Object contains between-individuals dissimilarity matrix of type ",
          x$distance,".\n")
    if (x$spatial)
      cat("Object contains neighborhood list nb between individuals.\n")
    cat("Object contains ",x$nasum," missing loci data.\n")
    cat("Further potentially informative components:\n")
    cat(" amatrix (individuals*loci matrix),\n")
    cat(" leveldist (distribution of alleles per locus), \n")
    cat(" naprob (probabilities for missing values, governed by namode=",
        x$namode,"), \n")
    cat("components charmatrix, ext.nblist, prab, regperspec, specperreg don't\n")
    cat("contain additional information and are only needed for efficient data handling.\n")
}



stressvals <-  function(x,mdsdim=1:12,trace=FALSE){
  oregions <- order(x$specperreg)
  prabo1 <- x$prab[oregions, ]
  ospecies <- do.call("order", as.data.frame(t(prabo1)))
  dm <- x$distmat[ospecies, ospecies]
  mindm <- min(dm[dm > 0])/10
  for (i in 1:(x$n.species - 1))
    for (j in (i + 1):x$n.species)
    if (dm[i, j] < mindm) 
            dm[i, j] <- dm[j, i] <- mindm
  mdsout <- list()
  for (mdim in mdsdim)
    mdsout[[mdim]] <- isoMDS(dm, k = mdim,trace=FALSE)
  MDSstress <- numeric(0)
  for (i in mdsdim)
    MDSstress[i] <- mdsout[[i]]$stress
  out <- list(MDSstress=MDSstress,mdsout=mdsout)
  out
}


# file.format could be "degminsec", "decimal4", "decimal2"
coord2dist <- function(file=NULL, coordmatrix=NULL, cut=NULL,
                       file.format="degminsec",
                       output.dist=FALSE, radius=6378.137,
                       fp=1/298.257223563, neighbors=FALSE){
  if (is.null(coordmatrix))
    m1 <- as.matrix(read.table(file))
  else
    m1 <- as.matrix(coordmatrix)
  ap <- radius
  n <- nrow(m1)
  p <- ncol(m1)
#  print(p)
  m2 <- matrix(0,ncol=2,nrow=n)
  distmatrix <- matrix(0,ncol=n,nrow=n)
  if (file.format=="decimal2"){
    if (!(p==2)) stop("decimal2 input needs two columns.")
    else
      m2 <- m1
  }
  if (file.format=="decimal4"){
    if (!(p==4)) stop("decimal4 input needs four columns.")
    else{
      m2[,1] <- sign(m1[,1])*(abs(m1[,1])+m1[,2]/100)
      m2[,2] <- sign(m1[,3])*(abs(m1[,3])+m1[,4]/100)
    }
  }
  if (file.format=="degminsec"){
    if (!(p==6)) stop("degminsec input needs six columns.")
    else{
      m2[,1] <- sign(m1[,1])*(abs(m1[,1]) + (m1[,2] + m1[,3] / 60) / 60)
      m2[,2] <- sign(m1[,4])*(abs(m1[,4]) + (m1[,5] + m1[,6] / 60) / 60)
    }
  }
  m2 <- m2*pi/180
  for (i in 1:(n-1))
    for(j in (i+1):n){
      Fp <- (m2[i,1]+m2[j,1])/2
      Gp <- (m2[i,1]-m2[j,1])/2
      lp <- (m2[i,2]-m2[j,2])/2
      Sp <- sin(Gp)^2*cos(lp)^2 +cos(Fp)^2*sin(lp)^2
      Cp <- cos(Gp)^2*cos(lp)^2 +sin(Fp)^2*sin(lp)^2
      wp <- atan(sqrt(Sp/Cp))
      Rp <- sqrt(Sp*Cp)/wp
      Dp <- 2*wp*ap
      H1 <- (3*Rp-1)/(2*Cp)
      H2 <- (3*Rp+1)/(2*Sp)
      if (Gp==0 & lp==0)
        distmatrix[i,j] <- distmatrix[j,i] <- 0
      else
        distmatrix[i,j] <- distmatrix[j,i] <-
          Dp*(1 + fp*H1*sin(Fp)^2*cos(Gp)^2 - fp*H2*cos(Fp)^2*sin(Gp)^2)
    }
  if (output.dist) distmatrix <- as.dist(distmatrix)
  if (neighbors){
    nblist <- geo2neighbor(distmatrix,cut)
    out <- list(distmatrix=distmatrix,nblist=nblist)
  }
  else
    out <- distmatrix
  out
}


  
      

"cluspop.nb" <-
function(neighbors,p.nb=0.5,n.species,clus.specs,reg.group,
                       grouppf=10, n.regions=length(neighbors),
                       vector.species=rep(1,n.species),
                       pdf.regions=rep(1/n.regions,n.regions),count=TRUE,
                       pdfnb=FALSE){
# print(vector.species)
  out <- matrix(0,ncol=n.species,nrow=n.regions)
  if (pdfnb)
  {
    for (i in 1:n.regions)
      pdf.regions[i] <- pdf.regions[i]/max(1,length(neighbors[[i]]))
    pdf.regions <- pdf.regions/sum(pdf.regions)
  }
  pdf.group <- pdf.complement <- pdf.regions
  pdf.groupstart <- pdf.cstart <- rep(0,n.regions)
  sp <- spc <- spr <- 0
  prob.group <- sum(pdf.group[reg.group])
  pdf.complement[reg.group] <- pdf.regions[reg.group]/grouppf
  spc <- sum(pdf.complement[reg.group])
  sp <- spc*grouppf
  reg.c <- (1:n.regions)[-reg.group]
  pdf.group[reg.c] <- pdf.regions[reg.c]/grouppf
  pdf.cstart[reg.c] <- pdf.regions[reg.c]/(1-sp)
  pdf.complement[reg.c] <- pdf.cstart[reg.c]*(1-spc)
  spr <- sum(pdf.group[reg.c])
  pdf.groupstart[reg.group] <- pdf.regions[reg.group]/sp
  pdf.group[reg.group] <- pdf.groupstart[reg.group]*(1-spr)
  cdf.local <- cdf.regions <- cdf.groupstart <- cdf.cstart <- c()
  for (i in 1:n.regions){
    cdf.regions[i] <- sum(pdf.regions[1:i])
    cdf.groupstart[i] <- sum(pdf.groupstart[1:i])
    cdf.cstart[i] <- sum(pdf.cstart[1:i])
  }
# print(pdf.groupstart)    
# print(cdf.groupstart)    
# regular species
  for (i in 1:(n.species-clus.specs))
  {
    if(count)
      cat("Species ",i,"\n")
    spec.regind <- spec.neighb <- rep(FALSE,n.regions)
    nsize <- vector.species[1+floor(length(vector.species)*runif(1))]
# print(nsize)
    r1 <- runif(1)
    reg <- 1+sum(r1>cdf.regions)
# print(reg)
    spec.regind[reg] <- TRUE
    for (k in neighbors[[reg]])
      spec.neighb[k] <- TRUE
    out[reg,i] <- 1
    if(nsize>1)
      for (j in 2:nsize)
        if ((sum(spec.neighb)==0) | (sum(pdf.regions[spec.neighb])<1e-8) |
             (sum(spec.neighb | spec.regind)==n.regions))
# no further neighbors or only neighbors, i.e., next region is drawn from all
# remaining
        {
          nreg <- sum(!spec.regind)
          pdf.local <- pdf.regions[!spec.regind]
          pdf.local <- pdf.local/sum(pdf.local)
          for (l in 1:nreg)
            cdf.local[l] <- sum(pdf.local[1:l])
# cat(nreg, "\n")
          r1 <- runif(1)
          zz <- 1+sum(r1>cdf.local[1:nreg])
# cat(zz,"\n")
          reg <- (1:n.regions)[!spec.regind][zz]
# cat("reg, all ",reg,"\n")  
          spec.regind[reg] <- TRUE
          spec.neighb[reg] <- FALSE
          for (k in neighbors[[reg]])
            spec.neighb[k] <- !(spec.regind[k])
          out[reg,i] <- 1
        }
        else
          if (runif(1)<p.nb)
# next region is drawn from non-neighbors (jump)
          { 
            regs <- !(spec.regind | spec.neighb)
            nreg <- sum(regs)
            pdf.local <- pdf.regions[regs]
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
# cat(nreg," ",zz,"\n")
            reg <- (1:n.regions)[regs][zz]  
# cat("reg, jump ",reg,"\n")  
            spec.regind[reg] <- TRUE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,i] <- 1
# if (sum(out[,i])!=sum(spec.regind))
#   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
          }
          else
          {
# next region is drawn from neighbors
            nreg <- sum(spec.neighb)
            pdf.local <- pdf.regions[spec.neighb]
# print(pdf.local)
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
# print(cdf.local)
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
# cat("nreg= ",nreg," zz =",zz,"\n")
            reg <- (1:n.regions)[spec.neighb][zz]  
# cat("reg, neighbor ",reg,"\n")  
            spec.regind[reg] <- TRUE
            spec.neighb[reg] <- FALSE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,i] <- 1
# if (sum(out[,i])!=sum(spec.regind))
#   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
          }
# end if nsize>1 for j 
# cat("out=",sum(out[,i]),"  ind=",sum(spec.regind),"  nb=",sum(spec.neighb),
#    "  nni=",sum(!(spec.regind | spec.neighb)),"\n")
  } # for i - regular species
# species from reg.group
  for (i in 1:clus.specs)
  {
    ind <-i+n.species-clus.specs 
    if(count)
      cat("Clustered species ",ind,"\n")
    groupind <- runif(1)<prob.group
    if (groupind){
      spec.regind <- spec.neighb <- rep(FALSE,n.regions)
      nsize <- vector.species[1+floor(length(vector.species)*runif(1))]
  # print(nsize)
      r1 <- runif(1)
      reg <- 1+sum(r1>cdf.groupstart)
  # print(reg)
      spec.regind[reg] <- TRUE
      for (k in neighbors[[reg]])
        spec.neighb[k] <- TRUE
      out[reg,ind] <- 1
      if(nsize>1)
        for (j in 2:nsize)
          if ((sum(spec.neighb)==0) | (sum(pdf.group[spec.neighb])<1e-8) |
               (sum(spec.neighb | spec.regind)==n.regions))
  # no further neighbors or only neighbors, i.e., next region is drawn from all
  # remaining
          {
            nreg <- sum(!spec.regind)
            pdf.local <- pdf.group[!spec.regind]
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
  # cat(nreg, "\n")
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat(zz,"\n")
            reg <- (1:n.regions)[!spec.regind][zz]
  # cat("reg, all ",reg,"\n")  
            spec.regind[reg] <- TRUE
            spec.neighb[reg] <- FALSE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,ind] <- 1
          }
          else
            if (runif(1)<p.nb)
  # next region is drawn from non-neighbors (jump)
            { 
              regs <- !(spec.regind | spec.neighb)
              nreg <- sum(regs)
              pdf.local <- pdf.group[regs]
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg)
                cdf.local[l] <- sum(pdf.local[1:l])
              r1 <- runif(1)
              zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat(nreg," ",zz,"\n")
              reg <- (1:n.regions)[regs][zz]  
  # cat("reg, jump ",reg,"\n")  
              spec.regind[reg] <- TRUE
              for (k in neighbors[[reg]])
                spec.neighb[k] <- !(spec.regind[k])
              out[reg,ind] <- 1
  # if (sum(out[,i])!=sum(spec.regind))
  #   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
            }
            else
            {
  # next region is drawn from neighbors
              nreg <- sum(spec.neighb)
              pdf.local <- pdf.group[spec.neighb]
  # print(pdf.local)
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg)
                cdf.local[l] <- sum(pdf.local[1:l])
  # print(cdf.local)
              r1 <- runif(1)
              zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat("nreg= ",nreg," zz =",zz,"\n")
              reg <- (1:n.regions)[spec.neighb][zz]  
  # cat("reg, neighbor ",reg,"\n")  
              spec.regind[reg] <- TRUE
              spec.neighb[reg] <- FALSE
              for (k in neighbors[[reg]])
                spec.neighb[k] <- !(spec.regind[k])
              out[reg,ind] <- 1
  # if (sum(out[,i])!=sum(spec.regind))
  #   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
            }
  # end if nsize>1 for j 
  # cat("out=",sum(out[,i]),"  ind=",sum(spec.regind),"  nb=",sum(spec.neighb),
  #    "  nni=",sum(!(spec.regind | spec.neighb)),"\n")
    } # if groupind           
# species from complement
    else{
      spec.regind <- spec.neighb <- rep(FALSE,n.regions)
      nsize <- vector.species[1+floor(length(vector.species)*runif(1))]
  # print(nsize)
      r1 <- runif(1)
      reg <- 1+sum(r1>cdf.cstart)
  # print(reg)
      spec.regind[reg] <- TRUE
      for (k in neighbors[[reg]])
        spec.neighb[k] <- TRUE
      out[reg,ind] <- 1
      if(nsize>1)
        for (j in 2:nsize)
          if ((sum(spec.neighb)==0) | (sum(pdf.complement[spec.neighb])<1e-8) |
               (sum(spec.neighb | spec.regind)==n.regions))
  # no further neighbors or only neighbors, i.e., next region is drawn from all
  # remaining
          {
            nreg <- sum(!spec.regind)
            pdf.local <- pdf.complement[!spec.regind]
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
  # cat(nreg, "\n")
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat(zz,"\n")
            reg <- (1:n.regions)[!spec.regind][zz]
  # cat("reg, all ",reg,"\n")  
            spec.regind[reg] <- TRUE
            spec.neighb[reg] <- FALSE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,ind] <- 1
          }
          else
            if (runif(1)<p.nb)
  # next region is drawn from non-neighbors (jump)
            { 
              regs <- !(spec.regind | spec.neighb)
              nreg <- sum(regs)
              pdf.local <- pdf.complement[regs]
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg)
                cdf.local[l] <- sum(pdf.local[1:l])
              r1 <- runif(1)
              zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat(nreg," ",zz,"\n")
              reg <- (1:n.regions)[regs][zz]  
  # cat("reg, jump ",reg,"\n")  
              spec.regind[reg] <- TRUE
              for (k in neighbors[[reg]])
                spec.neighb[k] <- !(spec.regind[k])
              out[reg,ind] <- 1
  # if (sum(out[,i])!=sum(spec.regind))
  #   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
            }
            else
            {
  # next region is drawn from neighbors
              nreg <- sum(spec.neighb)
              pdf.local <- pdf.complement[spec.neighb]
  # print(pdf.local)
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg)
                cdf.local[l] <- sum(pdf.local[1:l])
  # print(cdf.local)
              r1 <- runif(1)
              zz <- 1+sum(r1>cdf.local[1:nreg])
  # cat("nreg= ",nreg," zz =",zz,"\n")
              reg <- (1:n.regions)[spec.neighb][zz]  
  # cat("reg, neighbor ",reg,"\n")  
              spec.regind[reg] <- TRUE
              spec.neighb[reg] <- FALSE
              for (k in neighbors[[reg]])
                spec.neighb[k] <- !(spec.regind[k])
              out[reg,ind] <- 1
  # if (sum(out[,i])!=sum(spec.regind))
  #   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
            }
  # end if nsize>1 for j 
  # cat("out=",sum(out[,i]),"  ind=",sum(spec.regind),"  nb=",sum(spec.neighb),
  #    "  nni=",sum(!(spec.regind | spec.neighb)),"\n")
    } # else (complement)
  } # for i
  out
}

# library(bootstrap)

# This is no good because for comparing regressions
# we don't have a single null model.
# compareregdist <- function(x,dmx,dmy,grouping){
#   lcl <- levels(as.factor(grouping)[x])
#   cld <- as.factor(grouping[x])==lcl[1]
#   n <- length(grouping[x])
#   distx <- dmx[x,x]
#   disty <- dmy[x,x]
#   nd1 <- length(as.vector(as.dist(distx[cld,cld])))
#   nd2 <- length(as.vector(as.dist(distx[!cld,!cld])))
#   ndummy <- c(rep(1,nd1),rep(0,nd2))
#   xv <- c(as.vector(as.dist(distx[cld,cld])),as.vector(as.dist(distx[!cld,!cld])))
#   yv <- c(as.vector(as.dist(disty[cld,cld])),as.vector(as.dist(disty[!cld,!cld])))
#   cxi <- xv*ndummy
#   lmfull <- lm(yv~ndummy+xv+cxi)
#   lmtogether <- lm(yv~xv)
#   logf <- log(anova(lmtogether,lmfull)$F[2])
#   logf
# }

# This defines communities from a given geographical distance matrix or dist
# object. cutoff is the geographical distance below which individuals are put
# together (by hclust/cutree method, default is single linkage).
# individuals in different groups in grouping
# cannot be in the same community. Probably for later testing 2 groups
# it is best to run this with a 2 groups grouping only.
communities <- function(geodist,grouping=NULL,
                        cutoff=1e-5,method="single"){
  geodist <- as.dist(geodist)
  hg <- hclust(geodist,method=method)
  hgc <- cutree(hg,h=cutoff)
  maxcl <- max(hgc)
  mc <- maxcl+1
  if (!is.null(grouping)){
    fgrouping <- as.factor(grouping)
    for (i in 1:maxcl){
      ilev <- as.vector(levels(droplevels(fgrouping[hgc==i])))
      q <- length(ilev)
      if (q>1)
        for (j in 2:q){
          hgc[(hgc==i) & (fgrouping==ilev[j])] <- mc
          mc <- mc+1
        }
    }   
  }
  hgc
}

phipt <- function(alleleobj,comvector,i,j){
    ssg <- numeric(0)
    ssg[i] <-sum(as.dist(alleleobj$distmat[comvector==i,comvector==i]))/sum(comvector==i)
    ssg[j] <-sum(as.dist(alleleobj$distmat[comvector==j,comvector==j]))/sum(comvector==j)
    sst <- sum(as.dist(alleleobj$distmat[comvector %in% c(i,j),comvector %in% c(i,j)]))/sum(comvector %in% c(i,j))
    msa <- ssa <- sst-ssg[i]-ssg[j]
    ssw <- ssg[i]+ssg[j]
    msw <- ssw/(sum(comvector %in% c(i,j))-2)
    if (is.na(msw)) msw <- 0
    n0 <- sum(comvector %in% c(i,j))-(sum(comvector==i)^2+sum(comvector==j)^2)/sum(comvector %in% c(i,j))
    vap <- (msa-msw)/n0
    phipt <- vap/(vap+msw)
    out <- list(phipt=phipt,vap=vap,n0=n0,sst=sst,ssg=ssg,msa=msa,msw=msw)
    out
}


# Cavalli-Sforza-Edwards Chord distance between communities
# from lists p1, p2. Every list entry
# corresponds to a locus and is a vector holding relative frequencies for
# every allele. A list entry can be a single NA in case all community members
# have NA on that locus.
cfchord <- function(p1,p2){
  n <- length(p1)
  n2 <- length(p2)
  if (n!=n2) stop("Lists p1 and p2 must have the same length.")
  naloci <- numeric(0)
  vd <- rep(NA,n)
  for (i in 1:n)
    if (!is.na(p1[[i]][1]) & !is.na(p2[[i]][1])){
      cosphi <- sum(sqrt(p1[[i]]*p2[[i]]))
      vd[i] <- 2*sqrt(2*(1-cosphi))/pi
    }
  validd <- n-sum(is.na(vd))
  out <- sqrt(n*sum(vd[!is.na(vd)]^2)/validd)
  out
}

shared.problist <- function(p1,p2){
  n <- length(p1)
  n2 <- length(p2)
  if (n!=n2) stop("Lists p1 and p2 must have the same length.")
  naloci <- numeric(0)
  vd <- rep(NA,n)
  for (i in 1:n)
    if (!is.na(p1[[i]][1]) & !is.na(p2[[i]][1])){
      vd[i] <- sum(pmin(p1[[i]],p2[[i]]))
    }
  out <- mean(vd,na.rm=TRUE)
  out
}
 

# Construct input lists for cfchord
diploidcomlist <- function(alleleobj,comvector,diploid=TRUE){
  ncom <- max(comvector)
  if (diploid)
    dcomvector <- rep(comvector,each=2)
  else
    dcomvector <- comvector
  out <- list()
#  print(str(alleleobj$charmatrix))
  for (i in 1:ncom){
    out[[i]]  <- list()
    for (j in 1:alleleobj$n.variables){
#      cat("i=",i,"j=",j,"\n")
#      print(dcomvector==i)
      dvec <- factor(
        as.vector(alleleobj$charmatrix[dcomvector==i,j]),
        levels=alleleobj$alevels)
      tdvec <- as.vector(table(dvec))
      ntdvec <- sum(tdvec)
      if (ntdvec>0)
        out[[i]][[j]] <- tdvec/ntdvec
      else
        out[[i]][[j]] <- NA
    }
  }
  out
}

# This constructs a chord-distance matrix between communities.
# comvector: indicates community for individuals; must be numbered from
# 1 to maximum, or "auto" in which case the communities function is
# used. ... are additional arguments to that function; if grouping=NA,
# communities will ignore grouping.
# distance can be "chord", "phipt", "shared.average", "shared.chakraborty",
# "shared.problist".
# communities requires a geographical distance geodist.
# compute.geodist: if TRUE, geographical distance
# between communities will be created, based on distance geodist between
# individuals.
# out.dist: Will dist objects be given out or matrices?
# out: comvector (community indicator), comgroup (group indicator for
# communities), dist, cgeodist
# phiptna: Value where phipt cannot be computed because of communities of size 1.
communitydist <- function(alleleobj,comvector="auto",distance="chord",
                          compute.geodist=TRUE,out.dist=FALSE,
                          grouping=NULL,geodist=NA,diploid=TRUE,
                          phiptna=NA,...){
  if (identical(comvector,"auto")){
    if(is.null(grouping))
      comvector <- communities(geodist,...)
    else
      comvector <- communities(geodist,grouping,...)
  }
  ncom <- max(comvector)
  dclist <- diploidcomlist(alleleobj,comvector,diploid)
  chorddist <- matrix(0,ncol=ncom,nrow=ncom)
  if (distance=="chord"){
    for(i in 1:(ncom-1))
      for (j in (i+1):ncom)
        chorddist[i,j] <- chorddist[j,i] <- cfchord(dclist[[i]],dclist[[j]])
  }
  if (distance=="shared.problist"){
    for(i in 1:(ncom-1))
      for (j in (i+1):ncom)
        chorddist[i,j] <- chorddist[j,i] <- 1-shared.problist(dclist[[i]],dclist[[j]])
  }
  if (distance=="phipt"){
    ssg <- numeric(0)
    for (i in 1:ncom)
      ssg[i] <-sum(as.dist(alleleobj$distmat[comvector==i,comvector==i]))/sum(comvector==i)
    for(i in 1:(ncom-1))
      for (j in (i+1):ncom){
        sst <- sum(as.dist(alleleobj$distmat[comvector %in% c(i,j),comvector %in% c(i,j)]))/sum(comvector %in% c(i,j))
        msa <- ssa <- sst-ssg[i]-ssg[j]
        ssw <- ssg[i]+ssg[j]
        msw <- ssw/(sum(comvector %in% c(i,j))-2)
#        if (is.na(msw)) msw <- phiptna
        n0 <- sum(comvector %in% c(i,j))-(sum(comvector==i)^2+sum(comvector==j)^2)/sum(comvector %in% c(i,j))
        vap <- (msa-msw)/n0
        chorddist[i,j] <- chorddist[j,i] <- vap/(vap+msw)
        if (is.na(chorddist[i,j])) chorddist[i,j] <- chorddist[j,i] <- phiptna
      }
  }
  if (distance=="shared.average"){
    for(i in 1:(ncom-1))
      for (j in (i+1):ncom)
        chorddist[i,j] <- chorddist[j,i] <- mean(alleleobj$distmat[comvector==i,comvector==j])
  }
  if (distance=="shared.chakraborty"){
    avewithin <- numeric(0)
    for (i in 1:ncom){
      imat <-  alleleobj$distmat[comvector==i,comvector==i]
      avewithin[i] <- mean(imat[upper.tri(imat,diag=TRUE)])
    }
    for(i in 1:(ncom-1))
      for (j in (i+1):ncom)
        chorddist[i,j] <- chorddist[j,i] <-
          1-(2-2*mean(alleleobj$distmat[comvector==i,comvector==j]))/
           (2-avewithin[i]-avewithin[j])
  }
  if (out.dist)
    chorddist <- as.dist(chorddist)
  out <- list(comvector=comvector,dist=chorddist)
  if (compute.geodist){
   cgeodist <- matrix(0,ncol=ncom,nrow=ncom)
   geodist=as.matrix(geodist)
   for(i in 1:(ncom-1))
     for (j in (i+1):ncom)
       cgeodist[i,j] <- cgeodist[j,i] <-
         mean(geodist[comvector==i,comvector==j])
     if (out.dist)
       cgeodist <- as.dist(cgeodist)
   out$cgeodist <- cgeodist 
  }
  if (is.null(grouping))
    out$comgroup  <- rep(1,ncom)
  else{
    out$comgroup <- numeric(0)
    for (i in 1:ncom)
      out$comgroup[i] <- grouping[comvector==i][1]
  }
  out
}


# This computes a regression between distance matrices extracted
# from dmx and dmy by indicator vector x
# param (output parameter) can be 1 or 2, 1 for intercept, 2 for slope.
# x centered by xcenter
regdist <- function(x,dmx,dmy,xcenter=0,param=NULL){
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  distx <- dmx[x,x]
  disty <- dmy[x,x]
#   nd1 <- length(as.vector(as.dist(distx[cld,cld])))
#   nd2 <- length(as.vector(as.dist(distx[!cld,!cld])))
#   ndummy <- c(rep(1,nd1),rep(0,nd2))
  xv <- as.vector(as.dist(distx))-xcenter
  yv <- as.vector(as.dist(disty))
  lmdist <- lm(yv~xv)
  if (is.null(param)) out <- lmdist
  else out <- coef(lmdist)[param]
  out
}
 



# Jackknife-based test for equality of 2 regressions
# distance matrices dmx and dmy, grouping is vector with 1 and 2
# defining the data for the two regressions
regeqdist <- function(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2]){ 
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  grouping <- as.factor(grouping)
  n <- length(grouping)
  computable <- sum(grouping==groups[1])>2 & sum(grouping==groups[2])>2
#  cld <- as.factor(grouping[x])==groups[1]
  if (computable){
    dmxc <- dmyc <- jr <- lmfit <- xvi <- yvi <- list()
    nc <- sediff <- coefdiff <- pval <- condition <- numeric(0)
    for (i in 1:2){
      dmxc[[i]] <- dmx[grouping==groups[i],grouping==groups[i]]
      dmyc[[i]] <- dmy[grouping==groups[i],grouping==groups[i]]
      jr[[i]] <- list()
      nc[i] <- sum(grouping==groups[i])
      xvi[[i]] <- as.vector(as.dist(dmxc[[i]]))
      yvi[[i]] <- as.vector(as.dist(dmyc[[i]]))
    }
    xall <- c(xvi[[1]],xvi[[2]])
    xcenter <- mean(xall)
    clm <- jackpseudo <- jackestcl <- jackvarcl <- list()
    jackse <- jackest <- tstat <- tdf <- numeric(0)
    for (i in 1:2){
      jackpseudo[[i]] <- list()
      jackestcl[[i]] <- jackvarcl[[i]] <- numeric(0)
      for (j in 1:2)
        jackpseudo[[i]][[j]] <- numeric(0)
    }
    for (i in 1:2){
      xvi[[i]] <- xvi[[i]]-xcenter
      lmfit[[i]] <- lm(yvi[[i]]~xvi[[i]])
      mm <- model.matrix(~xvi[[i]])
      condition[i] <- kappa(mm)
      clm[[i]] <- coef(lmfit[[i]])
    }
    for (i in 1:2)
      for (j in 1:2)
        jr[[i]][[j]] <- bootstrap::jackknife(1:nc[i],regdist,dmx=dmxc[[i]],
                                  dmy=dmyc[[i]],xcenter=xcenter,param=j)
    for (j in 1:2){
      for (i in 1:2)
        if (is.na(jr[[i]][[j]]$jack.se)) computable <- FALSE
      coefdiff[j] <- clm[[1]][j]-clm[[2]][j]    
#      if(computable){
      for (i in 1:2){
        for (k in 1:nc[i])
          jackpseudo[[i]][[j]][k] <-
            nc[i]*clm[[i]][j]-(nc[i]-1)*jr[[i]][[j]]$jack.values[k]
        jackestcl[[i]][j] <- mean(jackpseudo[[i]][[j]])
        jackvarcl[[i]][j] <- var(jackpseudo[[i]][[j]])
      }
      jackest[j] <- jackestcl[[1]][j]-jackestcl[[2]][j]
      jackse[j] <- sqrt(jackvarcl[[1]][j]/nc[1]+jackvarcl[[2]][j]/nc[2])
      tstat[j] <- jackest[j]/jackse[j]
      # Run Welch's t-test, 2-sided
      tdf[j] <-
        jackse[j]^4/((jackvarcl[[1]][j]/nc[1])^2/(nc[1]-1)+
                     (jackvarcl[[2]][j]/nc[2])^2/(nc[2]-1))
      if (tstat[j]>0)
        pval[j] <- 2*(pt(tstat[j],tdf[j],lower.tail=FALSE))
      else
        pval[j] <- 2*(pt(tstat[j],tdf[j]))
 #     }
 #     else
 #       pval <- tstat <- tdf <- jackest <- jackse <- jackpseudo <- NA
    }
    out <- list(pval=pval,coefdiff=coefdiff,condition=condition,lmfit=lmfit,jr=jr,xcenter=xcenter,tstat=tstat,tdf=tdf,jackest=jackest,jackse=jackse,jackpseudo=jackpseudo,groups=groups)
  }
  else
    out <- NA
  class(out) <- "regeqdist"
  out
}

print.regeqdist <- function(x,...){
  if (identical(x[[1]], NA))
    print("Too few individuals in one group. Regression could not be computed.")
  else{
  cat("Testing equality for distance-based regressions in two groups\n")
  cat(x$groups[1]," and ",x$groups[2],"\n")
  if (all(is.na(x$pval)))
    cat("p-value could not be computed because of ill-conditioned regressions\n (probably there were too few or too geographically concentrated individuals\n in a group).\n")
  else{
    cat("Approx. p-values (intercept, slope): ", x$pval,"\n")
    cat("Approx. Bonferroni p-value: ", min(c(1,min(x$pval)*2)),"\n")
    cat("Difference between coefficients, plain (intercept,slope): ",x$coefdiff,"\n")
    cat("Difference between coefficients, jackknife (intercept,slope): ",x$jackest,"\n")
    cat("Standard error of difference, jackknife (intercept, slope): ",x$jackse,"\n")
    cat("Welch-Satterthwaite degrees of freedom: ",x$tdf,"\n")
  }
  }
#  cat("Condition numbers of regressions (clusters): ",x$condition,"\n")
}
  
# For testing whether distanzes between clusters are compatible with   
# joint regression within clusters, compute regression within clusters,
# compute jackknife se (both parameters?? check formula for confidence/
# prediction intervals), and then check whether between-cluster distances
# are outside prediction interval.


# Compute regression from within-cluster distances only; from all
# distances, and compute difference between the two
# where x is the center of between-cluster distances
# This should vary around 0 under H0 (equality) and se can be estimated.
regdistdiff <- function(x,dmx,dmy,grouping,xcenter=0,xcenterbetween=0){
  clx <- grouping[x]
  groups <- unique(clx)
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  dmxx <- dmx[x,x]
  dmyx <- dmy[x,x]
  dmxc <- dmyc <- lmfit <- list()
  dmxc[[1]] <- c(as.vector(as.dist(dmxx[clx==groups[1],clx==groups[1]])),
                 as.vector(as.dist(dmxx[clx==groups[2],clx==groups[2]])))-xcenter
  dmxc[[2]] <- as.vector(as.dist(dmxx))-xcenter
  dmyc[[1]] <- c(as.vector(as.dist(dmyx[clx==groups[1],clx==groups[1]])),
                 as.vector(as.dist(dmyx[clx==groups[2],clx==groups[2]])))
  dmyc[[2]] <- as.vector(as.dist(dmyx))
  for (i in 1:2)
    lmfit[[i]] <- lm(dmyc[[i]]~dmxc[[i]])
  out <- coef(lmfit[[2]])[1]-coef(lmfit[[1]])[1]+(coef(lmfit[[2]])[2]-coef(lmfit[[1]])[2])*xcenterbetween
  out
}



# Tests whether  regression for between-cluster distances
# is compatible with regressions for within-cluster distances
# at between-cluster central value of x
# by calling regdistdiff and using jackknife 
regdistbetween <- function(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2]){
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  grouping <- as.factor(grouping)
  n <- sum(grouping %in% groups)
  computable <- (n>2)
#  cld <- as.factor(grouping[x])==groups[1]
  dmxc <- dmyc <- lmfit <- list()
  coefdiff <- pval <- condition <- numeric(0)
  dmxc[[1]] <- c(as.vector(as.dist(dmx[grouping==groups[1],grouping==groups[1]])),
                 as.vector(as.dist(dmx[grouping==groups[2],grouping==groups[2]])))
  xcenter <- mean(dmxc[[1]])
  dmxc[[1]] <- dmxc[[1]]-xcenter
  dmxc[[2]] <- as.vector(as.dist(dmx[grouping %in% groups, grouping %in% groups]))-xcenter
  dmxcbetween <- as.vector(dmx[grouping==groups[1],grouping==groups[2]])-xcenter
  xcenterbetween <- mean(dmxcbetween)
  dmyc[[1]] <- c(as.vector(as.dist(dmy[grouping==groups[1],grouping==groups[1]])),
                 as.vector(as.dist(dmy[grouping==groups[2],grouping==groups[2]])))
  dmyc[[2]] <- as.vector(as.dist(dmy[grouping %in% groups, grouping %in% groups]))
  jackpseudo <- numeric(0)
  for (i in 1:2){
    lmfit[[i]] <- lm(dmyc[[i]]~dmxc[[i]])
#    jr[[i]] <- list()
#    nc[i] <- sum(grouping==groups[i])
    mm <- model.matrix(~dmxc[[i]])
    condition[i] <- kappa(mm)
  }
  jr <- bootstrap::jackknife(1:n,regdistdiff,
                  dmx=dmx[grouping %in% groups, grouping %in% groups],
                  dmy=dmy[grouping %in% groups, grouping %in% groups],
                  grouping=grouping[grouping %in% groups],xcenter=xcenter,
                         xcenterbetween=xcenterbetween)
#    sediff[j] <- sqrt(jr[[1]][[j]]$jack.se^2+jr[[2]][[j]]$jack.se^2)
  if (is.na(jr$jack.se)) computable <- FALSE
  coefdiff <- (coef(lmfit[[2]])[1]-coef(lmfit[[1]])[1])+(coef(lmfit[[2]])[2]-coef(lmfit[[1]])[2])*xcenterbetween
  if (computable){
      for (k in 1:n)
        jackpseudo[k] <- n*coefdiff-(n-1)*jr$jack.values[k]
      jackest <- mean(jackpseudo)
      jackse <- sd(jackpseudo)/sqrt(n)
      tstat <- jackest/jackse
      # One-sided t-test
      tdf <- n-1
      pval <- pt(tstat,tdf,lower.tail=FALSE)
  }
  else
      pval <- tstat <- tdf <- jackest <- jackse <- jackpseudo <- NA
  testname <- "Testing whether regression for between-group distances\n is compatible with regressions for within-group distances"  
  out <- list(pval=pval,coefdiff=coefdiff,condition=condition,lmfit=lmfit,jr=jr,xcenter=xcenter,xcenterbetween=xcenterbetween,tstat=tstat,tdf=tdf,jackest=jackest,jackse=jackse,jackpseudo=jackpseudo,groups=groups,testname=testname)
  class(out) <- "regdistbetween"
  out
}
 
print.regdistbetween <- function(x,...){
  if (identical(x[[1]], NA))
    print("Too few individuals in one group. Regression could not be computed.")
  else{
    cat(x$testname,"\n")
    cat("Groups: ",x$groups[1]," and ",x$groups[2],"\n")
    if (all(is.na(x$pval)))
      cat("p-value could not be computed because of ill-conditioned regressions\n (probably there were too few or too geographically concentrated individuals\n in a species).\n")
    else{
      cat("Approx. p-value: ", x$pval,"\n")
      cat("Difference between coefficients at between groups center (plain): ",x$coefdiff,"\n")
      cat("Difference between coefficients at between groups center (jackknife): ",x$jackest,"\n")
      cat("Standard error of difference (jackknife): ",x$jackse,"\n")
      cat("Welch-Satterthwaite degrees of freedom: ",x$tdf,"\n")
    }
  }
#  cat("Condition numbers of regressions (within-cluster/all): ",x$condition,"\n")
}


# Compute regression from within-cluster distances of one species only
# (species gives number); from
# those and the distances to species 2,
# and compute difference between the two at center of between-cluster
# distances.
# This should vary around 0 under H0 (equality) and se can be estimated.
regdistdiffone <- function(x,dmx,dmy,grouping,xcenter=0,xcenterbetween=0,rgroup){
  clx <- grouping[x]
  groups <- unique(clx)
  dmxx <- dmx[x,x]
  dmyx <- dmy[x,x]  
#  print(x)
#  print(str(dmxx))
#  print(groups)
#  print(grouping)
#  print(clx)
  dmxc <- dmyc <- lmfit <- list()
  dmxc[[1]] <- as.vector(as.dist(dmxx[clx==rgroup,clx==rgroup]))-xcenter
  dmxc[[2]] <- c(dmxc[[1]],as.vector(dmxx[clx==groups[1],clx==groups[2]])-xcenter)
  dmyc[[1]] <- as.vector(as.dist(dmyx[clx==rgroup,clx==rgroup]))
  dmyc[[2]] <- c(dmyc[[1]],as.vector(dmyx[clx==groups[1],clx==groups[2]]))
  for (i in 1:2)
    lmfit[[i]] <- lm(dmyc[[i]]~dmxc[[i]])
#  print(str(lmfit))
  out <- coef(lmfit[[2]])[1]-coef(lmfit[[1]])[1]+(coef(lmfit[[2]])[2]-coef(lmfit[[1]])[2])*xcenterbetween
  out
}


# Tests whether  regression for between-cluster distances
# is compatible with regressions for within-cluster distances
# of a single rgroup (rgroup given number) 
# by calling regdistdiffone and using jackknife
regdistbetweenone <- function(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2],rgroup){
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  grouping <- as.factor(grouping)
  n <- sum(grouping %in% groups)
  n1 <- sum(grouping==rgroup)
  computable <- (n1>2)
  if (computable){
  n2 <- n-n1
#  cld <- as.factor(grouping[x])==groups[1]
  jackse <- jackest <- tstat <- tdf <- numeric(0)
  dmxc <- dmyc <- jr <- lmfit <- list()
  coefdiff <- pval <- condition <- sediff <- numeric(0)
  dmxc[[1]] <- as.vector(as.dist(dmx[grouping==rgroup,grouping==rgroup]))
  xcenter <- mean(dmxc[[1]])
  dmxc[[1]] <- dmxc[[1]]-xcenter
  dmxcbetween <- as.vector(dmx[grouping==groups[1],grouping==groups[2]])-xcenter
  xcenterbetween <- mean(dmxcbetween)
  dmxc[[2]] <- c(dmxc[[1]],dmxcbetween)
  dmyc[[1]] <- as.vector(as.dist(dmy[grouping==rgroup,grouping==rgroup]))
  dmyc[[2]] <- c(dmyc[[1]],as.vector(dmy[grouping==groups[1],grouping==groups[2]]))
  jackpseudo <- numeric(0)
  for (i in 1:2){
    lmfit[[i]] <- lm(dmyc[[i]]~dmxc[[i]])
#    jr[[i]] <- list()
#    nc[i] <- sum(grouping==groups[i])
    mm <- model.matrix(~dmxc[[i]])
    condition[i] <- kappa(mm)
  }
  jr <- bootstrap::jackknife(1:n,regdistdiffone,
                  dmx=dmx[grouping %in% groups, grouping %in% groups],
                  dmy=dmy[grouping %in% groups, grouping %in% groups],
                  grouping=grouping[grouping %in% groups],xcenter=xcenter,
                  xcenterbetween=xcenterbetween,rgroup=rgroup)
  if (is.na(jr$jack.se)) computable <- FALSE
  coefdiff <- (coef(lmfit[[2]])[1]-coef(lmfit[[1]])[1])+(coef(lmfit[[2]])[2]-coef(lmfit[[1]])[2])*xcenterbetween
#  if (computable){
  for (k in 1:n)
    jackpseudo[k] <- n*coefdiff-(n-1)*jr$jack.values[k]
  jackest <- mean(jackpseudo)
  jackvar1 <- var(jackpseudo[grouping[grouping %in% groups]==groups[1]])
  jackvar2 <- var(jackpseudo[grouping[grouping %in% groups]==groups[2]])
  jackvar <- (n1*jackvar1+n2*jackvar2)/(n1+n2)
  jackse <- sqrt(jackvar/n)
  tstat <- jackest/jackse
  # One-sided t-test, df according to Welch-Satterthwaite equation
  tdf <- jackvar^2/((n1*jackvar1/(n1+n2))^2/(n1-1)+(n2*jackvar2/(n1+n2))^2/(n2-1))
  pval <- pt(tstat,tdf,lower.tail=FALSE)
    
#  }
#  else
#      pval <- tstat <- tdf <- jackest <- jackse <- jackpseudo <- jackvar1 <- jackvar2 <- NA

  testname <- paste("Testing whether regression for between-group distances\n is compatible with regressions for within-group distances for species ",rgroup,"\n The maximum Bonferroni p-value over both species can be used to test\n the H0 that the between-group distances are compatible with within-group\n distances of at least one group.")
  out <- list(pval=pval,coefdiff=coefdiff,condition=condition,lmfit=lmfit,jr=jr,xcenter=xcenter,xcenterbetween=xcenterbetween,rgroup=rgroup,tstat=tstat,tdf=tdf,jackest=jackest,jackse=jackse,jackpseudo=jackpseudo,jackvar1=jackvar1,jackvar2=jackvar2,groups=groups,rgroup=rgroup,testname=testname)
  }
  else
    out <- NA
  class(out) <- "regdistbetween"
  out
}


plotdistreg <- function(dmx,dmy,grouping,
                        groups=levels(as.factor(grouping))[1:2],cols=c(1,2,3,4),
                        pchs=rep(1,3),
                        ltys=c(1,2,1,2),
                        individual=TRUE,jointwithin=TRUE,jointall=TRUE,
                        oneplusjoint=TRUE,jittering=TRUE,bcenterline=TRUE,
                        xlim=NULL,ylim=NULL,xlab="geographical distance",
                        ylab="genetic distance",...){
#  if (is.null(groups) & length(levels(as.factor(grouping))==2)){
#    if (is.numeric(grouping))
#      groups <- range(grouping)
#    else
#      groups <- levels(grouping)
  #  }
  grouping <- as.factor(grouping)
  dmx <- as.matrix(dmx)
  dmy <- as.matrix(dmy)
  selector <- grouping %in% groups
  selclust <- grouping[selector]
  ci <- list()
  ci[[1]] <- grouping==groups[1]
  ci[[2]] <- grouping==groups[2]
  betweencenter <- mean(dmx[ci[[1]],ci[[2]]])
  if (is.null(xlim))
    xlim=c(min(as.dist(dmx[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]])),max(as.dist(dmx[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]])))
  if (is.null(ylim))
    ylim=c(min(as.dist(dmy[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]])),max(as.dist(dmy[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]])))  
  if (jittering){
    plot(jitter(as.dist(dmx[ci[[1]],ci[[1]]])),
         jitter(as.dist(dmy[ci[[1]],ci[[1]]])),
         col=cols[1],pch=pchs[1],xlim=xlim,ylim=ylim,xlab=xlab,ylab=ylab,...)
    points(jitter(as.dist(dmx[ci[[2]],ci[[2]]])),
         jitter(as.dist(dmy[ci[[2]],ci[[2]]])),
         col=cols[2],pch=pchs[2])
    points(jitter(as.vector(dmx[ci[[1]],ci[[2]]])),
         jitter(as.vector(dmy[ci[[1]],ci[[2]]])),
         col=cols[3],pch=pchs[3])
  }
  else{
    plot(as.dist(dmx[ci[[1]],ci[[1]]]),
         as.dist(dmy[ci[[1]],ci[[1]]]),
         col=cols[1],pch=pchs[1],xlim=xlim,ylim=ylim,xlab=xlab,ylab=ylab,...)
    points(as.dist(dmx[ci[[2]],ci[[2]]]),
         as.dist(dmy[ci[[2]],ci[[2]]]),
         col=cols[2],pch=pchs[2])
    points(as.vector(dmx[ci[[1]],ci[[2]]]),
         as.vector(dmy[ci[[1]],ci[[2]]]),
         col=cols[3],pch=pchs[3])
  }    
  if(individual){
      lind <- list()
      for (i in 1:2){
        lind[[i]] <- lm(as.dist(dmy[ci[[i]],ci[[i]]])~as.dist(dmx[ci[[i]],ci[[i]]]))
        abline(coef(lind[[i]]),col=cols[i],lty=ltys[1])
      }
  }
  if (bcenterline)
    lines(c(betweencenter,betweencenter),c(-1,1.5*max(ylim)),col=cols[4])
  if (jointwithin){
      lmjw <- lm(c(as.dist(dmy[ci[[1]],ci[[1]]]),as.dist(dmy[ci[[2]],ci[[2]]]))~c(as.dist(dmx[ci[[1]],ci[[1]]]),as.dist(dmx[ci[[2]],ci[[2]]])))
      abline(coef(lmjw),col=cols[3],lty=ltys[2])
  }
  if (jointall){
    lmall <- lm(as.dist(dmy[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]])~as.dist(dmx[ci[[1]]|ci[[2]],ci[[1]]|ci[[2]]]))
    abline(coef(lmall),col=cols[3],lty=ltys[3])
  }
  if(oneplusjoint){
      lop <- list()
      for (i in 1:2){
        lop[[i]] <- lm(c(as.dist(dmy[ci[[i]],ci[[i]]]),as.vector(dmy[ci[[1]],ci[[2]]]))~c(as.dist(dmx[ci[[i]],ci[[i]]]),as.vector(dmx[ci[[1]],ci[[2]]])))
        abline(coef(lop[[i]]),col=cols[i],lty=ltys[4])
      }
  }
}
    
    
alleleconvert <- function (file = NULL, strmatrix = NULL, format.in = "genepop", 
    format.out = "prabclus", alength = 3, orig.nachar = "000", 
    new.nachar = "-", rows.are.individuals = TRUE, firstcolname = FALSE, 
    aletters = intToUtf8(c(65:90, 97:122), multiple = TRUE), 
    outfile = NULL, skip=0) 
{
    if (is.null(file)) 
        m1 <- strmatrix
    else m1 <- read.table(file, colClasses = "character", skip=skip)
    if (firstcolname) {
        if (format.in == "structure") 
            colnamesv <- m1[seq(1, nrow(m1) - 1, by = 2), 1]
        if (format.in %in% c("genepop","structureb")) 
            colnamesv <- m1[, 1]
        if (format.in == "structureb")
          m1 <- m1[, 3:ncol(m1)]
        else
          m1 <- m1[, 2:ncol(m1)] 
    }
    if (!rows.are.individuals) 
        m1 <- t(m1)
    if (format.in == "genepop") {
        n.individuals <- nrow(m1)
        n.variables <- ncol(m1)
    }
    if (format.in == "structure") {
        n.individuals <- nrow(m1)/2
        n.variables <- ncol(m1)
    }
    if (format.in == "structureb") {
        n.individuals <- nrow(m1)
        n.variables <- ncol(m1)/2
    }
    first.allele <- second.allele <- outmatrix <- matrix("", 
        ncol = n.variables, nrow = n.individuals)
    double.out <- matrix("", ncol = n.variables, nrow = 2 * n.individuals)
    if (format.in == "genepop") {
        for (i in 1:n.individuals) for (j in 1:n.variables) {
            first.allele[i, j] <- substring(m1[i, j], 1, alength)
            second.allele[i, j] <- substring(m1[i, j], alength + 
                1, 2 * alength)
        }
    }
    if (format.in == "structure") {
        for (i in 1:n.individuals) for (j in 1:n.variables) {
            first.allele[i, j] <- m1[2 * i - 1, j]
            second.allele[i, j] <- m1[2 * i, j]
        }
    }
    if (format.in == "structureb") {
        for (i in 1:n.individuals) for (j in 1:n.variables) {
            first.allele[i, j] <- m1[i, 2*j-1]
            second.allele[i, j] <- m1[i, 2*j]
        }
    }
    double.allele <- rbind(first.allele, second.allele)
    maxk <- 0
    for (j in 1:n.variables) {
        jlevels <- levels(as.factor(double.allele[, j]))
        jlevels <- jlevels[jlevels != orig.nachar]
        if (length(jlevels) > maxk) 
            maxk <- length(jlevels)
        double.out[double.allele[, j] == orig.nachar, j] <- new.nachar
        if (format.out == "prabclus") {
            for (k in 1:length(jlevels)) double.out[double.allele[, 
                j] == jlevels[k], j] <- aletters[k]
            outmatrix[, j] <- mapply(paste, double.out[1:n.individuals, 
                j], double.out[(n.individuals + 1):(2 * n.individuals), 
                j], sep = "")
            out <- structure(outmatrix, alevels = aletters[1:maxk])
        }
        if (format.out == "structurama") {
            for (k in 1:length(jlevels)) double.out[double.allele[, 
                j] == jlevels[k], j] <- jlevels[k]
            outmatrix[, j] <- mapply(paste, "(", double.out[1:n.individuals, 
                j], ",", double.out[(n.individuals + 1):(2 * 
                n.individuals), j], ")", sep = "")
            out <- structure(outmatrix, alevels = jlevels)
        }
    }
    if (!is.null(outfile)) {
        if (firstcolname) 
            outmatrix <- cbind(colnamesv, outmatrix)
        write.table(outmatrix, outfile, quote = FALSE, col.names = FALSE)
    }
    out
}
  
    
    
    
         

# Reorders components of clustsummary
prabclust <- function (prabobj, mdsmethod = "classical", mdsdim = 4,
                       nnk = ceiling(prabobj$n.species/40), 
    nclus = 0:9, modelid = "all", permutations = 0) 
{
#    require(MASS)
#    require(mclust)
    oregions <- order(prabobj$specperreg)
    prabo1 <- prabobj$prab[oregions, ]
    ospecies <- do.call("order", as.data.frame(t(prabo1)))
    dm <- prabobj$distmat[ospecies, ospecies]
    if (mdsmethod != "classical") {
        mindm <- min(dm[dm > 0])/10
        for (i in 1:(prabobj$n.species - 1)) for (j in (i + 1):prabobj$n.species) if (dm[i, 
            j] < mindm) 
            dm[i, j] <- dm[j, i] <- mindm
    }
#    print(dm)
#    print(mdsdim)
    mdsbest <- mdsout <- switch(mdsmethod, classical = cmdscale(dm, 
        k = mdsdim), kruskal = isoMDS(dm, k = mdsdim), sammon = sammon(dm, 
        k = mdsdim))
    if (mdsmethod == "classical") 
        mds <- mdsout
    else mds <- mdsout$points
    permchange = FALSE
    operm <- NULL
    if (permutations > 0) {
        if (mdsmethod != "classical") {
            for (i in 1:permutations) {
                inumbers <- sample(1:prabobj$n.species, prabobj$n.species)
                dmperm <- dm[inumbers, inumbers]
                mdsout <- switch(mdsmethod, kruskal = isoMDS(dmperm, 
                  k = mdsdim), sammon = sammon(dm, k = mdsdim))
                if (mdsout$stress < mdsbest$stress) {
                  mdsbest <- mdsout
                  operm <- inumbers
                  permchange <- TRUE
                }
            }
            mdsout <- mdsbest
            if (!is.null(operm)) {
                mdsout$points[operm, ] <- mdsbest$points
                mds <- mdsout$points
            }
            operm <- NULL
        }
    }
    if (nnk == 0) {
        if (0 == nclus[1]) 
            nclus <- nclus[-1]
        if (identical(modelid,"all")) 
            kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
                "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
                "VEV", "VVV"))
        else {
            if (identical(modelid,"noVVV")) 
                kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
                  "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
                  "VEV"))
            else kem <- mclustBIC(mds, G = nclus, modelNames = modelid)
        }
    }
    else {
        kn <- NNclean(mds, k = nnk)
        if (identical(modelid,"all")) 
            kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
                "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
                "VEV", "VVV"), initialization = list(noise = as.logical(1 - 
                kn$z)))
        else {
            if (identical(modelid,"noVVV")) 
                kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
                  "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
                  "VEV"), initialization = list(noise = as.logical(1 - 
                  kn$z)))
            else kem <- mclustBIC(mds, G = nclus, modelNames = modelid, 
                initialization = list(noise = as.logical(1 - 
                  kn$z)))
        }
    }
    skembest <- skem <- summary(kem, mds)
    if (permutations > 0) {
        for (i in 1:permutations) {
            inumbers <- sample(1:prabobj$n.species, prabobj$n.species)
            mdsperm <- mds[inumbers, ]
            if (nnk == 0) {
                if (0 == nclus[1]) 
                  nclus <- nclus[-1]
                if (identical(modelid,"all")) 
                  kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
                    "VII", "EEI", "VEI", "EVI", "VVI", "EEE", 
                    "EEV", "VEV", "VVV"))
                else {
                  if (identical(modelid,"noVVV")) 
                    kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
                      "VII", "EEI", "VEI", "EVI", "VVI", "EEE", 
                      "EEV", "VEV"))
                  else kem <- mclustBIC(mdsperm, G = nclus, modelNames = modelid)
                }
            }
            else {
                kn <- NNclean(mdsperm, k = nnk)
                if (identical(modelid,"all")) 
                  kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
                    "VII", "EEI", "VEI", "EVI", "VVI", "EEE", 
                    "EEV", "VEV", "VVV"), initialization = list(noise = as.logical(1 - 
                    kn$z)))
                else {
                  if (identical(modelid,"noVVV")) 
                    kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
                      "VII", "EEI", "VEI", "EVI", "VVI", "EEE", 
                      "EEV", "VEV"), initialization = list(noise = as.logical(1 - 
                      kn$z)))
                  else kem <- mclustBIC(mdsperm, G = nclus, modelNames = modelid, 
                    initialization = list(noise = as.logical(1 - 
                      kn$z)))
                }
            }
            skem <- summary(kem, mdsperm)
            if (skem$bic > skembest$bic) {
                skembest <- skem
                operm <- inumbers
                permchange <- TRUE
            }
        }
    }
    skem <- skembest
    if (!is.null(operm)) {
        skem$classification[operm] <- skembest$classification
        skem$z[operm, ] <- skembest$z
        if (!is.null(attr(skembest, "initialization")$noise)){
          snoisevector <- (1:prabobj$n.species) %in% attr(skem, "initialization")$noise
          sbnoisevector <- (1:prabobj$n.species) %in% attr(skembest, "initialization")$noise
          snoisevector[operm] <- sbnoisevector
          attr(skem, "initialization")$noise <- (1:prabobj$n.species)[snoisevector]
        }
        skembest <- skem
    }
    mdsr <- mds
    mds[ospecies, ] <- mdsr
    skem$classification[ospecies] <- skembest$classification
    skem$z[ospecies, ] <- skembest$z
    if (!is.null(attr(skembest, "initialization")$noise)){
      snoisevector <- (1:prabobj$n.species) %in% attr(skem, "initialization")$noise
      sbnoisevector <- (1:prabobj$n.species) %in% attr(skembest, "initialization")$noise
      snoisevector[ospecies] <- sbnoisevector
      attr(skem, "initialization")$noise <- (1:prabobj$n.species)[snoisevector]
    }
    uclustering <- skem$classification
    ncl <- max(uclustering)
    nc <- ncl + 1
    noisec <- min(uclustering) == 0
    clustering <- uclustering
    csum <- function(n, cv) {
        out <- c()
        for (i in 1:length(n)) out[i] <- sum(cv == n[i])
        out
    }
    cs <- csum(1:ncl, clustering)
    ocs <- order(-cs)
    prob <- skem$parameters$pro
    pmean <-  skem$parameters$mean
    psigma <- skem$parameters$variance$sigma
    pcsigma <- skem$parameters$variance$cholsigma
    pscale <- skem$parameters$variance$scale
    pshape <- skem$parameters$variance$shape
    pz <- skem$z
#    print(prob)
#    print(pmean)
#    print(psigma)
#    print(pcsigma)
#    print(pscale)
#    print(pshape)
#    print(skem)
    for (i in 1:ncl){
      clustering[uclustering == ocs[i]] <- i
      skem$classification <-  clustering
      skem$parameters$pro[i] <- prob[ocs[i]]
      skem$parameters$mean[,i] <- pmean[,ocs[i]]
      skem$parameters$variance$sigma[,,i] <- psigma[,,ocs[i]]
      skem$parameters$variance$cholsigma[,,i] <- pcsigma[,,ocs[i]]
      if (length(skem$parameters$variance$scale)>1)
        skem$parameters$variance$scale[i] <- pscale[ocs[i]]
      if (is.matrix(skem$parameters$variance$shape))
        skem$parameters$variance$shape[,i] <- pshape[,ocs[i]]
      skem$z[,i] <- pz[,ocs[i]]
    }
    if (noisec & nc == 1) 
        clsym <- rep("N", prabobj$n.species)
    else {
        if (noisec) {
            symbols <- c("N", sapply(1:ncl, toString))
            clsym <- symbols[clustering + 1]
        }
        else {
            symbols <- sapply(1:ncl, toString)
            clsym <- symbols[clustering]
        }
    }
    for (i in 1:ncl) if (sum(clustering == i) < 2) 
        clsym[clustering == i] <- "N"
    plot(mds, pch = clsym)
    out <- list(clustering = clustering, clustsummary = skem, 
        bicsummary = kem, points = mds, nnk = nnk, mdsdim = mdsdim, 
        mdsmethod = mdsmethod, symbols = clsym, permutations = permutations, 
        permchange = permchange)
    class(out) <- "prabclust"
    out
}

# "prabclust" <- function (prabobj, mdsmethod = "classical", mdsdim = 4,
#                        nnk = ceiling(prabobj$n.species/40), 
#     nclus = 0:9, modelid = "all", permutations=0) 
# {
#     require(MASS)
#     require(mclust)
#     # "Data-alphabetical" ordering 
#     oregions <- order(prabobj$specperreg)
#     prabo1 <- prabobj$prab[oregions,]
#     ospecies <- do.call("order",as.data.frame(t(prabo1)))    
#     dm <- prabobj$distmat[ospecies,ospecies]
#     if (mdsmethod != "classical") {
#         mindm <- min(dm[dm > 0])/10
#         for (i in 1:(prabobj$n.species - 1))
#           for (j in (i + 1):prabobj$n.species) if (dm[i, j] < mindm) 
#             dm[i, j] <- dm[j, i] <- mindm
#     }
#     mdsbest <- mdsout <-
#       switch(mdsmethod, classical = cmdscale(dm, k = mdsdim), 
#         kruskal = isoMDS(dm, k = mdsdim), sammon = sammon(dm, 
#             k = mdsdim))
#     if (mdsmethod=="classical") mds <- mdsout
#     else mds <- mdsout$points
#     permchange=FALSE
#     operm <- NULL
#     if (permutations>0){
#       if (mdsmethod!="classical"){
#         for (i in 1:permutations){
#           inumbers <- sample(1:prabobj$n.species,prabobj$n.species)
#           dmperm <- dm[inumbers,inumbers]
#           mdsout <- switch(mdsmethod,  
#             kruskal = isoMDS(dmperm, k = mdsdim),
#                         sammon = sammon(dm, k = mdsdim))
#           if (mdsout$stress<mdsbest$stress){
#             mdsbest <- mdsout
#             operm <- inumbers
#             permchange <- TRUE
#           } # if mds$stress<beststress
#         } # for i
#         mdsout <- mdsbest
#         if (!is.null(operm)){
#           mdsout$points[operm,] <- mdsbest$points
#           mds <- mdsout$points
#         }
#         operm <- NULL
#       } # if mdsmethod!="classical"
#     } # if permutations>0  
#     if (nnk==0){
#       if (0==nclus[1])
#         nclus <- nclus[-1]
#       if (modelid == "all") 
#         kem <- mclustBIC(mds, G = nclus, modelNames=c("EII", 
#                 "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                 "VEV","VVV"))
#       else {
#         if (modelid == "noVVV") 
#             kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
#                 "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                 "VEV"))
#         else kem <- mclustBIC(mds, G = nclus, modelNames = modelid)
#       }
#     }
#     else{  
#       kn <- NNclean(mds, k = nnk)
#       if (modelid == "all") 
#         kem <- mclustBIC(mds, G = nclus, modelNames=c("EII", 
#                 "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                 "VEV","VVV"),
#                          initialization=list(noise = as.logical(1 - kn$z)))
#       else {
#         if (modelid == "noVVV") 
#             kem <- mclustBIC(mds, G = nclus, modelNames = c("EII", 
#                 "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                 "VEV"), initialization=list(noise = as.logical(1 - kn$z)))
#         else kem <- mclustBIC(mds, G = nclus, modelNames = modelid, 
#             initialization=list(noise =as.logical( 1 - kn$z)))
#       }
#     }
#     skembest <- skem <- summary(kem, mds)
#     if (permutations>0){
#       for (i in 1:permutations){
#         inumbers <- sample(1:prabobj$n.species,prabobj$n.species)
#         mdsperm <- mds[inumbers,]
#         if (nnk==0){
#           if (0==nclus[1])
#             nclus <- nclus[-1]
#           if (modelid == "all") 
#             kem <- mclustBIC(mdsperm, G = nclus, modelNames=c("EII", 
#                 "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                 "VEV","VVV"))
#           else {
#             if (modelid == "noVVV") 
#                 kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
#                     "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                     "VEV"))
#             else kem <- mclustBIC(mdsperm, G = nclus, modelNames = modelid)
#           } # else (modelid!="all")
#         } # if nnk==0
#         else{  
#           kn <- NNclean(mdsperm, k = nnk)
#           if (modelid == "all") 
#             kem <- mclustBIC(mdsperm, G = nclus, modelNames=c("EII", 
#                     "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                     "VEV","VVV"),initialization=
#                              list(noise = as.logical(1 - kn$z)))
#           else {
#             if (modelid == "noVVV") 
#               kem <- mclustBIC(mdsperm, G = nclus, modelNames = c("EII", 
#                     "VII", "EEI", "VEI", "EVI", "VVI", "EEE", "EEV", 
#                     "VEV"), initialization=list(noise = as.logical(1 - kn$z)))
#             else kem <- mclustBIC(mdsperm, G = nclus, modelNames = modelid, 
#                 initialization=list(noise =as.logical(1 - kn$z)))
#           } # else - modelid!="all"
#         } # else - nnk>0
#         skem <- summary(kem, mdsperm)
#         if (skem$bic>skembest$bic){
#           skembest <- skem
#           operm <- inumbers
#           permchange <- TRUE
#         }
#       } # for i
#     } # if permutations>0    
#     skem <- skembest
#     if (!is.null(operm)){
#       skem$classification[operm] <- skembest$classification
#       skem$z[operm,] <- skembest$z
#       if (!is.null(attr(skembest,"initialization")$noise))
#         attr(skem,"initialization")$noise[operm] <-
#           attr(skembest,"initialization")$noise
#       skembest <- skem
#     }
#     mdsr <- mds
#     mds[ospecies,] <- mdsr
#     skem$classification[ospecies] <- skembest$classification
#     skem$z[ospecies,] <- skembest$z
#     if (!is.null(attr(skembest,"initialization")$noise))
#       attr(skem,"initialization")$noise[ospecies] <-
#         attr(skembest,"initialization")$noise
#     uclustering <- skem$classification
#     ncl <- max(uclustering)
#     nc <- ncl+1
#     noisec <- min(uclustering)==0
#     clustering <- uclustering
#     csum <- function(n, cv) {
#         out <- c()
#         for (i in 1:length(n)) out[i] <- sum(cv == n[i])
#         out
#     }
# #    print(skem$z)
# #    str(skem)
# #    print(ncl)
# #    print(nc)
#     cs <- csum(1:ncl, clustering)
#     ocs <- order(-cs)
#     for (i in 1:ncl) clustering[uclustering == ocs[i]] <- i
#     clusyms <- sapply(1:9,toString)
#     if (ncl>9)
#       clusyms <- c(clusyms, intToUtf8(97:(97+ncl-10),multiple=TRUE)) 
#     if (noisec & nc == 1)
#       clsym <- rep("N",prabobj$n.species)
#     else {
#       if (noisec){ 
#          symbols <- c("N",clusyms)
#          clsym <- symbols[clustering+1]
#        }
#        else{
#          symbols <- clusyms
#          clsym <- symbols[clustering]
#        }
#     }
#     for (i in 1:ncl) if (sum(clustering == i) < 2) 
#         clsym[clustering == i] <- "N"
#     plot(mds, pch = clsym)
#     out <- list(clustering = clustering, clustsummary = skem, 
#         bicsummary = kem, points = mds, nnk = nnk, mdsdim = mdsdim, 
#         mdsmethod = mdsmethod, symbols = clsym, permutations=permutations,
#                 permchange=permchange, csreorder=ocs)
#     class(out) <- "prabclust"
#     out
# }

#   \item{csreorder}{integer vector. This gives the numbering of the
#     components in \code{clustsummary} relative to
#     \code{clustering}. Usually, \code{clustering} and \code{symbols}
#     will be used, but in order to use the information in
#     \code{clustsummary} (parameter values, posterior assignment
#     probabilities etc.), it has to be taken into account that cluster
#     no. 1 in \code{clustering} corresponds to cluster
#     no. \code{csreorder[1]} in \code{clustsummary} and so on. Noise, if
#     present, is numbered 0 in \code{clustering} as well as
#     \code{clustsummary}.}

piecewiselin <- function(distmatrix, maxdist=0.1*max(distmatrix)){
  ncd <- ncol(distmatrix)
  nmatrix <- distmatrix/maxdist  
  for (i in 1:(ncd-1))
    for (j in (i+1):ncd)
      if (nmatrix[i,j]>1)
        nmatrix[i,j] <- nmatrix[j,i] <- 1
  nmatrix
}
          
# Geographic Kulczynski distance, rows are regions
geco <- function(regmat,
                   geodist=as.dist(matrix(as.integer(!diag(nrow(regmat))))),
                   transform="piece",
                   tf=0.1,
                   countmode=ncol(regmat)+1){
#  print(tf)
  nart <- ncol(regmat)
  ncell <- nrow(regmat)
  jdist <- rep(0, nart * nart)
  dim(jdist) <- c(nart, nart)
  if (transform=="none")
    geodist <- as.matrix(geodist)
  if (transform=="log")
    geodist <- log(as.matrix(tf*geodist)+1)
  if (transform=="sqrt")
    geodist <- sqrt(as.matrix(tf*geodist))
  if (transform=="piece"){
    mg <- max(geodist)
    geodist <- piecewiselin(as.matrix(geodist),tf*mg)
  }
  fi <- list()
  nci <- numeric(0)
  for (i in 1:nart){
    fi[[i]] <- (1:ncell)[as.logical(regmat[,i])]
    nci[[i]] <- sum(regmat[, i])
  }
  for (i in 1:(nart - 1)) {
    if (round(i/countmode)==(i/countmode))
      cat("Computing gb-distances for  species ",i,"\n")
    for (j in (i + 1):nart) {
      nsi <- numeric(0)
      gfi <- geodist[fi[[i]],fi[[j]],drop=FALSE]
#      print(gfi)
      nsi[1] <- sum(apply(gfi,1,min))
      nsi[2] <- sum(apply(gfi,2,min))
      jdist[i,j] <- jdist[j,i] <- (nsi[1]/nci[i]+nsi[2]/nci[j])/2
      if (is.na(jdist[i, j])) 
        cat("Warning! NA at i=", i, ", j=", j, "\n")
    }
  }
  jdist
}

geo2neighbor <- function(geodist,cut=0.1*max(geodist)){
  geodist <- as.matrix(geodist)
  n <- nrow(geodist)
  nblist <- list()
  for (i in 1:n) nblist[[i]] <- numeric(0)
  for (i in 1:(n-1))
    for(j in (i+1):n)
      if (geodist[i,j]<=cut){
        nblist[[i]] <- c(nblist[[i]],j)
        nblist[[j]] <- c(nblist[[j]],i)
      }
  nblist
}
        

hprabclust <- function (prabobj, cutdist=0.4, cutout=1,
                        method="average", nnout=2, mdsplot=TRUE,
                        mdsmethod="classical") 
{
    cf <- match.call()
#    if (mdsplot & mdsmethod!="classical")
#      require(MASS)
    # "Data-alphabetical" ordering 
    oregions <- order(prabobj$specperreg)
    prabo1 <- prabobj$prab[oregions,]
    ospecies <- do.call("order",as.data.frame(t(prabo1)))    
    dma <- prabobj$distmat[ospecies,ospecies]
    if (mdsplot){
      mdsdim=2
      if (mdsmethod != "classical") {
          mindm <- min(dma[dma > 0])/10
          for (i in 1:(prabobj$n.species - 1))
            for (j in (i + 1):prabobj$n.species) if (dma[i, j] < mindm) 
              dma[i, j] <- dma[j, i] <- mindm
      }
      mdsout <-
        switch(mdsmethod, classical = cmdscale(dma, k = mdsdim), 
        kruskal = isoMDS(dma, k = mdsdim), sammon = sammon(dma, 
            k = mdsdim))
      if (mdsmethod=="classical") mds <- mdsout
      else mds <- mdsout$points
    }
    else mds <- NULL
    n <- prabobj$n.species
    nnd <- c()
    nout <- rep(TRUE,n)
    for (i in 1:n){
      nnd[i] <- sort(dma[i, ])[nnout + 1]
      if (nnd[i]>cutout) nout[i] <- FALSE
    }
    noisen <- n-sum(nout)
    dm <- as.dist(dma[nout,nout])
    cl1 <- hclust(dm, method=method)
    rclustering <- cl2 <- cutree(cl1, h=cutdist)
    nc <- max(cl2)
#    nout[ospecies] <- nout
#    ncl <- max(cl2)
    csum <- function(nx, cv) {
        out <- c()
        for (i in 1:length(nx)) out[i] <- sum(cv == nx[i])
        out
    }
    cs <- csum(1:nc, cl2)
    ocs <- order(-cs)
    for (i in 1:nc) cl2[rclustering == ocs[i]] <- i
    clustering <- rep(0,n)
    clustering[ospecies][nout] <- cl2
    nmr <- max((1:nc)[cs[ocs]>nnout])
#    print(cs[ocs])
#    print(nmr)
    rclustering <- rep(0,n)
    rclustering[clustering<=nmr] <- clustering[clustering<=nmr]
    symbols <- c("N")
    if (nmr>0) symbols <- c("N", sapply(1:nmr, toString))
    clsym <- symbols[rclustering+1]
    if (mdsplot){
      mds[ospecies,] <- mds
      plot(mds[,1:2],pch=clsym)
    }
    out <- list(clustering = clustering, rclustering=rclustering,
                cutdist=cutdist, method=method,
                cutout=cutout,nnout=nnout,noisen=noisen,
                symbols = clsym, points=mds, call=cf)
    class(out) <- "comprabclust"
    out
}

"print.comprabclust" <-
function(x, ...){
  cat("* Clustered presence-absence matrix * \n\n")
  cat("Clustered by hclust with noise detection, method=: ", x$method, "\n\n")
  cat("Distance value to cut tree:", x$cutdist,"\n")
  cat("Minimum cluster size (below is noise):", x$nnout+1,"\n")
  cat("Call: \n")
  print(x$call)
  cat("\n Cluster memberships:\n")
  print(x$rclustering)
  cat("\n")
}

"lcomponent" <-
function(distmat, ne=floor(3*ncol(distmat)/4)){
  nc <- ncol(distmat)
  vdist <- distmat[upper.tri(distmat)]
  sdist <- sort(vdist)
  distcut <- sdist[ne]
  cm <- (distmat<=distcut)  
  ccn <- con.comp(cm)
  stn <- max(ccn)
  pn <- vector(length=stn)
  for (i in 1:stn)
    pn[i] <- sum(ccn==i)
  lc <- max(pn)
  out <- list(lc=lc,ne=ne)
  out
}

"homogen.test" <-
function(distmat,ne=ncol(distmat),testdist="erdos"){
  nc <- ncol(distmat)
  vdist <- distmat[upper.tri(distmat)]
  sdist <- sort(vdist)
  distcut <- sdist[ne]
  iv <- nc
  for (i in 1:nc)
    iv <- iv - (min(distmat[-i,i])<=distcut)
  if(testdist=="erdos"){
    lambda <- exp(-2*ne/(nc-1) + log(nc))
    p <- 1-ppois(iv-1,lambda)
    if (iv>=lambda)
      psymm <- 2*pnorm((lambda-iv)/sqrt(lambda))
    else
      psymm <- 2*pnorm((iv-lambda)/sqrt(lambda))
    out <- list(p=p, p.twoside=psymm, iv=iv, lambda=lambda, distcut=distcut, ne=ne)
  } 
  if(testdist=="ling"){
    print("Computation of Ling-probabilities...")
    prob <- rep(0,ne*(nc-iv))
    dim(prob) <- c(ne,(nc-iv))
#    prob <- rep(0,ne*nc)
#    dim(prob) <- c(ne,nc)
    prob[1,2] <- 1
    n2 <- choose(nc,2)
    for (i in 2:ne)
      for(j in 3:(nc-iv))
#      for(j in 3:nc)
        prob[i,j] <- (choose(nc-j+2,2)*prob[i-1,j-2]+
          (j-1)*(nc-j+1)*prob[i-1,j-1]+(choose(j,2)-(i-1))*prob[i-1,j])/
          (n2-(i-1))
#    cat(prob)
    p2 <- p <- 0
    for(j in 2:(nc-iv))
      p <- p+prob[ne,j]
    print("finished.")
    out <- list(p=p, iv=iv, distcut=distcut, ne=ne)
  }
  out
}

# Produces a matrix with clusters as rows and regions as columns,
# indicating how many species of a region belong to the clusters
#
# x: prab object as generated by prabinit
# xc: prabclust object as produced by prabclust
crmatrix <- function(x,xc,percentages=FALSE){
  onoise <- 0 %in% xc$clustering
  ofac <- levels(as.factor(xc$clustering))
  ol <- length(ofac)
  snoise <- "N" %in% xc$symbols
  sfac <- levels(as.factor(xc$symbols))
  sl <- length(sfac)
  
  cln <- sl-as.integer(snoise)
  
  clu <- xc$clustering
  if (onoise){
    if (ol!=sl)
      clu[xc$clustering>cln] <- 0
  }
  if (!onoise){
    if (snoise)
      clu[xc$clustering>cln] <- 0
  }
  
  clu[clu==0] <- cln+1

  cin <- rep(1,sl)
  if (percentages)
    for (i in 1:sl)
      cin[i] <- sum(clu==i) 
  cmatrix <- matrix(0,nrow=sl,ncol=x$n.regions)
  for (i in 1:sl)
    for (j in 1:x$n.regions)
      cmatrix[i,j] <- sum(x$prab[j,clu==i])/cin[i]
  cmatrix
}

"print.prab" <-
function(x, ...){
  cat("Presence-absence matrix object with\n")
  cat(x$n.species," species and ",x$n.regions," regions,\n")
  cat("including ")
  nbind <- FALSE
  for (i in 1:length(x$nb)) if (!identical(x$nb[[i]],numeric(0))) nbind <- TRUE
  if (nbind & x$nbbetweenregions) cat("regions neighborhoods and \n")
  else{
    if (nbind & !x$nbbetweenregions)
      cat("species/individuals neighborhoods and \n")
    else
      cat("\n")
  }
  cat("between-species distance matrix of type ",x$distance,".\n")
}

"distratio" <-
function(distmat, prop=0.25){
  nc <- ncol(distmat)
  net <- as.integer(nc*(nc-1)/2)
  if (prop==(-1))
    prop <- 0.25
  vdist <- distmat[upper.tri(distmat)]
# cat("length=",length(vdist)," net=",net,"\n")
  sdist <- sort(vdist)
  lo <- floor(prop*net)
  hi <- ceiling((1-prop)*net)+1
# cat("lo=", lo, " hi=",hi,"\n")
  los <- sum(sdist[1:lo])
  his <- sum(sdist[hi:net])
  lowmean <- los/lo
  himean <- his/(net+1-hi)
  dr <- lowmean/himean
  out <- list(dr=dr,lowmean=lowmean,himean=himean,prop=prop)
  out
}

"autoreg" <-
function(x, probs, ejprob, plot=TRUE, nperp=4, species.fixed=TRUE, pdfnb=FALSE){
  tjumps <- matrix(nrow=nperp*length(probs),ncol=3)
  for (j in 1:length(probs)){
    cat("    Estimating disj. parameter: Simulations for p= ",probs[j],"\n")
    for (i in 1:nperp){
#      print(x$n.species)
#      print(x$specperreg)
#      print(sum(x$specperreg))
      test <- randpop.nb(x$nb,p.nb=probs[j], n.species=x$n.species,
                         vector.species=x$regperspec,
                         species.fixed=species.fixed,
                         pdf.regions=x$specperreg/sum(x$specperreg),
                         count=FALSE, pdfnb=pdfnb)
#      print("Test generated")
#      print(test)
#      print(dim(test))
#      print(x$regperspec)
      nst <- apply(test,2,sum)
#      print(nst)
#      print(apply(test,1,sum) - x$specperreg)
      tcn <- con.regmat(test,x$nb,count=FALSE)
#      print("tcn computed")
      ind <- (j-1)*nperp+i
      tjumps[ind,1] <- probs[j]
      tjumps[ind,2] <- sum(tcn-1)
#      print(tjumps[ind,2])
      tjumps[ind,3] <- tjumps[ind,2]/sum(nst-1)
    }
  }
  ejlm <- lm(tjumps[,3]~tjumps[,1])
  if (plot){
    plot(tjumps[,1],tjumps[,3],xlab="pdisj",
         ylab="qdisj")
#    print(tjumps[,1])
#    print(tjumps[,3])
    abline(ejlm$coef)
    abline(c(ejprob,0), lty=2)
  }
  pd <- (ejprob-ejlm$coef[1])/ejlm$coef[2]
  cat("  Estimated disjunction parameter =",pd,"\n")
  out <- list(pd=pd, coef=ejlm$coef)
  out
}

"incmatrix" <-
function(regmat){
  nart <- ncol(regmat)
  nreg <- nrow(regmat)
  neq <- 0
  incmat <- matrix(0,ncol=nart,nrow=nart)
  for (i in 1:(nart-1))
    for (j in (i+1):nart){
#      cat (i," ",j," ",sum(regmat[,i]<regmat[,j]),sum(regmat[,j]<regmat[,i]),"\n")
      if (sum(regmat[,i]<regmat[,j])==0)
        incmat[i,j] <- 1
      if (sum(regmat[,j]<regmat[,i])==0)
        incmat[j,i] <- 1
      if (identical(regmat[,i],regmat[,j]))
#        incmat[i,j] <- 0
        neq <- neq+1
    }
  out <- list(m=incmat, ninc=sum(incmat), neq=neq)
  out
}

con.regmat <- function (regmat, neighbors, count = FALSE) 
{
    nart <- ncol(regmat)
    nreg <- nrow(regmat)
    out <- c()
    for (i in 1:nart) {
        nspec <- sum(regmat[, i])
        if (nspec>0){
          if (count) 
            cat("Species ", i, " size ", nspec, "\n")
          regions <- (1:nreg)[as.logical(regmat[, i])]
          comat <- matrix(FALSE, ncol = nspec, nrow = nspec)
          for (j in 1:nspec)
            for (k in neighbors[[regions[j]]])
              comat[j, (1:nspec)[regions == k]] <- TRUE
          out[i] <- max(con.comp(comat))
        }
        else
          out[i] <- NA
    }
    out
}

# Includes ignore.richness-parameter
# dist="dice": dice distance
prabtest <- function (prabobject, teststat = "distratio", tuning = switch(teststat, 
    distratio = 0.25, lcomponent = floor(3 * ncol(prabobject$distmat)/4), 
    isovertice = ncol(prabobject$distmat), nn = 4, NA), times = 1000, 
    pd = NULL, prange = c(0, 1), nperp = 4, step = 0.1, step2=0.01,
                      twostep = TRUE, 
    sf.sim = FALSE, sf.const = sf.sim, pdfnb = FALSE, ignore.richness=FALSE) 
{
    if (is.null(pd) & prabobject$spatial) 
        ac <- autoconst(prabobject, twostep = twostep, prange = prange, 
            nperp = nperp, step1 = step, step2=step2, species.fixed = sf.const,
                        ignore.richness=ignore.richness)
    else {
        if (is.null(pd)) 
            pd <- 1
        ac <- list(pd = pd, coef = NA)
    }
    psim <- pop.sim(prabobject$prab, prabobject$nb, teststat = teststat, h0c = ac$pd, 
        dist = prabobject$distance, times = times, geodist = prabobject$geodist, gtf = prabobject$gtf,
                    testc = tuning, n.species = prabobject$n.species, 
        specperreg = prabobject$specperreg, regperspec = prabobject$regperspec, 
        species.fixed = sf.sim, pdfnb = pdfnb, ignore.richness=ignore.richness)
    out <- list(results = psim$results, datac = psim$datac, p.value = ifelse(teststat == 
        "inclusions", psim$p.above, psim$p.below), tuning = tuning, 
        pd = ac$pd, reg = ac$coef, teststat = teststat, distance = prabobject$distance, 
        times = times, pdfnb = pdfnb, ignore.richness=ignore.richness)
    class(out) <- "prabtest"
    out
}

"summary.prabtest" <-
function(object, above.p=object$teststat %in% c("groups","inclusions","mean"),
         group.outmean=FALSE,...){
  if (object$teststat!="groups"){
    rrange <- range(object$results)
    rmean <- mean(object$results)
    groupinfo <- NULL
  }
  else{
    rrange <- range(object$results$overall)
    rmean <- mean(object$results$overall)
    rrangem <- range(object$results$mean)
    rmeanm <- mean(object$results$mean)
    rrangeg <- matrix(0,ncol=2,nrow=object$groupinfo$ng)
    rmeang <- numeric(0)
    for (i in 1:object$groupinfo$ng){
      rrangeg[i,] <- range(object$results$gr[i,])
      rmeang[i] <- mean(object$results$gr[i,])
    }    
    groupinfo <- c(object$groupinfo,list(rrangeg=rrangeg,rmeang=rmeang,
                                         rrangem=rrangem,rmeanm=rmeanm))
  }
  # Aendern in print.summary.prabtest: Verhalten bei is.null(pd), pdfnb=FALSE
  # und Ueberschrift!
  p.value <- if (is.null(object$abund)) object$p.value
             else{
               if (above.p) object$p.above
               else object$p.below
             }
  out <- list(rrange=rrange, rmean=rmean, datac=object$datac,
              p.value=p.value,
              pd=object$pd, tuning=object$tuning,
              teststat=object$teststat, distance=object$distance,
              times=object$times,
              pdfnb=object$pdfnb,
              abund=object$abund, sarlambda=object$sarlambda,
              groupinfo=groupinfo, group.outmean=group.outmean,
              ignore.richness=object$ignore.richness, nbcols=object$nbcols,
              allele=object$allele)
  class(out) <- "summary.prabtest"
  out
}


"print.summary.prabtest" <-
function(x, ...){
  if (!is.null(x$abund))
    cat("* Parametric bootstrap test for spatial abundance data *\n\n")
  else{
    if(!is.null(x$allele))
      cat("* Parametric bootstrap test for allele/loci data *\n\n")
    else
      cat("* Parametric bootstrap test for presence-absence data *\n\n")
  }
  cat("Test statistics: ",x$teststat,", Tuning constant=",x$tuning,"\n")
  cat("Distance: ",x$distance,"\n")
  cat("Simulation runs: ",x$times,"\n")
  if(is.null(x$pd))    
    cat("A model without spatial autocorrelation was used.\n")
  else{
    cat("Disjunction parameter for presence-absence pattern: ",x$pd,"\n")
    if (!is.null(x$abund))
      cat("Neighborhood parameter lambda for SAR-model: ",x$sarlambda,"\n")
  }
  if (!is.null(x$ignore.richness))
    if (x$ignore.richness)
      cat("Rows (regions) richness has been ignored by the null model.\n")
  if (!is.null(x$nbcol))
    if (x$nbcol)
      cat("Neighborhood belongs to columns (species) instead of rows.\n")
  if (!is.null(x$pdfnb))
    if (x$pdfnb)
      cat("Neighbor-based correction of region probabilities was used.\n")
  if(x$teststat=="groups"){
    cat("Mean within group distances for original data: ",x$datac$overall,"\n")
    cat("Mean of mean within group distances for null data: ",x$rmean,
        ", range: ",x$rrange,"\n")
    cat("p= ",x$p.value,"\n")
    if (x$group.outmean){
      cat("Overall mean for original data: ",x$groupinfo$testm,"\n")
      cat("Mean of overall mean for null data: ",x$groupinfo$rmeanm,
          ", range: ",x$groupinfo$rrangem,"\n")
      cat("p= ",x$groupinfo$pma,"\n")
    }
    for (i in 1:x$groupinfo$ng)
      if (x$groupinfo$nsg[i]>1){
        cat("  Group ",x$groupinfo$lg[i],
            " statistics value for original data: ",
          x$datac$gr[i],"\n")
        cat("  Group ",x$groupinfo$lg[i],
            " mean for null data: ",x$groupinfo$rmeang[i],
          ", range: ",x$groupinfo$rrangeg[i,],"\n")
        cat("  p= ",x$groupinfo$pa[i],"\n")
      }
      
  }
  else{
    cat("Statistics value for original data: ",x$datac,"\n")
    cat("Mean for null data: ",x$rmean,", range: ",x$rrange,"\n")
    cat("p= ",x$p.value,"\n")
  }
}



autoconst <- function (x, prange = c(0, 1), twostep = TRUE, step1 = 0.1, step2 = 0.01, 
    plot = TRUE, nperp = 4, ejprob = NULL, species.fixed = TRUE, 
    pdfnb = FALSE, ignore.richness=FALSE) 
{
    probs <- prange[1] + step1 * (0:round((prange[2] - prange[1])/step1))
    if (is.null(ejprob)) {
        cat("  Calculating disjunction probability for original data ")
# str(x$prab)
# print(x$nb)        
        positivespecies <- x$regperspec>0
        cn <- con.regmat(x$prab, x$nb)[positivespecies]
        ejumps <- sum(cn - 1)
        den <- sum(x$regperspec[positivespecies] - 1)
        if (den == 0 | ejumps == 0) 
            ejprob <- 0
        else ejprob <- ejumps/den
        cat(ejprob, "\n")
    }
    out <- list()
    if (ejprob > 0) 
        out <- autoreg(x, probs, ejprob, plot, nperp, species.fixed = species.fixed, 
            pdfnb = pdfnb, ignore.richness=ignore.richness)
    if (ejprob == 0) 
        out$pd <- 0
    if (out$pd < 0) 
        out$pd <- 0
    if (out$pd > 1) 
        out$pd <- 1
    if (twostep){
        out1 <- out
        if (out$pd==0)
          prange2 <- c(0,10*step2)
        else 
          prange2 <- c(max(0, out$pd - 5 * step2), min(1, out$pd + 
            5 * step2))
        probs <- prange2[1] + step2 * (0:round((prange2[2] - 
            prange2[1])/step2))
        out <- autoreg(x, probs, ejprob, plot, nperp, species.fixed = species.fixed, 
            pdfnb = pdfnb, ignore.richness=ignore.richness)
        if (out$pd < 0 | out$pd > 1) 
            out <- out1
    }
    out <- c(out, list(ejprob = ejprob))
    out
}

autoreg <- function (x, probs, ejprob, plot = TRUE, nperp = 4,
                     species.fixed = TRUE, 
    pdfnb = FALSE, ignore.richness=FALSE) 
{
    tjumps <- matrix(nrow = nperp * length(probs), ncol = 3)
    for (j in 1:length(probs)) {
        cat("    Estimating disj. parameter: Simulations for p= ", 
            probs[j], "\n")
        for (i in 1:nperp) {
            if (ignore.richness)
              test <- randpop.nb(x$nb, p.nb = probs[j], n.species = x$n.species, 
                vector.species = x$regperspec, species.fixed = species.fixed,  
                count = FALSE, pdfnb = pdfnb)
            else
              test <- randpop.nb(x$nb, p.nb = probs[j], n.species = x$n.species, 
                vector.species = x$regperspec, species.fixed = species.fixed,
                                 pdf.regions = x$specperreg/sum(x$specperreg), 
                count = FALSE, pdfnb = pdfnb)
            nst <- apply(test, 2, sum)
            tcn <- con.regmat(test, x$nb, count = FALSE)
            ind <- (j - 1) * nperp + i
            tjumps[ind, 1] <- probs[j]
            tjumps[ind, 2] <- sum(tcn - 1)
            tjumps[ind, 3] <- tjumps[ind, 2]/sum(nst - 1)
        }
    }
    ejlm <- lm(tjumps[, 3] ~ tjumps[, 1])
    if (plot) {
        plot(tjumps[, 1], tjumps[, 3], xlab = "pdisj", ylab = "qdisj")
        abline(ejlm$coef)
        abline(c(ejprob, 0), lty = 2)
    }
    pd <- (ejprob - ejlm$coef[1])/ejlm$coef[2]
    cat("  Estimated disjunction parameter =", pd, "\n")
    out <- list(pd = pd, coef = ejlm$coef)
    out
}

pop.sim <-
  function (regmat, neighbors, h0c = 1, times = 200, dist = "kulczynski", 
    teststat = "isovertice", testc = NULL, geodist = NULL, gtf = 0.1,
            n.species = ncol(regmat), 
    specperreg = NULL, regperspec = NULL, species.fixed = FALSE, 
    pdfnb = FALSE, ignore.richness=FALSE) 
{
    statres <- rep(0, times)
    if (is.null(specperreg)) 
        nregions <- apply(regmat, 1, sum)
    else nregions <- specperreg
    if (is.null(regperspec)) 
        nspecies <- apply(regmat, 2, sum)
    else nspecies <- regperspec
    for (i in 1:times) {
        cat("Simulation run ", i)
        if (ignore.richness)
          mat <- randpop.nb(neighbors, p.nb = h0c, n.species = n.species, 
            vector.species = nspecies, species.fixed = species.fixed, 
            count = FALSE, 
            pdfnb = pdfnb)
        else
          mat <- randpop.nb(neighbors, p.nb = h0c, n.species = n.species, 
            vector.species = nspecies, species.fixed = species.fixed, 
            pdf.regions = nregions/sum(nregions), count = FALSE, 
            pdfnb = pdfnb)
#        str(geodist)
#        print(max(geodist))
        if (teststat != "inclusions") {
            if (dist == "jaccard") 
                distm <- jaccard(mat)
            if (dist == "kulczynski") 
                distm <- kulczynski(mat)
            if (dist=="dice")
                distm <- dicedist(mat)
            if (dist == "geco") 
                distm <- geco(mat, geodist, tf = gtf)
#            print("distm")
#            str(distm)
        }
        else statres[i] <- incmatrix(mat)$ninc
        if (teststat == "isovertice") {
            test <- homogen.test(distm, ne = testc)
            statres[i] <- test$iv
        }
        if (teststat == "lcomponent") 
            statres[i] <- lcomponent(distm, ne = testc)$lc
        if (teststat == "distratio") 
            statres[i] <- distratio(distm, prop = testc)$dr
        if (teststat == "nn") 
            statres[i] <- nn(distm, ne = testc)
        cat(" statistics value=", statres[i], "\n")
    }
    if (teststat != "inclusions") {
        if (dist == "jaccard") 
            distm <- jaccard(regmat)
        if (dist == "kulczynski") 
            distm <- kulczynski(regmat)
        if (dist=="dice")
                distm <- dicedist(regmat)
        if (dist == "geco") 
            distm <- geco(regmat, geodist, tf = gtf)
    }
    else {
        test <- incmatrix(regmat)$ninc
        p.above <- (1 + sum(statres >= test))/(1 + times)
        p.below <- (1 + sum(statres <= test))/(1 + times)
        datac <- test
    }
    if (teststat == "isovertice") {
        test <- homogen.test(distm, ne = testc)
        p.above <- (1 + sum(statres >= test$iv))/(1 + times)
        p.below <- (1 + sum(statres <= test$iv))/(1 + times)
        pb <- min(p.above, p.below) * 2
        p.above <- max(p.above, p.below)
        p.below <- pb
        datac <- test$iv
        testc <- test$ne
    }
    if (teststat == "lcomponent") {
        test <- lcomponent(distm, ne = testc)
        p.above <- (1 + sum(statres >= test$lc))/(1 + times)
        p.below <- (1 + sum(statres <= test$lc))/(1 + times)
        datac <- test$lc
        testc <- test$ne
    }
    if (teststat == "nn") {
        test <- nn(distm, ne = testc)
        p.above <- (1 + sum(statres >= test))/(1 + times)
        p.below <- (1 + sum(statres <= test))/(1 + times)
        datac <- test
    }
    if (teststat == "distratio") {
        test <- distratio(distm, prop = testc)
        p.above <- (1 + sum(statres >= test$dr))/(1 + times)
        p.below <- (1 + sum(statres <= test$dr))/(1 + times)
        datac <- test$dr
        testc <- test$prop
    }
    cat("Data value: ", datac, "\n")
    out <- list(results = statres, p.above = p.above, p.below = p.below, 
        datac = datac, testc = testc)
    out
}


# "pop.sim" <-
# function(regmat, neighbors, h0c=1, times=200, dist="kulczynski",
#                     teststat="isovertice",testc=NULL,geodist=NULL,gtf=0.1,
#                     n.species=ncol(regmat), specperreg=NULL,
#                     regperspec=NULL, species.fixed=FALSE, pdfnb=FALSE){
#   statres <- rep(0,times)
#   if (is.null(specperreg))
#       nregions <- apply(regmat,1,sum)
#   else
#       nregions <- specperreg
#   if (is.null(regperspec))
#       nspecies <- apply(regmat,2,sum)
#   else
#       nspecies <- regperspec
#   for (i in 1:times)
#   {
#     cat("Simulation run ",i)
#     mat <- randpop.nb(neighbors,p.nb=h0c,n.species=n.species,
#                         vector.species=nspecies, species.fixed=species.fixed,
#                         pdf.regions=nregions/sum(nregions),count=FALSE,
#                       pdfnb=pdfnb)
#     if (teststat!="inclusions"){
#       if (dist=="jaccard")
#         distm <- jaccard(mat)
#       if (dist=="kulczynski")
#         distm <- kulczynski(mat)
#       if (dist=="geco")
#         distm <- geco(mat,geodist,tf=gtf)
#     }
#     else
#       statres[i] <- incmatrix(mat)$ninc
#     if (teststat=="isovertice")
#     {
#       test <- homogen.test(distm,ne=testc)
#       statres[i] <- test$iv
#     }
#     if (teststat=="lcomponent")
#       statres[i] <- lcomponent(distm,ne=testc)$lc
#     if (teststat=="distratio")
#       statres[i] <- distratio(distm,prop=testc)$dr
#     if (teststat=="nn")
#       statres[i] <- nn(distm,ne=testc)
#     cat(" statistics value=",statres[i],"\n")
#   }
#   if (teststat!="inclusions"){
#     if (dist=="jaccard")
#       distm <- jaccard(regmat)
#     if (dist=="kulczynski")
#       distm <- kulczynski(regmat)
#     if (dist=="geco")
#       distm <- geco(regmat,geodist,tf=gtf)
#   }
#   else{
#     test <- incmatrix(regmat)$ninc
#     p.above <- (1+sum(statres>=test))/(1+times)
#     p.below <- (1+sum(statres<=test))/(1+times)
#     datac <- test
#   }
#   if (teststat=="isovertice")
#   {
#     test <- homogen.test(distm,ne=testc)
#     p.above <- (1+sum(statres>=test$iv))/(1+times)
#     p.below <- (1+sum(statres<=test$iv))/(1+times)
#     pb <- min(p.above,p.below)*2
#     p.above <- max(p.above,p.below)
#     p.below <- pb
#     datac <- test$iv
#     testc <- test$ne
#   }
#   if (teststat=="lcomponent")
#   {
#     test <- lcomponent(distm,ne=testc)
#     p.above <- (1+sum(statres>=test$lc))/(1+times)
#     p.below <- (1+sum(statres<=test$lc))/(1+times)
#     datac <- test$lc
#     testc <- test$ne
#   }
#   if (teststat=="nn")
#   {
#     test <- nn(distm,ne=testc)
#     p.above <- (1+sum(statres>=test))/(1+times)
#     p.below <- (1+sum(statres<=test))/(1+times)
#     datac <- test
#   }
#   if (teststat=="distratio")
#   {
#     test <- distratio(distm,prop=testc)
#     p.above <- (1+sum(statres>=test$dr))/(1+times)
#     p.below <- (1+sum(statres<=test$dr))/(1+times)
#     datac <- test$dr
#     testc <- test$prop
#   }
#   cat("Data value: ",datac,"\n")
#   out <- list(results=statres,p.above=p.above,p.below=p.below,datac=datac,
#               testc=testc)
#   out
# }

"jaccard" <-
function(regmat){
  nart <- ncol(regmat)
  jdist <- rep(0, nart*nart)
  dim(jdist) <- c(nart,nart)
  reg.col.sum <- apply(regmat,2,sum)
  reg.aggrement <- t(regmat) %*% regmat
  
  jdist <-  1- reg.aggrement / (reg.col.sum-t(t(reg.aggrement)-reg.col.sum))
 
  jdist
}


# "jaccard" <-
# function(regmat){
#   nart <- ncol(regmat)
#   jdist <- rep(0, nart*nart)
#   dim(jdist) <- c(nart,nart)
#   for (i in 1:(nart-1)){
# #    cat("Row ",i,"\n")
#     for (j in (i+1):nart){
#       jdist[j,i] <- jdist[i,j] <-  1-sum(regmat[,i]+regmat[,j]>1.99)/sum(regmat[,i]+regmat[,j]>0.99)
#       if (is.na(jdist[i,j]))
#         cat("Warning! NA at i=",i,", j=", j,"\n")
#     }
#   }
#   jdist
# }

"nbtest" <-
  function(nblist, n.regions=length(nblist)){
    nbok <- TRUE
    if (!is.list(nblist)){
      cat("Neighborhood is not a list.\n")
      nbok <- FALSE
    }
    lnb <- length(nblist)
    if (lnb!=n.regions){
      cat("Neighborhood length",lnb,"does not match regions number",
          n.regions,".\n")
      nbok <- FALSE
    }
    for (i in 1:lnb){
      if (length(nblist[[i]])>0){
        if (min(nblist[[i]]<1))
          stop("Neighborhood list contains elements smaller than 1.")
        if (max(nblist[[i]]>n.regions))
          stop("Neighborhood list contains elements larger than number of regions.")
        for (n in nblist[[i]]){
          if (n==i){
            cat(i,"is neighbor of itself.\n")
            nbok <- FALSE
          }
          if (all(nblist[[n]]!=i)){
            cat(i,"is neighbor of",n,"but",n,"is not neighbor of",
                i,".\n")
            nbok <- FALSE
          }
        }
      }
    }
    if (!nbok) stop("Improper neighborhood list.")
    invisible(nbok)
  }

"randpop.nb" <-
function(neighbors,p.nb=0.5,n.species,
                       n.regions=length(neighbors),
                       vector.species=rep(1,n.species), species.fixed=FALSE,
                       pdf.regions=rep(1/n.regions,n.regions),count=TRUE,
                       pdfnb=FALSE){
# print(vector.species)
  out <- matrix(0,ncol=n.species,nrow=n.regions)
  if (pdfnb)
  {
    for (i in 1:n.regions)
      pdf.regions[i] <- pdf.regions[i]/max(1,length(neighbors[[i]]))
    pdf.regions <- pdf.regions/sum(pdf.regions)
  }
  cdf.local <- cdf.regions <- c()
  for (i in 1:n.regions)
    cdf.regions[i] <- sum(pdf.regions[1:i])
  for (i in 1:n.species)
  {
    if(count)
      cat("Species ",i,"\n")
    spec.regind <- spec.neighb <- rep(FALSE,n.regions)
    nsize <- ifelse(species.fixed, vector.species[i],
                    vector.species[1+floor(length(vector.species)*runif(1))])
#    print(vector.species)
#    print(nsize)
    r1 <- runif(1)
    reg <- 1+sum(r1>cdf.regions)
# print(reg)
#    print(cdf.regions)
    spec.regind[reg] <- TRUE
    for (k in neighbors[[reg]])
      spec.neighb[k] <- TRUE
    out[reg,i] <- 1
#    print(out)
#    print(nsize)
    if(nsize>1)
      for (j in 2:nsize)
        if (all(!spec.neighb) | all(pdf.regions[spec.neighb]<1e-8) |
             all(spec.neighb | spec.regind) |
            all(pdf.regions[!(spec.regind | spec.neighb)]<1e-8))
# no further neighbors or only neighbors, i.e., next region is drawn from all
# remaining
        {
          nreg <- sum(!spec.regind)
          pdf.local <- pdf.regions[!spec.regind]
          pdf.local <- pdf.local/sum(pdf.local)
          for (l in 1:nreg)
            cdf.local[l] <- sum(pdf.local[1:l])
# cat(nreg, "\n")
          r1 <- runif(1)
          zz <- 1+sum(r1>cdf.local[1:nreg])
# cat(zz,"\n")
          reg <- (1:n.regions)[!spec.regind][zz]
#          if (spec.regind[reg]) cat("reg, all ",reg,"\n")  
          spec.regind[reg] <- TRUE
          spec.neighb[reg] <- FALSE
          for (k in neighbors[[reg]])
            spec.neighb[k] <- !(spec.regind[k])
          out[reg,i] <- 1
        }
        else
          if (runif(1)<p.nb)
# next region is drawn from non-neighbors (jump)
          { 
            regs <- !(spec.regind | spec.neighb)
            nreg <- sum(regs)
            pdf.local <- pdf.regions[regs]
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
# cat(nreg," ",zz,"\n")
            reg <- (1:n.regions)[regs][zz]
#            if (is.na(spec.regind[reg]))  cat("reg, jump ",r1," ",cdf.local,"\n")  
            spec.regind[reg] <- TRUE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,i] <- 1
# if (sum(out[,i])!=sum(spec.regind))
#   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
          }
          else
          {
# next region is drawn from neighbors
            nreg <- sum(spec.neighb)
            pdf.local <- pdf.regions[spec.neighb]
# print(pdf.local)
            pdf.local <- pdf.local/sum(pdf.local)
            for (l in 1:nreg)
              cdf.local[l] <- sum(pdf.local[1:l])
# print(cdf.local)
            r1 <- runif(1)
            zz <- 1+sum(r1>cdf.local[1:nreg])
# cat("nreg= ",nreg," zz =",zz,"\n")
            reg <- (1:n.regions)[spec.neighb][zz]  
#            if (spec.regind[reg]) cat("reg, neighbor ",reg,"\n")  
            spec.regind[reg] <- TRUE
            spec.neighb[reg] <- FALSE
            for (k in neighbors[[reg]])
              spec.neighb[k] <- !(spec.regind[k])
            out[reg,i] <- 1
# if (sum(out[,i])!=sum(spec.regind))
#   cat("error: sum= ",sum(out[,i])," ind=",sum(spec.regind),"\n")
          }
# end if nsize>1 for j 
# cat("out=",sum(out[,i]),"  ind=",sum(spec.regind),"  nb=",sum(spec.neighb),
#   "  nni=",sum(!(spec.regind | spec.neighb)),"\n")
  } # for i           
  out
}

# allows dist="dice"
# gives out skipping indicator
# (and does all the geco and abundances stuff too) 
prabinit <- function (file = NULL, prabmatrix = NULL, rows.are.species = TRUE, 
    neighborhood = "none", nbbetweenregions=TRUE,
                      geodist = NULL, gtf = 0.1, distance = "kulczynski", 
    toprab = FALSE, toprabp = 0.05, outc = 5.2) 
{
    if (is.null(prabmatrix)) 
        m1 <- as.matrix(read.table(file))
    else m1 <- as.matrix(prabmatrix)
    if (rows.are.species) 
        m1 <- t(m1)
    regperspec <- apply(m1, 2, sum)
    specperreg <- apply(m1, 1, sum)
    nonempty.species <- regperspec > 0
    m1 <- as.matrix(m1[, regperspec > 0])
    regperspec <- regperspec[regperspec > 0]
    n.species <- ncol(m1)
    n.regions <- nrow(m1)
    nb <- list()
    if (nbbetweenregions)
          nreg <- n.regions
    else
          nreg <- n.species
    if (is.list(neighborhood)) 
        nb <- neighborhood
    else {
        if (identical(neighborhood,"none")) 
            for (i in 1:nreg) nb[[i]] <- numeric(0)
        else for (i in 1:nreg) nb <- c(nb, list(scan(file = neighborhood, 
            skip = i - 1, nlines = 1, quiet = TRUE)))
    }
    nbtest(nb, nreg)
    if (toprab) {
        nscut <- toprabp * specperreg
#        if (toprabp == 0) 
#            nscut <- min(m1[m1 > 0])/10
        minno <- c()
        for (i in 1:n.species) {
            g0 <- log(m1[, i][m1[, i] > 0])
            minno[i] <- median(g0) - mad(g0, constant = outc)
        }
        for (i in 1:n.regions) for (j in 1:n.species) m1[i, j] <- as.integer(m1[i, 
            j] > nscut[i] | log(m1[i, j]) > minno[j])
        regperspec <- apply(m1, 2, sum)
        specperreg <- apply(m1, 1, sum)
    }
    distmat <- switch(distance, kulczynski = kulczynski(m1), 
        jaccard = jaccard(m1), geco = geco(m1, geodist, tf = gtf), 
        qkulczynski = qkulczynski(m1), logkulczynski = qkulczynski(m1, 
            log.distance = TRUE), dice=dicedist(m1),
                      none = NULL)
    if (identical(levels(as.factor(m1)),c("0","1"))){
      prabm <- as.matrix(as.logical(m1))
      dim(prabm) <- dim(m1)
      m1 <- prabm
    }
    out <- list(distmat = distmat, prab = m1, nb = nb, regperspec = regperspec, 
        specperreg = specperreg, n.species = n.species, n.regions = n.regions, 
        distance = distance, geodist = geodist, gtf = gtf, spatial = (!identical(neighborhood, 
            "none")), nonempty.species=nonempty.species,
                nbbetweenregions=nbbetweenregions)
    class(out) <- "prab"
    out
}

# 
# prabinit <- function (file = NULL, prabmatrix = NULL, rows.are.species = TRUE, 
#     neighborhood = "none", geodist = NULL, gtf = 0.1, distance = "kulczynski", 
#     toprab = FALSE, toprabp = 0.05, outc = 5.2) 
# {
#     if (is.null(prabmatrix)) 
#         m1 <- as.matrix(read.table(file))
#     else m1 <- as.matrix(prabmatrix)
#     if (rows.are.species) 
#         m1 <- t(m1)
#     regperspec <- apply(m1, 2, sum)
#     specperreg <- apply(m1, 1, sum)
#     nonzero <- regperspec>0
#     m1 <- as.matrix(m1[, regperspec > 0])
#     regperspec <- regperspec[regperspec > 0]
#     n.species <- ncol(m1)
#     n.regions <- nrow(m1)
#     nb <- list()
#     if (is.list(neighborhood)) 
#         nb <- neighborhood
#     else {
#         if (neighborhood == "none") 
#             for (i in 1:n.regions) nb[[i]] <- numeric(0)
#         else for (i in 1:n.regions) nb <- c(nb, list(scan(file = neighborhood, 
#             skip = i - 1, nlines = 1, quiet = TRUE)))
#     }
#     nbtest(nb, n.regions)
#     if (toprab) {
#         nscut <- toprabp * specperreg
#         if (toprabp == 0) 
#             nscut <- min(m1[m1 > 0])/10
#         minno <- c()
#         for (i in 1:n.species) {
#             g0 <- log(m1[, i][m1[, i] > 0])
#             minno[i] <- median(g0) - mad(g0, constant = outc)
#         }
#         for (i in 1:n.regions)
#           for (j in 1:n.species)
#             m1[i, j] <- as.integer(m1[i,j] >= nscut[i] | log(m1[i, j]) >= minno[j])
#         regperspec <- apply(m1, 2, sum)
#         specperreg <- apply(m1, 1, sum)
#     }
#     distmat <- switch(distance, kulczynski = kulczynski(m1), 
#         jaccard = jaccard(m1), geco = geco(m1, geodist, tf = gtf), 
#         qkulczynski = qkulczynski(m1), logkulczynski=qkulczynski(m1,
#                                          log.distance=TRUE), none = NULL)
#     out <- list(distmat = distmat, prab = m1, nb = nb, regperspec = regperspec, 
#         specperreg = specperreg, n.species = n.species, n.regions = n.regions, 
#         distance = distance, geodist = geodist, gtf = gtf,
#                 spatial = (!identical(neighborhood, "none")),
#                 nonzero=nonzero)
#     class(out) <- "prab"
#     out
# }

NNclean <- 
function (data, k, distances = NULL, edge.correct = FALSE, wrap = 0.1, 
    convergence = 0.001, plot = FALSE, quiet=TRUE) 
{
#    require(mva)
    data <- as.matrix(data)
    d <- dim(data)[2]
    n <- dim(data)[1]
    if (n > 800) {
        options(object.size = 5e+07)
    }
    if ((d == 2) && (edge.correct == TRUE)) {
        r1 <- diff(range(data[, 1]))
        r2 <- diff(range(data[, 2]))
        tran2 <- matrix(c(rep(0, n), rep(r2, n)), byrow = FALSE, 
            nrow = n)
        tran1 <- matrix(c(rep(r1, n), rep(0, n)), byrow = FALSE, 
            nrow = n)
        aux.dat <- rbind(data + tran1, data - tran1, data + tran2, 
            data - tran2, data + tran1 + tran2, data - tran1 + 
                tran2, data - tran1 - tran2, data + tran1 - tran2)
        aux.dat <- aux.dat[aux.dat[, 1] < (max(data[, 1]) + wrap * 
            r1) & aux.dat[, 1] > (min(data[, 1]) - wrap * r1) & 
            aux.dat[, 2] < (max(data[, 2]) + wrap * r2) & aux.dat[, 
            2] > (min(data[, 2]) - wrap * r2), ]
        full.data <- rbind(data, aux.dat)
    }
    else {
        full.data <- data
    }
    dDk <- function(x, lambda, k, d, alpha.d) {
        (exp(-lambda * alpha.d * x^d) * 2 * (lambda * alpha.d)^k * 
            x^(d * k - 1))/gamma(k)
    }
    if (is.null(distances)) {
        distances <- dist(full.data)
    }
    kthNND <- rep(0, n)
    Labels <- 1:(n - 1)
    kthNND[1] <- sort(distances[Labels])[k]
    Labels[(2):(n - 1)] <- Labels[(2):(n - 1)] + (n - 1 - 1)
    for (i in 2:n) {
        kthNND[i] <- sort(distances[Labels])[k]
        Labels[1:(i - 1)] <- Labels[1:(i - 1)] + 1
        Labels[(i + 1):(n - 1)] <- Labels[(i + 1):(n - 1)] + 
            (n - i - 1)
    }
    kthNND <- kthNND[1:n]
    alpha.d <- (2 * pi^(d/2))/(d * gamma(d/2))
    delta <- rep(0, n)
    delta[kthNND > (min(kthNND) + diff(range(kthNND))/3)] <- 1
    delta[is.na(delta)] <- 0
    p <- 0.5
    lambda1 <- k/(alpha.d * mean((kthNND[delta == 0])^d))
    lambda2 <- k/(alpha.d * mean((kthNND[delta == 1])^d))
    loglik.old <- 0
    loglik.new <- 1
    while (abs((loglik.new - loglik.old)/loglik.new) > convergence) {
        delta <- (p * dDk(kthNND, lambda1, k = k, d = d, alpha.d = alpha.d))/(p * 
            dDk(kthNND, lambda1, k = k, d = d, alpha.d = alpha.d) + 
            (1 - p) * dDk(kthNND, lambda2, k = k, d = d, alpha.d = alpha.d))
        delta[is.na(delta)] <- 0
        p <- sum(delta)/n
        if (p>0)
          lambda1 <- (k * sum(delta))/(alpha.d * sum((kthNND^d) * 
             delta))
        if (p<1)
          lambda2 <- (k * sum((1 - delta)))/(alpha.d * sum((kthNND^d) * 
              (1 - delta)))
        if (p<=0)
          lambda1 <- lambda2/2
        if (p>=1)
          lambda2 <- 2*lambda1
        loglik.old <- loglik.new
        loglik.new <- sum(-p * lambda1 * alpha.d * ((kthNND^d) * 
            delta) - (1 - p) * lambda2 * alpha.d * ((kthNND^d) * 
            (1 - delta)) + delta * k * log(lambda1 * alpha.d) + 
            (1 - delta) * k * log(lambda2 * alpha.d))
        if (!quiet){
          cat("l.new=",loglik.new," p=",p," l1=",lambda1,
              " l2=",lambda2," ad=",alpha.d," knnd=", kthNND," delta=",delta,
              "\n")
        }
    }
    if (plot) {
        hist(kthNND, nclass = 20, axes = TRUE, ylab = "Estimate of Mixture", 
            xlim = c(0, max(kthNND)), probability = TRUE, xlab = paste("Distance to", 
                eval(k), "th nearest neighbour"))
        box()
        support <- seq(0, max(kthNND), length = 200)
        lines(support, (p * dDk(support, lambda1, k = k, d = d, 
            alpha.d = alpha.d) + (1 - p) * dDk(support, lambda2, 
            k = k, d = d, alpha.d = alpha.d)))
    }
    probs <- dDk(kthNND, lambda1, k = k, d = d, alpha.d = alpha.d)/(dDk(kthNND, 
        lambda1, k = k, d = d, alpha.d = alpha.d) + dDk(kthNND, 
        lambda2, k = k, d = d, alpha.d = alpha.d))
    probs[is.na(probs)] <- 1
    out <- list(z = round(probs), probs = probs, k = k, lambda1 = lambda1, 
        lambda2 = lambda2, p = p, kthNND = kthNND)
    class(out) <- "nnclean"
    return(out)
}

print.nnclean <- function(x, ...){
  cat("Nearest neighbor noise detection\n")
  cat("by Byers, S. and Raftery, A. E. (1998) Nearest-Neighbor Clutter\n")
  cat("Removal for Estimating Features in Spatial Point Processes,\n")
  cat("Journal of the American Statistical Association, 93, 577-584.\n")
  cat("Classification: ( 0 means noise)\n", x$z, "\n")
  cat("The Poisson process mixture of the distance to kth nearest neighbor\n")
  cat("is characterized by k=",x$k,", p=",x$p,"\n")
  cat("lambda1=",x$lambda1,", lambda2=",x$lambda2,"\n")
}
  

"print.prabclust" <-
function(x, bic=FALSE, ...){
  cat("* Clustered presence-absence matrix * \n\n")
  cat("Clustered: ", x$mdsdim, "-dim. MDS result from method ",x$mdsmethod,"\n\n")
#  cat("mclust decided for ",ncol(x$clustsummary[[3]]$mu),
#      " clusters plus noise.\n")
  cat("Noise-detector NNclean has been used with k=", x$nnk, "\n")
  cat("NNclean is explained in S. Byers and A. E. Raftery, JASA 95 (1998), 781-794\n")
  cat("A Normal mixture model with noise component (mclust) has been used.\n")
  if (bic){
    cat("Cluster summary:\n")
    print(x$clustsummary)
    cat("\n")
    cat("BIC value summary:\n")
    print(x$bicsummary)
    cat("\n")
  }
  else{
    cat("Mixture component memberships:\n")
    print(x$clustering)
    cat("\n")
  }
  cat("Clustering (N denotes noise or one-point components):\n")
  print(x$symbols)
}

# simulation with regpop.sar
# p.nb=NULL: ignore neighbors
# groupvector is needed for teststat="groups", has to be a factor
# sarestimate=NULL: presence-absence
abundtest <- function (prabobj, teststat = "distratio", tuning = 0.25,
                       times = 1000, p.nb = NULL, 
                       prange = c(0, 1), nperp = 4, step = 0.1, step2 = 0.01, 
                       twostep = TRUE, species.fixed=TRUE, prab01=NULL,
                       groupvector=NULL,
                       sarestimate=prab.sarestimate(prabobj),
                       dist = prabobj$distance,
                       n.species = prabobj$n.species)
#    species.fixed = TRUE 
{
    if (is.null(prab01))
      prab01 <- prabinit(prabmatrix=toprab(prabobj),rows.are.species=FALSE,
                      distance="none",neighborhood=prabobj$nb)
    if (is.null(p.nb) & prabobj$spatial){        
        ac <- autoconst(prab01, twostep = twostep, prange = prange, 
            nperp = nperp, step1 = step, step2 = step2,
                        species.fixed = species.fixed)
        p.nb <- ac$pd
    }
    if (is.null(p.nb)) 
        p.nb <- 1    
    statres <- rep(0, times)
    if (teststat=="groups"){
      groupvector <- as.factor(groupvector)
      ng <- length(levels(groupvector))
      lg <- levels(groupvector)
      nsg <- numeric(0)
      for (i in 1:ng) nsg[i] <- sum(groupvector==lg[i])
      pa <- pb <- rep(1,ng)
      groupinfo <- list(lg=lg,ng=ng,nsg=nsg)
      statreslist <- list(overall=numeric(0),mean=numeric(0),
                          gr=matrix(0,nrow=ng,ncol=times))
    }
    else
      groupinfo <- NULL
#    print(groupinfo)
#    rmatrix <- rankmatrix(prabobj)
    for (i in 1:times) {
        cat("Simulation run ", i)
        if (is.null(sarestimate) || teststat == "inclusions")
          mat <- randpop.nb(neighbors=prabobj$nb,
                             p.nb = p.nb, n.species = prabobj$n.species, 
                             vector.species = prab01$regperspec,
                             species.fixed = species.fixed, 
                             pdf.regions =
                             prab01$specperreg/sum(prab01$specperreg),
                             count = FALSE)
         else
           mat <- regpop.sar(prabobj, prab01, sarestimate,
                          p.nb, count = FALSE)
        if (teststat != "inclusions"){
            if (dist == "jaccard") 
                distm <- jaccard(mat)
            if (dist == "kulczynski") 
                distm <- kulczynski(mat)
            if (dist == "qkulczynski") 
                distm <- qkulczynski(mat)
            if (dist == "logkulczynski") 
                distm <- qkulczynski(mat,log.distance=TRUE)
        }
        else statres[i] <- incmatrix(mat)$ninc
        if (teststat == "isovertice") {
            test <- homogen.test(distm, ne = tuning)
            statres[i] <- test$iv
        }
        if (teststat == "lcomponent") 
            statres[i] <- lcomponent(distm, ne = tuning)$lc
        if (teststat == "mean")
            statres[i] <- mean(as.dist(distm))
        if (teststat == "distratio") 
            statres[i] <- distratio(distm, prop = tuning)$dr
        if (teststat == "nn") 
            statres[i] <- nn(distm, ne = tuning)
        if (teststat == "groups"){
            slist <- specgroups(distm, groupvector, groupinfo)
#            print(slist)
            statreslist$overall[i] <- slist$overall
            statreslist$mean[i] <- mean(as.dist(distm))
            statreslist$gr[,i] <-  slist$gr
#            print(statreslist)
            cat(" statistics value=", statreslist$overall[i], "\n")
        }
        else
          cat(" statistics value=", statres[i], "\n")
    }
    regmat <- prabobj$prab
    if (teststat != "inclusions") {
      if (dist==prabobj$distance)
        distm <- prabobj$distmat
      else{
        if (dist == "jaccard") 
            distm <- jaccard(regmat)
        if (dist == "kulczynski") 
            distm <- kulczynski(regmat)
        if (dist == "qkulczynski") 
            distm <- qkulczynski(regmat)
        if (dist == "logkulczynski") 
            distm <- qkulczynski(regmat,log.distance=TRUE)
      }
    }
    else {
        regmat <- prab01$prab
        test <- incmatrix(regmat)$ninc
        p.above <- (1 + sum(statres >= test))/(1 + times)
        p.below <- (1 + sum(statres <= test))/(1 + times)
        datac <- test
        tuning <- NA
    }
    if (teststat == "mean"){
      test <- mean(as.dist(distm))
      p.above <- (1 + sum(statres >= test))/(1 + times)
      p.below <- (1 + sum(statres <= test))/(1 + times)
      datac <- test
      tuning <- NA
    }

    if (teststat == "isovertice") {
        test <- homogen.test(distm, ne = tuning)
        p.above <- (1 + sum(statres >= test$iv))/(1 + times)
        p.below <- (1 + sum(statres <= test$iv))/(1 + times)
        pb <- min(p.above, p.below) * 2
        p.above <- max(p.above, p.below)
        p.below <- pb
        datac <- test$iv
        tuning <- test$ne
    }
    if (teststat == "lcomponent") {
        test <- lcomponent(distm, ne = tuning)
        p.above <- (1 + sum(statres >= test$lc))/(1 + times)
        p.below <- (1 + sum(statres <= test$lc))/(1 + times)
        datac <- test$lc
        tuning <- test$ne
    }
    if (teststat == "nn") {
        test <- nn(distm, ne = tuning)
        p.above <- (1 + sum(statres >= test))/(1 + times)
        p.below <- (1 + sum(statres <= test))/(1 + times)
        datac <- test
    }
    if (teststat == "distratio") {
        test <- distratio(distm, prop = tuning)
        p.above <- (1 + sum(statres >= test$dr))/(1 + times)
        p.below <- (1 + sum(statres <= test$dr))/(1 + times)
        datac <- test$dr
        tuning <- test$prop
    }
    if (teststat=="groups"){
        test <- specgroups(distm, groupvector, groupinfo)
        testm <- mean(as.dist(distm))
        p.above <- (1 + sum(statreslist$overall >= test$overall))/(1 + times)
        p.below <- (1 + sum(statreslist$overall <= test$overall))/(1 + times)
        p.m.above <- (1 + sum(statreslist$mean >= testm))/(1 + times)
        p.m.below <- (1 + sum(statreslist$mean <= testm))/(1 + times)
        for (i in 1:ng){
          pa[i] <- (1 + sum(statreslist$gr[i,] >= test$gr[i]))/(1 + times)
          pb[i] <- (1 + sum(statreslist$gr[i,] <= test$gr[i]))/(1 + times)
        }
        datac <- test
        tuning <- NA
        groupinfo$testm <- testm
        groupinfo$pa <- pa
        groupinfo$pb <- pb
        groupinfo$pma <- p.m.above
        groupinfo$pmb <- p.m.below
        cat("Data value: ", datac$overall, "\n")
    }
    else
      cat("Data value: ", datac, "\n")
    if (!prabobj$spatial || is.null(sarestimate)) sarlambda <- NULL
    else sarlambda <- sarestimate$lambda*sarestimate$nbweight
    if (teststat=="groups")
      results <- statreslist
    else
      results=statres
    out <- list(results = results, p.above = p.above, p.below = p.below, 
        datac = datac, tuning = tuning, distance=dist, times=times,
                teststat=teststat, pd=p.nb,
                abund=!is.null(sarestimate),
                sarlambda=sarlambda, sarestimate=sarestimate,
                groupinfo=groupinfo)
    class(out) <- "prabtest"
    out
}


    
toprab <- function(prabobj)
  prabobj$prab>0

    
build.nblist <- function(prabobj,prab01=NULL,style="C"){
#  require(spdep)
  if (is.null(prab01))
    prab01 <- prabinit(prabmatrix=toprab(prabobj),rows.are.species=FALSE,
                      distance="none")
  nblist <- list()
  q <- 1
  ijsum <- 0
  for (i in 1:prabobj$n.species){
#    print(i)
    iregs <- (1:prabobj$n.regions)[prab01$prab[,i]]
    for (j in 1:prab01$regperspec[i]){
#      print(j)
      nblist[[q]] <-
        (1:length(iregs))[iregs %in% prabobj$nb[[iregs[j]]]]+ijsum
#      if (sum(nblist[[q]]==q)>0) cat(q," ",i," ",j," ",iregs[j]," ",ijsum,"\n")
      q <- q+1
    }
    ijsum <- ijsum+prab01$regperspec[i]
  }
  nblist <- lapply(nblist,as.integer)
  nblist[sapply(nblist, length) == 0L] <- 0L
#  print(nblist)
  class(nblist) <- "nb"
  out <- spdep::nb2listw(nblist,style=style,zero.policy=TRUE)
  invisible(out)
}

# columns are species
# fixed species
# if neighborhood="none", sampling=TRUE is faster
# abmat is a prab object
prab.sarestimate <- function(abmat, prab01=NULL,sarmethod="eigen",
                             weightstyle="C",
                             quiet=TRUE, sar=TRUE,
                             add.lmobject=TRUE){
#  if (sar) require(spdep)
  if (is.null(prab01))
    prab01 <- prabinit(prabmatrix=toprab(abmat),rows.are.species=FALSE,
                      distance="none")
  # single and regions total abundances log transformed
#  print("sarestimate logs")
  logabund <- log(abmat$prab[prab01$prab[,1],1])
  species <- rep(1,sum(prab01$prab[,1]))
  region <- (1:abmat$n.regions)[prab01$prab[,1]]
  for (j in 2:abmat$n.species){
    logabund <- c(logabund,log(abmat$prab[prab01$prab[,j],j]))
    species <- c(species,rep(j,sum(prab01$prab[,j])))
    region <- c(region,(1:abmat$n.regions)[prab01$prab[,j]])
  }
  species <- as.factor(species)
  region <- as.factor(region)
#  nblistw <- build.nblist(abmat,prab01=prab01,style=weightstyle)
  abundreg <- data.frame(logabund,species,region,
                         row.names=sapply(1:length(species),toString))
  if (sar){
      nblistw <- build.nblist(abmat,prab01=prab01,style=weightstyle)
#    print("errorsarlm")
      abundlm <- spatialreg::errorsarlm(logabund~region+species,data=abundreg,
                        listw=nblistw,quiet=quiet,zero.policy=TRUE,
                        method=sarmethod)
      interc <- coef(abundlm)[2] # was 1
      sigma <- sqrt(summary(abundlm)$s2)
      regeffects <- c(0,coef(abundlm)[3:(abmat$n.regions+1)]) # was one down
      speffects <- c(0,coef(abundlm)[(abmat$n.regions+2):
                                 (abmat$n.regions+abmat$n.species)]) # dito
      lambda <- abundlm$lambda
      nbweight <- mean(c(nblistw[[3]],recursive=TRUE))
      if (!add.lmobject) abundlm <- NULL
#    print("sarestimate end")
      out <- list(sar=sar,intercept=interc,sigma=sigma,regeffects=regeffects,
              speffects=speffects,lambda=lambda,size=length(nblistw[[3]]),
              nbweight=nbweight,lmobject=abundlm)
  }
  else{
#    print("lm")
    abundlm <- lm(logabund~region+species,data=abundreg)
    interc <- coef(abundlm)[1]
    sigma <- summary(abundlm)$sigma
    regeffects <- c(0,coef(abundlm)[2:abmat$n.regions])
    speffects <- c(0,coef(abundlm)[(abmat$n.regions+1):
                                 (abmat$n.regions+abmat$n.species-1)])
    if (!add.lmobject) abundlm <- NULL
#    print("sarestimate end")
    out <- list(sar=sar,intercept=interc,sigma=sigma,regeffects=regeffects,
              speffects=speffects,lmobject=abundlm)
  }
  out
}
 
# columns are species
# fixed species
# if neighborhood="none", sampling=TRUE is faster
# If sarestimate$sar=FALSE, this does also simulation without
# SAR-neighborhood dependent abundances.
# p.nb=NULL > ignore neighbors
regpop.sar <- function(abmat, prab01=NULL,
                       sarestimate=prab.sarestimate(abmat),
                    p.nb=NULL,
                    vector.species=prab01$regperspec,
                    pdf.regions=prab01$specperreg/(sum(prab01$specperreg)),
                   count=FALSE){
#  require(spdep)
#  require(mvtnorm)
  if (is.null(prab01)){
    prab01 <- prabinit(prabmatrix=toprab(abmat),rows.are.species=FALSE,
                      distance="none")
    vector.species=prab01$regperspec
    pdf.regions=prab01$specperreg/(sum(prab01$specperreg))
  }
  proble <- function(v,val) mean(v<=val, na.rm=TRUE)
  # single and regions total abundances log transformed
#  print("Computing the logs")
  logabund <- log(abmat$prab[prab01$prab[,1],1])
  species <- rep(1,sum(prab01$prab[,1]))
  region <- (1:abmat$n.regions)[prab01$prab[,1]]
  for (j in 2:abmat$n.species){
    logabund <- c(logabund,log(abmat$prab[prab01$prab[,j],j]))
    species <- c(species,rep(j,sum(prab01$prab[,j])))
    region <- c(region,(1:abmat$n.regions)[prab01$prab[,j]])
  }
  species <- as.factor(species)
  region <- as.factor(region)
  neighbors <- abmat$nb
  m01 <- matrix(FALSE, ncol = abmat$n.species, nrow = abmat$n.regions)
  out <- matrix(0, ncol = abmat$n.species, nrow = abmat$n.regions)
  cdf.local <- cdf.regions <- c()
  for (i in 1:abmat$n.regions) cdf.regions[i] <- sum(pdf.regions[1:i])
  for (i in 1:abmat$n.species){
    if (count) 
        cat("Species ", i, "\n")
    spec.regind <- spec.neighb <- rep(FALSE, abmat$n.regions)
    nsize <- vector.species[i]
    if (is.null(p.nb)){
      m01[,i] <- rep(FALSE,abmat$n.regions)
      m01[sample(abmat$n.regions,nsize,prob=pdf.regions),i] <- rep(TRUE,nsize)
    }
    else{
#      print(p.nb)
      r1 <- runif(1)
      reg <- 1 + sum(r1 > cdf.regions)
      spec.regind[reg] <- TRUE
      for (k in neighbors[[reg]]) spec.neighb[k] <- TRUE
      m01[reg, i] <- TRUE
      if (nsize > 1) 
        for (j in 2:nsize)
          if (all(!spec.neighb) | all(pdf.regions[spec.neighb] < 
           1e-08) | all(spec.neighb | spec.regind) |
             all(pdf.regions[!(spec.regind | spec.neighb)] < 1e-08)) {
              nreg <- sum(!spec.regind)
              pdf.local <- pdf.regions[!spec.regind]
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg) cdf.local[l] <- sum(pdf.local[1:l])
              r1 <- runif(1)
              zz <- 1 + sum(r1 > cdf.local[1:nreg])
              reg <- (1:abmat$n.regions)[!spec.regind][zz]
              spec.regind[reg] <- TRUE
              spec.neighb[reg] <- FALSE
              for (k in neighbors[[reg]]) spec.neighb[k] <- !(spec.regind[k])
              m01[reg, i] <- TRUE
          }
          else if (runif(1) < p.nb) {
              regs <- !(spec.regind | spec.neighb)
              nreg <- sum(regs)
              pdf.local <- pdf.regions[regs]
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg) cdf.local[l] <- sum(pdf.local[1:l])
              r1 <- runif(1)
              zz <- 1 + sum(r1 > cdf.local[1:nreg])
              reg <- (1:abmat$n.regions)[regs][zz]
              spec.regind[reg] <- TRUE
              for (k in neighbors[[reg]]) spec.neighb[k] <- !(spec.regind[k])
              m01[reg, i] <- TRUE
          }
          else {
              nreg <- sum(spec.neighb)
              pdf.local <- pdf.regions[spec.neighb]
              pdf.local <- pdf.local/sum(pdf.local)
              for (l in 1:nreg) cdf.local[l] <- sum(pdf.local[1:l])
              r1 <- runif(1)
              zz <- 1 + sum(r1 > cdf.local[1:nreg])
              reg <- (1:abmat$n.regions)[spec.neighb][zz]
              spec.regind[reg] <- TRUE
              spec.neighb[reg] <- FALSE
              for (k in neighbors[[reg]]) spec.neighb[k] <- !(spec.regind[k])
              m01[reg, i] <- TRUE
          }
    }
    iregions <- (1:abmat$n.regions)[m01[,i]]
    if (sarestimate$sar){
      inbmatrix <- matrix(0,nrow=nsize,ncol=nsize)
      for (j in 1:nsize)
        inbmatrix[j,(1:nsize)[iregions %in%
                                       abmat$nb[[iregions[j]]]]] <- 1
      inbmatrix <- sarestimate$lambda*sarestimate$nbweight*inbmatrix
#    print(iregions)
#    print(inbmatrix)
      invmatrix <- solve(diag(nsize)-inbmatrix)
      icov <- sarestimate$sigma^2*invmatrix %*% invmatrix
#    print(icov)
      ierror <- mvtnorm::rmvnorm(1,sigma=icov)
#    print(ierror)
    }
    else
      ierror <- rnorm(nsize,sd=sarestimate$sigma)      
    for (j in 1:nsize){
     abundmean <- sarestimate$intercept+sarestimate$speffects[i]+
            sarestimate$regeffects[iregions[j]]
     out[iregions[j],i] <- exp(abundmean+ierror[j])
#      print(abundmean)
    }
#    break
  }
  out
}

specgroups <- function (distmat,groupvector, groupinfo) 
{
    distmat <- as.matrix(distmat)
    nc <- ncol(distmat)
    sgd <- mgd <- numeric(0)
    sni <- 0
    for (i in 1:groupinfo$ng){
      gd <- distmat[groupvector==groupinfo$lg[i],
                    groupvector==groupinfo$lg[i]]
      ni <- groupinfo$nsg[i]
      ni <- ni*(ni-1)/2
      sni <- sni+ni
#      print(i)
#      print(gd)
      sgd[i] <- sum(gd[upper.tri(gd)])
      mgd[i] <- sgd[i]/ni
    }
#    print(gd)
#    print(sgd)
#    print(ni)
#    print(sni)
    overall <- sum(sgd)/sni
    out <- list(overall=overall,gr=mgd)
    out
}

"kulczynski" <-
function(regmat){
  nart <- ncol(regmat)
  jdist <- rep(0, nart*nart)
  dim(jdist) <- c(nart,nart)
  for (i in 1:(nart-1)){
#    cat("Row ",i,"\n")
    for (j in (i+1):nart){
      ri <- sum(regmat[,i])
      rj <- sum(regmat[,j])
      srij <- sum(regmat[,i]+regmat[,j]>=1.99) 
      jdist[j,i] <- jdist[i,j] <- 1 - 0.5* (srij/ri + srij/rj)
      if (is.na(jdist[i,j]))
        cat("Warning! NA at i=",i,", j=", j,"\n")
    }
  }
  jdist
}

\name{regdist}
\alias{regdist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Regression between subsets of dissimilarity matrices}
\description{
  Given two dissimilarity matrices \code{dmx} and \code{dmy} and an indicator
  vector \code{x}, this computes a standard least squares regression
  between the dissimilarity between objects indicated in \code{x}.
}

\usage{

regdist(x,dmx,dmy,xcenter=0,param)

}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{vector of logicals of length of the number of objects on which
    dissimilarities \code{dmx} and \code{dmy} are based.} 
  \item{dmx}{dissimilarity matrix or object of class
    \code{\link{dist}}. Explanatory  dissimilarities.}
  \item{dmy}{dissimilarity matrix or object of class
    \code{\link{dist}}. Response dissimilarities.}
  \item{xcenter}{numeric. Dissimilarities \code{dmx} are centered by
    this, i.e., this value is subtracted from the dissimilarities before
    regression.}
  \item{param}{1 or 2 or \code{NULL}. If 1 or 2, only the first or
    second parameter (intercept or slope) of the regression is given
    out.}
}

\value{
  If \code{param=NULL}, the output object of \code{\link{lm}}. If
  \code{param=1} the intercept. If
  \code{param=2} the slope. 
}
\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}



\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[1:20,],file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[1:20,],distance="jaccard")
  regdist(c(rep(TRUE,10),rep(FALSE,10)),ver.geo,vei$distmat,param=1)
}
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{geco}
\alias{geco}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{geco distance matrix}
\description{
  Computes geco distances between the columns of a 0-1-matrix, based on
  a distance matrix between regions (usually, but not necessarily, this is
  a geographical distance).
}
\usage{
geco(regmat,geodist=as.dist(matrix(as.integer(!diag(nrow(regmat))))),
                   transform="piece",
                   tf=0.1,
                   countmode=ncol(regmat)+1)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
  \item{geodist}{\code{dist}-object or symmetric non-negative matrix.
    Geographical distances between regions.}
  \item{transform}{transformation applied to the distances before
    computation of geco coefficient, see details. "piece" means
    piecewise linear, namely distance/(\code{tf}*maximum distance)
    if distance<\code{tf}*maximum distance, and 1 otherwise, "log" means
    \code{log((tf*distance)+1)}, "sqrt" means \code{sqrt(tf*distance)},
    "none" means no transformation.}
  \item{tf}{tuning constant for transformation. See \code{transform}.}
  \item{countmode}{optional positive integer. Every 'countmode' algorithm runs
          'geco' shows a message.}
}
\details{
  The geco distance between two species is 0.5*(mean distance
  between region where species 1 is present and closest region where
  species 2 is present plus mean distance
  between region where species 2 is present and closest region where
  species 1 is present). 'closest' to a region could be the regions
  itself. 
  It is recommended (Hennig and Hausdorf, 2006) to transform the
  distances first, because the differences between large distances are
  usually not meaningful or at least much less meaningful than
  differences between small distances for dissimilarity measurement
  between species ranges. See parameter \code{transform}.

  If the between-regions distance is 1 for all pairs of
  non-equal regions, the geco distance degenerates
  to the Kulczynski distance, see \code{kulczynski}.
}
\value{
  A symmetrical matrix of geco distances.
}

\references{
  Hennig, C. and Hausdorf, B. (2006)  A robust distance coefficient
  between distribution areas incorporating geographic distances.
  \emph{Systematic Biology} 55, 170-175.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{kulczynski}}
}

\examples{
options(digits=4)
data(kykladspecreg)
data(waterdist)
geco(t(kykladspecreg),waterdist)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{con.comp}
\alias{con.comp}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Connectivity components of an undirected graph}
\description{
  Computes the connectivity components of an undirected graph from a
  matrix giving the edges.
}
\usage{
con.comp(comat)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{comat}{a symmetric logical or 0-1 matrix, where \code{comat[i,j]=TRUE}
    means that there is an edge between vertices \code{i} and
    \code{j}. The diagonal is ignored.}
}
\details{
  The "depth-first search" algorithm of Cormen, Leiserson and Rivest
  (1990, p. 477) is used.
}
\value{
  An integer vector, giving the number of the connectivity component for
  each vertice.
}
\references{
  Cormen, T. H., Leiserson, C. E. and Rivest, R. L. (1990), \emph{Introduction
    to Algorithms}, Cambridge: MIT Press.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}



\seealso{
  \code{\link{hclust}}, \code{\link{cutree}} for cutted single linkage
  trees (often equivalent).
}

\examples{
  set.seed(1000)
  x <- rnorm(20)
  m <- matrix(0,nrow=20,ncol=20)
  for(i in 1:20)
    for(j in 1:20)
      m[i,j] <- abs(x[i]-x[j])
  d <- m<0.2
  cc <- con.comp(d)
  max(cc) # number of connectivity components
  plot(x,cc)
  # The same should be produced by
  # cutree(hclust(as.dist(m),method="single"),h=0.2).
}
\keyword{array}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line

\name{plotdistreg}
\alias{plotdistreg}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Plots for within-groups and between-groups distance regression}
\description{
  Visualisation of various regressions on distance (or dissimilarity)
  data where objects are from two groups.
}

\usage{
plotdistreg(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2],
                        cols=c(1,2,3,4),
                        pchs=rep(1,3),
                        ltys=c(1,2,1,2),
                        individual=TRUE,jointwithin=TRUE,jointall=TRUE,
                        oneplusjoint=TRUE,jittering=TRUE,bcenterline=TRUE,
                        xlim=NULL,ylim=NULL,xlab="geographical distance",
                        ylab="genetic distance",...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{dmx}{dissimilarity matrix or object of class
    \code{dist}. Explanatory dissimilarities (often these will be proper
    distances, but more general dissimilarities that do not
    necessarily fulfill the triangle inequality can be used, same for \code{dmy}).}
  \item{dmy}{dissimilarity matrix or object of class
    \code{dist}. Response dissimilarities.}
  \item{grouping}{something that can be coerced into a factor,
    defining the grouping of
    objects represented by the dissimilarities \code{dmx} and \code{dmy}
    (i.e., if \code{grouping} has length n, \code{dmx} and \code{dmy}
    must be dissimilarities between \code{n} objects).}
  \item{groups}{Vector of two levels. The two groups defining the
    regressions to be compared in the test. These can be
    factor levels, integer numbers, or strings, depending on the entries
    of \code{grouping}.}
  \item{cols}{vector of four colors (or color numbers) to be used for
    plotting distances 
    and regression lines within the first group, within the second group,
    distances between groups, and a line marking the center of the
    between-groups explanatory distances, see \code{col}-argument of
    \code{\link{par}}.}
  \item{pchs}{vector of three plot symbols (or numbers) to be used for
    plotting distances within the first group, within the second group,
    and distances between groups, see \code{pch}-argument of
    \code{\link{par}}.}
  \item{ltys}{vector of line type numbers to be used for single group
    within-group regression, both groups combined within-group
    regression, regression with all distances, and regression combining
    within-groups distances of one group with between-groups distances,
    see \code{lty}-argument of
    \code{\link{par}}.}
  \item{individual}{if \code{TRUE}, within-groups distances regression
    lines are shown for both groups.}
  \item{jointwithin}{if \code{TRUE}, the within-groups distances regression
    line for both groups combined is shown.}
  \item{jointall}{if \code{TRUE}, the regression
    line based on all distances is shown.}
  \item{oneplusjoint}{if \code{TRUE}, the regression lines combining
    within-groups distances of one group with between-groups distances
    are shown (the colors of these are the colors of the individual
    groups, the first two components of the \code{cols}-argument).}
  \item{jittering}{if \code{TRUE}, points are jittered to avoid
    overplotting.}
  \item{bcenterline}{if \code{TRUE}, a line is plotted to mark the
    center of the between-groups distances on the explanatory variable.}
  \item{xlim}{to be passed on to \code{\link{plot}}; the default is
    determined from the involved distances.}
  \item{ylim}{to be passed on to \code{\link{plot}}; the default is
    determined from the involved distances.}
  \item{xlab}{to be passed on to \code{\link{plot}}.}
  \item{ylab}{to be passed on to \code{\link{plot}}.}  
  \item{...}{optional arguments to be passed on to \code{\link{plot}}.}
}

\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{regeqdist}}, \code{\link{regdistbetween}},
  \code{\link{regdistbetweenone}}, \code{\link{regdistdiffone}}
}

\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[173:207,],file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[173:207,],distance="jaccard")

  species <-c(rep(1,13),rep(2,22))
  loggeo <- log(ver.geo+quantile(as.vector(as.dist(ver.geo)),0.25))
  plotdistreg(dmx=loggeo,dmy=vei$distmat,grouping=species,
  jointwithin=FALSE,jointall=FALSE,groups=c(1,2))
  legend(5,0.75,c("within species 1",
  "within species 2","species 1 and between","species 2 and between"),lty=c(1,1,2,2),col=c(1,2,1,2))
  plotdistreg(dmx=loggeo,dmy=vei$distmat,grouping=species,
  jointwithin=TRUE,jointall=TRUE,oneplusjoint=FALSE,groups=c(1,2))
  legend(5,0.75,c("within species 1",
  "within species 2","all distances","all within species"),lty=c(1,1,1,2),col=c(1,2,3,3))
  

}
\keyword{htest}% __ONLY ONE__ keyword per line
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{piecewiselin}
\alias{piecewiselin}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Piecewise linear transformation for distance matrices}
\description{
  Piecewise linear transformation for distance matrices, utility
  function for \code{geco}.
}
\usage{
piecewiselin(distmatrix, maxdist=0.1*max(distmatrix))
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmatrix}{symmetric (non-negative) distance matrix.}
  \item{maxdist}{non-negative numeric. Larger distances are transformed
    to constant 1.}
}
\details{
  Transforms large distances to 1, 0 to 0 and continuously linear between 0 and
  \code{maxdist}.
}
\value{
  A symmetrical matrix.
}
  
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{geco}}
}

\examples{
options(digits=4)
data(waterdist)
piecewiselin(waterdist)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{nastats}
\alias{nastats}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Missing values statistics for matrix}
\description{
  Computes column-wise and row-wise numbers of missing values. 
}

\usage{
  nastats(amatrix, nastr="--")
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{amatrix}{(any) matrix.}
  \item{nastr}{missing value indicator.}
}
  
\value{
  A list with components
  \item{narow}{vector of row-wise numbers of mixxing values.}
  \item{nacol}{vector of column-wise numbers of mixxing values.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\examples{
  xx <- cbind(c(1,2,3),c(0,0,1),c(5,3,1))
  nastats(xx,nastr=0)
}
\keyword{manip}% at least one, from doc/KEYWORDS

\name{build.ext.nblist}
\alias{build.ext.nblist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Internal: generates neighborhood list for diploid loci}
\description{
  This is for use in \code{\link{alleleinit}}.
  Given a neighborhood list of individuals, a new neighborhood list is
  generated in which there are two entries for each individual (entry 1
  and 2 refer to individual one, 3 and 4 to individual 2 and so
  on). Neighborhoods are preserved and additionally the two entries
  belonging to the same individual are marked as neighbors.
}

\usage{
  build.ext.nblist(neighbors,n.individuals=length(neighbors))
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{neighbors}{list of integer vectors, where each vector contains
    the neighbors of an individual.}
  \item{n.individuals}{integer. Number of individuals.}
}

  
\value{
  list with \code{2*n.inidividuals} vectors of integers as described
  above.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{alleleinit}}}

\examples{
  data(veronica)
  vnb <- coord2dist(coordmatrix=veronica.coord[1:20,], cut=20,
    file.format="decimal2",neighbors=TRUE)
  build.ext.nblist(vnb$nblist)
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{regdistbetweenone}
\alias{regdistbetweenone}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Testing equality of one within-group and between-two groups
  distances regression}
\description{
  Jackknife-based test for equality of two regressions between
  distances. Given two groups of objects, this tests whether the
  regression involving the distances within one of the groups is compatible
  with the regression involving the same within-group distances together
  with the between group distances.
}

\usage{
regdistbetweenone(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2],rgroup)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{dmx}{dissimilarity matrix or object of class
    \code{dist}. Explanatory dissimilarities (often these will be proper
    distances, but more general dissimilarities that do not
    necessarily fulfill the triangle inequality can be used, same for \code{dmy}).}
  \item{dmy}{dissimilarity matrix or object of class
    \code{dist}. Response dissimilarities.}
  \item{grouping}{something that can be coerced into a factor,
    defining the grouping of
    objects represented by the dissimilarities \code{dmx} and \code{dmy}
    (i.e., if \code{grouping} has length n, \code{dmx} and \code{dmy}
    must be dissimilarities between \code{n} objects).}
  \item{groups}{vector of two levels. The two groups defining the
    regressions to be compared in the test. These can be
    factor levels, integer numbers, or strings, depending on the entries
    of \code{grouping}.}
  \item{rgroup}{one of the levels in \code{groups}, denoting the group
    of which within-group dissimilarities are considered.}
}

\details{
  The null hypothesis that the regressions based on the distances
  within group \code{species} and based on these distances together with
  the between-groups distances are
  equal is tested using jackknife pseudovalues. The test statistic is
  the difference between fitted
  values with x (explanatory variable) fixed at the center of the
  between-group distances. The test is run one-sided, i.e., the null
  hypothesis is only rejected if the between-group distances are larger
  than expected under the null hypothesis, see below. For the jackknife,
  observations from both groups are left out one at a time. However, the
  roles of the two groups are different (observations from group
  \code{species} are used in both regressions whereas observations from
  the other group are only used in one of them), and therefore the
  corresponding jackknife pseudovalues can have different variances. To
  take this into account, variances are pooled, and the degrees of
  freedom of the t-test are computed by the Welch-Sattertwaithe
  approximation for aggregation of different variances.

  The test cannot be run and many components will be \code{NA} in case that
  within-group regressions or jackknifed within-group regressions are
  ill-conditioned.

  This was implemented having in mind an application in which the
  explanatory distances represent geographical distances, the response
  distances are genetic distances, and groups represent species or
  species-candidates. In this application, for testing whether the
  regression patterns are compatble with the two groups behaving like a
  single species, one would first use \code{regeqdist} to test whether a
  joint regression for the within-group distances of both groups makes
  sense. If this is not rejected, \code{regdistbetween} is run to see
  whether the between-group distances are compatible with the
  within-group distances. 
  If a joint regression on
  within-group distances is rejected by \code{regeqdist},
  \code{regdistbetweenone} can be
  used to test whether the between-group distances are at least
  compatible with the within-group distances of one of the groups, which
  can still be the case within a single species, see Hausdorf and Hennig
  (2019). This
  is only rejected if the between-group
  distances are larger than expected under equality of regressions,
  because if they are smaller, this is not an indication against the
  groups belonging together genetically. To this end,
  \code{regdistbetweenone} needs to be run twice using both groups as
  \code{species}. This will produce two p-values. The null hypothesis
  that the regressions are compatible for at least one group can be
  rejected if the maximum of the two p-values is smaller than the chosen
  significance level.
}

\value{
  list of class \code{"regdistbetween"} with components
  \item{pval}{p-value.} 
  \item{coeffdiff}{difference between regression fits (within-group
    together with between-groups distances
    minus within-group distances only) at \code{xcenterbetween}, see
    below.}
  \item{condition}{condition numbers of regressions, see \code{\link{kappa}}.}
  \item{lmfit}{list. Output objects of \code{\link{lm}} within the two groups.}
  \item{jr}{output object of \code{\link[bootstrap]{jackknife}} for difference
    between regression fitted values at \code{xcenterbetween}.}
  \item{xcenter}{mean of within-group distances for group \code{species}
    of explanatory variable, used for centering.}
  \item{xcenterbetween}{mean of between-groups distances of explanatory
    variable (after centering by \code{xcenter}); at this point
    regression fitted values are computed.}
  \item{tstat}{t-statistic.}
  \item{tdf}{degrees of freedom of t-statistic according to
    Welch-Sattertwaithe approximation.}
  \item{jackest}{jackknife-estimator of difference between regression
    fitted values at \code{xcenterbetween}.} 
  \item{jackse}{jackknife-standard error for
    \code{jackest}.}
  \item{jackpseudo}{vector of jacknife pseudovalues on which the test is
    based.}
  \item{groups}{see above.}
  \item{species}{see above.}
  \item{testname}{title to be printed out when using
    \code{print.regdistbetween}.}
}
\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
   \code{\link{regeqdist}}, \code{\link{regdistbetweenone}}
}

\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[173:207,],file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[173:207,],distance="jaccard")

  species <-c(rep(1,13),rep(2,22))
  loggeo <- log(ver.geo+quantile(as.vector(as.dist(ver.geo)),0.25))
  rtest3 <-
  regdistbetweenone(dmx=loggeo,dmy=vei$distmat,grouping=species,groups=c(1,2),rgroup=1)
  print(rtest3)
}
\keyword{htest}% __ONLY ONE__ keyword per line
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{con.regmat}
\alias{con.regmat}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Connected regions per species}
\description{
  Returns a vector of the numbers of connected regions per species for a
  presence-absence matrix.   
}
\usage{
con.regmat(regmat, neighbors, count = FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
  \item{neighbors}{A list with a component for every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a list \code{numeric(0)}.}
  \item{count}{logical. If \code{TRUE}, the number of the currently
    processed species is printed.}
}
\details{
  Uses \code{con.comp}.
}
\value{
  Vector of numbers of connected regions per species.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\note{Designed for use in \code{prabtest}.}

\seealso{\code{\link{con.comp}}, \code{\link{prabtest}}}

\examples{
data(nb)
set.seed(888) 
cp <- cluspop.nb(nb, p.nb=0.1, n.species=10, clus.specs=9,
                 reg.group=1:17,vector.species=c(10))
con.regmat(cp,nb)
}
\keyword{spatial}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line

\name{regdistdiffone}
\alias{regdistdiffone}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Regression difference within reference group and between-group dissimilarities}
\description{
  Given two dissimilarity matrices \code{dmx} and \code{dmy}, an indicator
  vector \code{x} and a grouping, this computes the difference between
  standard least squares regression predictions at point
  \code{xcenterbetween}. The regressions are based on the dissimilarities
  in \code{dmx} vs. \code{dmy} for objects indicated in
  \code{x}. \code{grouping} indicates the two groups, and the difference
  is computed between regressions based on (a) the within-group
  distances of the reference group \code{rgroup} and (b) these together
  with the between-group distances. 
}

\usage{

regdistdiffone(x,dmx,dmy,grouping,xcenter=0,xcenterbetween=0,rgroup)

}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{vector of logicals of length of the number of objects on which
    dissimilarities \code{dmx} and \code{dmy} are based.} 
  \item{dmx}{dissimilarity matrix or object of class
    \code{\link{dist}}. Explanatory  dissimilarities.}
  \item{dmy}{dissimilarity matrix or object of class
    \code{\link{dist}}. Response dissimilarities.}
  \item{grouping}{vector of length of the number of objects on which
    dissimilarities \code{dmx} and \code{dmy} are based. Grouping
    vector. Regressions will be based on the first two values that
    appear in \code{unique(grouping[x])} (note that objects that are not
    assigned to one of these groups will be ignored); normally
    \code{grouping} should indicate only
    two groups on the objects with \code{x=TRUE}, and then these are used.}
  \item{xcenter}{numeric. Dissimilarities \code{dmx} are centered by
    this, i.e., this value is subtracted from the dissimilarities before
    regression.}
  \item{xcenterbetween}{numeric. This specifies the x- (dissimilarity)
    value at which predictions from the two regressions are
    compared. Note that this is interpreted as after centering by
    \code{xcenter}.}
  \item{rgroup}{one of the values of \code{grouping}, specifying the
    reference group.}

}

\value{
  Difference between
  standard least squares regression predictions for the two regressions at point
  \code{xcenterbetween}.  
}

\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\seealso{
  \code{\link{regdistbetweenone}}
}
  
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}



\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[173:207,],
    file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[173:207,],distance="jaccard")

  species <-c(rep(1,13),rep(2,22))
  regdistdiffone(rep(TRUE,35),ver.geo,vei$distmat,grouping=species,
    xcenter=0,xcenterbetween=100,rgroup=2)

}
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{prabtest}
\alias{prabtest}
\alias{summary.prabtest}
\alias{print.summary.prabtest}

%- Also NEED an `\alias' for EACH other topic documented here.
\title{Parametric bootstrap test for clustering in presence-absence matrices}
\description{
  Parametric bootstrap test of a null model of i.i.d., but spatially
  autocorrelated species against clustering of the species' occupied
  areas (or alternatively nestedness). In spite of the lots of
  parameters, a standard execution (for the default test statistics, see
  parameter \code{teststat} below) will be \cr
  \code{prabmatrix <- prabinit(file="path/prabmatrixfile",
    neighborhood="path/neighborhoodfile")}\cr
  \code{test <- prabtest(prabmatrix)}\cr
  \code{summary(test)}\cr
  \bold{Note:} Data formats are described
  on the \code{prabinit} help page. You may also consider the example datasets
  \code{kykladspecreg.dat} and \code{nb.dat}. Take care of the
  parameter \code{rows.are.species} of \code{prabinit}.}


\usage{
prabtest(prabobject, teststat = "distratio", tuning = switch(teststat, 
    distratio = 0.25, lcomponent = floor(3 * ncol(prabobject$distmat)/4), 
    isovertice = ncol(prabobject$distmat), nn = 4, NA), times = 1000, 
    pd = NULL, prange = c(0, 1), nperp = 4, step = 0.1, step2=0.01,
                      twostep = TRUE, 
    sf.sim = FALSE, sf.const = sf.sim, pdfnb = FALSE, ignore.richness=FALSE) 


\method{summary}{prabtest}(object, above.p=object$teststat \%in\%
         c("groups","inclusions","mean"),
         group.outmean=FALSE,...)

\method{print}{summary.prabtest}(x, ...)

}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobject}{an object of class \code{prab} (presence-absence data), as
    generated by \code{prabinit}.}
  \item{teststat}{string, indicating the test statistics. \code{"isovertice"}:
    number of isolated vertices in the graph of \code{tuning}
    smallest distances
    between species. \code{"lcomponent"}: size of largest connectivity
    component in this graph. \code{"distratio"}: ratio between \code{tuning}
    smallest and largest distances. \code{"nn"}: average distance of species to
    \code{tuning}th nearest neighbor. 
    \code{"inclusions"}: number of inclusions between areas of different
    species (tests for nestedness structure, not for clustering).}
  \item{tuning}{integer or (if \code{teststat="distratio"}) numerical
    between 0 and 1. Tuning constant for test statistics, see
    \code{teststat}.}
  \item{times}{integer. Number of simulation runs.}
  \item{pd}{numerical between 0 and 1. The probability that a new
    region is drawn from the non-neighborhood of the previous regions
    belonging to a species under generation. If \code{NA} (the default),
    \code{prabtest} estimates this by function
    \code{autoconst}. Otherwise the next five parameters have no effect.}
  \item{prange}{numerical range vector, lower value not smaller than 0, larger
    value not larger than 1. Range where \code{pd} is to be found. Used
    by function \code{autoconst}.}
  \item{nperp}{integer. Number of simulations per \code{pd}-value. Used
    by function \code{autoconst}.}
  \item{step}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the first simulation. Used
    by function \code{autoconst}.}
  \item{step2}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the second simulation (see
    parameter \code{twostep}). Used
    by function \code{autoconst}.}
  \item{twostep}{logical. If \code{TRUE}, a first estimation step for
    \code{pd} is
    carried out in the whole \code{prange}, and then the final
    estimation is determined between the preliminary estimator
    \code{-5*step2} and \code{+5*step2}. Else, the first simulation
    determines the final estimator. Used
    by function \code{autoconst}.}
  \item{sf.sim}{logical. Indicates if the range sizes of the species
    are held fixed
    in the test simulation (\code{TRUE}) or generated from their empirical
    distribution in \code{x} (\code{FALSE}). See function \code{randpop.nb}.}
  \item{sf.const}{logical. Same as \code{sf.sim}, but for estimation of
    \code{pd} by \code{autoconst}.}
  \item{pdfnb}{logical. If \code{TRUE}, the probabilities of the regions
    are modified according to the number of neighboring regions in
    \code{randpop.nb}, see Hennig and Hausdorf (2002), p. 5. This is
    usually no improvement.}
  \item{ignore.richness}{logical. If \code{TRUE}, there is no assumption
    of species richnesses to differ between regions in the null model.
    Regionwise probabilities don't differ in the generation of null
    data.}
    \item{object}{object of class \code{prabtest}.}
  \item{above.p}{logical. \code{TRUE} means that for output from
    \code{abundtest} the p-value is
    \code{p.above}, otherwise \code{p.below}.}
  \item{group.outmean}{logical. If \code{TRUE} and
    \code{object$teststat="groups"}, statistics concerning the mean of
    all dissimilarities are given out by \code{print.summary.prabtest}.}    
  \item{x}{object of class \code{summary.prabtest}.}
  \item{\dots}{no meaning, necessary for print and summary methods.}

}
\details{
  From the original data, the distribution of the
  range sizes of the species, the autocorrelation parameter \code{pd}
  (estimated by \code{autoconst}) and the distribution on the regions
  induced by the relative species numbers are taken. With these
  parameters, \code{times} populations according to the null model
  implemented in \code{randpop.nb} are generated and the test statistic
  is evaluated. The resulting p-value is number of simulated statistic
  values more extreme than than the value of the original data\code{+1}
  divided by \code{times+1}. "More extreme" means smaller for
  \code{"lcomponent"}, \code{"distratio"}, \code{"nn"}, larger for
  \code{"inclusions"}, and
  twice the smaller number between the original statistic value and the
  "border", i.e., a two-sided test for \code{"isovertice"}.
  If \code{pd=NA} was
  specified, a diagnostic plot
  for the estimation of \code{pd} is plotted by \code{autoconst}.
  For details see Hennig
  and Hausdorf (2004) and the help pages of the cited functions. 
}
\value{
  \code{prabtest} prodices
  an object of class \code{prabtest}, which is a list with components
  \item{results}{vector of test statistic values for all simulated
    populations.}
  \item{datac}{test statistic value for the original data.'}
  \item{p.value}{the p-value.}
  \item{tuning}{see above.}
  \item{pd}{see above.}
  \item{reg}{regression coefficients from \code{autoconst}.}
  \item{teststat}{see above.}
  \item{distance}{the distance measure chosen, see \code{prabinit}.}
  \item{gtf}{the geco-distance tuning parameter (only informative if
    \code{distance="geco"}), see \code{prabinit}.}
  \item{times}{see above.}
  \item{pdfnb}{see above.}
  \item{ignore.richness}{see above.}

  \code{summary.prabtest} produces an object of class
  \code{summary.prabtest}, which is a list with components
  \item{rrange}{range of the simulation results (test statistic values)
    of \code{object}.}
  \item{rmean}{mean of the simulation results (test statistic values)
    of \code{object}.}
  \item{datac, p.value, pd, tuning, teststat, distance, times, pdfnb,
    abund, sarlambda}{directly
    taken from \code{object}, see \code{prabtest} and \code{abundtest}.}
  \item{groupinfo}{if \code{object$teststat="groups"}, components
    \code{rrangeg} (matrix of group-wise ranges of test statistic
    value), \code{rmeang} (vector of group-wise means of test statistic
    value), \code{rrangem} (range over simulations of overall mean of
    within-group dissimilarities), \code{rmeanm} (mean over simulations
    of overall mean of within-group dissimilarities) are added to the
    list \code{object$groupinfo}, and this is given out.}
}

\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
\url{http://stat.ethz.ch/Research-Reports/110.html}.

Hausdorf, B. and Hennig, C. (2003)  Biotic Element Analysis in
Biogeography. \emph{Systematic Biology} 52, 717-723.

Hausdorf, B. and Hennig, C. (2003) Nestedness of north-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.
}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{prabinit}} generates objects of class \code{prab}.
  
  \code{\link{autoconst}} estimates \code{pd} from such objects.
  
  \code{\link{randpop.nb}} generates populations from the null model.
  An alternative model is given by \code{\link{cluspop.nb}}.

  Some more information on the test statistics is given in
  \code{\link{homogen.test}}, \code{\link{lcomponent}},
  \code{\link{distratio}}, \code{\link{nn}},
  \code{\link{incmatrix}}.

  The simulations are computed by \code{\link{pop.sim}}.
}


\examples{
options(digits=4)
data(kykladspecreg)
data(nb)
set.seed(1234)
x <- prabinit(prabmatrix=kykladspecreg, neighborhood=nb)
# If you want to use your own ASCII data files, use
# x <- prabinit(file="path/prabmatrixfile",
# neighborhood="path/neighborhoodfile")
kpt <- prabtest(x, times=5, pd=0.35)
# These settings are chosen to make the example execution
# a bit faster; usually you will use prabtest(kprab).
summary(kpt)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{prab.sarestimate}
\alias{prab.sarestimate}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Estimates SAR model from log-abundance matrix of prab-object.}
\description{ 
  This is either an interface for the function \code{\link[spdep]{errorsarlm}}
  for abundance data stored in an object of class \code{\link{prab}}
  implemented for use in \code{\link{abundtest}}, or, in case that spatial
  information should be ignored, it estimates a two-way additive
  unreplicated linear
  model for log-abundances on factors species and region. 
}
\usage{
prab.sarestimate(abmat, prab01=NULL,sarmethod="eigen",
                             weightstyle="C",
                             quiet=TRUE, sar=TRUE,
                             add.lmobject=TRUE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{abmat}{object of class \code{prab}.}
  \item{prab01}{presence-absence matrix of same dimensions than the
  abundance matrix of \code{prabobj}. This specifies the presences and
  absences on which the presence/absence step of abundance-based tests
  is based (see details). If \code{NULL} (which is usually the only
  reasonable choice), \code{prab01} is computed in order to indicate
  the nonzeroes of \code{prabobj$prab}.}
\item{sarmethod}{this is passed on as parameter \code{method} to
  \code{\link[spdep]{errorsarlm}} and documented there. We don't have
  experience with any other choice than \code{"eigen"}.} 
  \item{weightstyle}{can take values "W", "B", "C", "U", and "S" though tests
    suggest that "C" should be chosen. See \code{\link[spdep]{nb2listw}}.} 
  \item{quiet}{this is passed on as parameter \code{quiet} to
  \code{\link[spdep]{errorsarlm}} and documented there.} 
  \item{sar}{logical. If \code{TRUE}, a simultaneous autoregression
    model is fitted by calling \code{\link[spdep]{errorsarlm}}. If
    \code{FALSE}, a two-way additive
    unreplicated linear
    model for log-abundances on factors species and region is computed
    by \code{\link[stats]{lm}},
    ignoring the spatial arrangement of the regions.} 
  \item{add.lmobject}{logical. If \code{TRUE}, the whole output object
    of \code{\link[spdep]{errorsarlm}} (or \code{lm}) is given out.} 
}
\value{
  A list with the following components:
  \item{sar}{see above.}
  \item{intercept}{numeric. Estimator of the intercept.}
  \item{sigma}{numeric. Estimator of error standard deviation.}
  \item{regeffects}{numeric vector. Estimator for region effects.}
  \item{speceffects}{numeric vector. Estimator for species effects.}
  \item{lamda}{numeric. Governs the degree of spatial
    autocorrelation. See \code{\link[spdep]{errorsarlm}}.}
  \item{size}{integer. Length of neighborhood list generated by
    \code{\link[spdep]{nb2listw}} used by
    \code{\link[spdep]{errorsarlm}}.}
  \item{nbweight}{numeric. Average weight of neighbors.}
  \item{lmobject}{if \code{add.lmobject=TRUE}, output object of either
     \code{\link[stats]{lm}} or \code{\link[spdep]{errorsarlm}}.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link[spdep]{errorsarlm}},
  \code{\link{abundtest}}
}

\examples{
  options(digits=4)
  data(siskiyou)
  x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
             distance="none")
#  Not run; this needs package spdep 
#  prab.sarestimate(x)
  prab.sarestimate(x, sar=FALSE)
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{qkulczynski}
\alias{qkulczynski}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Quantitative Kulczynski distance matrix}
\description{
  Computes quantitative Kulczynski distances between the columns of an
  abundance matrix.
}
\usage{
qkulczynski(regmat, log.distance=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{(non-negative) abundance matrix. Columns are species,
    rows are regions.}
  \item{log.distance}{logical. If \code{TRUE}, 1 is added to the
    abundance matrix and then the logs of the values are taken in order
    to compute the distance.}
}
\details{
  The quantitative Kulczynski distance between two species
  is 1-(mean of (mean of over regions minimum abundance of both
  species)/(sum of abundances of species 1) and (mean of over regions
  minimum abundance of both species)/(sum of abundances of species 2)).
  If the abundance matrix is a 0-1-matrix, this gives the standard
  Kulczynski distance.
}
\value{
  A symmetrical matrix of quantitative Kulczynski distances.
}

\references{
  D. P. Faith, P. R. Minchin and L. Belbin (1987) Compositional
  dissimilarity as a robust measure of ecological distance.
  \emph{Vegetation} 69, 57-68.
  }
  
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{kulczynski}}
}

\examples{
options(digits=4)
data(kykladspecreg)
qkulczynski(t(kykladspecreg))
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{siskiyou}
\alias{siskiyou}
\alias{siskiyou.nb}
\alias{siskiyou.groups}
\docType{data}
% \non_function{}
\title{Herbs of the Siskiyou Mountains}
\description{
  Distributions of species of herbs in relation to elevation on quartz
  diorite in the central Siskiyou Mountains. All values are per mille
  frequencies
  in transects (The number of 1 m2 quadrats, among 1000 such quadrats,
  in which a species was observed, based on 1250 1m2 quadrats in the
  first 5  transects, and 400 1m2 quadrats in 6. transect). Observed
  presences in the transect, outside the sampling plots, were coded as
  0.2. Rows correspond to species, columns correspond to regions.
}
\usage{data(siskiyou)}
\format{
  Three objects are generated:
  \describe{
  \item{siskiyou}{numeric matrix giving the 144*6 abundance values.}
  \item{siskiyou.nb}{neighborhood list for the 6 regions.}
  \item{siskiyou.groups}{integer vector of length 144, giving group
    memberships for the 144 species.}}
}
\source{
Whittaker, R. H. 1960. Vegetation of the Siskiyou Mountains, Oregon and
California. \emph{Ecol. Monogr}. 30: 279-338 (table 14).
}
\details{
  Reads from example data files \code{LeiMik1.dat, LeiMik1NB.dat,
    LeiMik1G.dat}.
  }

\examples{
data(siskiyou)
}
\keyword{datasets}

\name{alleleconvert}
\alias{alleleconvert}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Format conversion for codominant marker data}
\description{
  Codominant marker data (which here means: data with several diploid
  loci; two alleles per locus) can be represented in various ways. This
  function converts the formats \code{"genepop"} and \code{"structure"} into
  \code{"structurama"} and \code{"prabclus"}. \code{"genepop"}
  is a version of the format
  used by the package GENEPOP (Rousset, 2008), \code{"structure"} is a version
  of what is used by STRUCTURE (Pritchard et al., 2000), another one is
  \code{"structureb"}. \code{"structurama"}
  is a version of what is used by STRUCTURAMA (Huelsenbeck and
  Andolfatto, 2007) and \code{"prabclus"} is required by the function
  \code{\link{alleleinit}} in the present package.
}
\usage{
  alleleconvert(file=NULL,strmatrix=NULL, format.in="genepop",
                          format.out="prabclus",
                          alength=3,orig.nachar="000",new.nachar="-",
                          rows.are.individuals=TRUE, firstcolname=FALSE,
                          aletters=intToUtf8(c(65:90,97:122),multiple=TRUE),
                          outfile=NULL,skip=0)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{file}{string. Filename of input file, see details. One of
    \code{file} and \code{strmatrix} needs to be specified.}
  \item{strmatrix}{matrix or data frame of strings, see details. One of
    \code{file} and \code{strmatrix} needs to be specified.}
  \item{format.in}{string. One of \code{"genepop"},
    \code{"structure"}, or \code{"structureb"}, see details.}
  \item{format.out}{string. One of \code{"structurama"} or
    \code{"prabclus"}, see details.}
  \item{alength}{integer. If \code{format.in="genepop"}, length of code
    for a single allele.}
  \item{orig.nachar}{string. Code for missing values in input data.}
  \item{new.nachar}{string. Code for missing values in output data.}
  \item{rows.are.individuals}{logical. If \code{TRUE}, rows are
    interpreted as individuals and columns (variables if
    \code{strmatrix} is a data frame) as loci.}
  \item{firstcolname}{logical. If \code{TRUE}, it is assumed that the
    first column contains row names.}
  \item{aletters}{character vector. String of default characters for
    alleles if \code{format.out=="prabclus"} (the default is fine unless
    there is a locus that can have more than 62 different alleles in the
    dataset).}
  \item{outfile}{string. If specified, the output matrix (omitting
    quotes) is written to a file of this name (including row names if
    \code{fistcolname==TRUE}).}
  \item{skip}{number of rows to be skipped when reading data from a
      file (\code{skip}-argument of \code{\link{read.table}}).}
}
\details{
  The formats are as follows (described is the format within R, i.e.,
  for the input, the format of \code{strmatrix}; if \code{file} is
  specified, the file is read with
  \code{read.table(file,colClasses="character")} and should give the
  format explained below - note that \code{colClasses="character"}
  implies that quotes are not needed in the input file):
  \describe{
    \item{genepop}{Alleles are coded by strings of length \code{alength}
      and there is no space between the two alleles in a locus, so a
      value of \code{"258260"} means that in the corresponding locus the two
      alleles have codes 258 and 260.}
    \item{structure}{Alleles are coded by strings of arbitrary length.
      Two rows correspond to each inidividual, the first row containing
      the first alleles in all loci and the second row containing the
      second ones.}
    \item{structureb}{Alleles are coded by strings of arbitrary length.
      One row corresponds to each inidividual, containing first and
      second alleles in all loci (first and second allele of first locus, first
      and second allele of second locus etc.). This starts in the third
      row (first two have locus names and other information).}
    \item{structurama}{Alleles are coded by strings of arbitrary
      length. the two alleles in each locus are written with brackets
      around them and a comma in between, so \code{"258260"} in
      \code{"genepop"}
      corresponds to \code{"(258,260)"} in \code{"structurama"}.}
    \item{prabclus}{Alleles are coded by a single character and there is
      no space between the two alleles in a locus (e.g.,
      \code{"AC"}).}
  }
}

\value{
  A matrix of strings in the format specified as \code{format.out} with
  an attribute \code{"alevels"}, a vector of all used allele codes if
  \code{format.out=="prabclus"}, otherwise vector of allele codes of
  last locus.  
}
\references{
  Huelsenbeck, J. P., and P. Andolfatto (2007) Inference of population
  structure under a Dirichlet process model. \emph{Genetics} 175,
  1787-1802.
  
  Pritchard, J. K., M. Stephens, and P. Donnelly (2000) Inference of
  population structure using multi-locus genotype data. \emph{Genetics}
  155, 945-959.
  
  Rousset, F. (2008) genepop'007: a complete re-implementation of the
  genepop software for Windows and Linux. \emph{Molecular Ecology
  Resources} 8, 103-106.


}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{alleleinit}}
}

\examples{
  data(tetragonula)
# This uses example data file Heterotrigona_indoFO.dat
  str(alleleconvert(strmatrix=tetragonula))
  strucmatrix <-
    cbind(c("I1","I1","I2","I2","I3","I3"),
    c("122","144","122","122","144","144"),c("0","0","21","33","35","44"))
  alleleconvert(strmatrix=strucmatrix,format.in="structure",
    format.out="prabclus",orig.nachar="0",firstcolname=TRUE)
  alleleconvert(strmatrix=strucmatrix,format.in="structure",
    format.out="structurama",orig.nachar="0",new.nachar="-9",firstcolname=TRUE)
}
\keyword{manip}% __ONLY ONE__ keyword per line

\name{unbuild.charmatrix}
\alias{unbuild.charmatrix}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Internal: create allele list out of character matrix}
\description{
  Creates a list of lists, such as required by \code{\link{alleledist}},
  from the \code{charmatrix} component of an
  \code{\link{alleleobject}}. 
}

\usage{
   unbuild.charmatrix(charmatrix,n.individuals,n.variables)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{charmatrix}{matrix of characters in which there are two rows for
    every individual corresponding to the two alleles in every locus
    (column). Entries are allele codes but missing values are coded as
    \code{NA}.}  
  \item{n.individuals}{integer. Number of individuals.}
  \item{n.variables}{integer. Number of loci.}
}
  
\value{
  A list of lists. In the "outer" list, there are
  \code{n.variables} lists, one for each locus. In the "inner" list, for every
    individual there is a vector of two codes (typically characters, see
    \code{\link{alleleinit}}) for the two alleles in that locus.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{alleleinit}}, \code{\link{build.charmatrix}}}

\examples{
  data(tetragonula)
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[1:50,],cut=50,file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[1:50,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist,distance="none")
  str(unbuild.charmatrix(tai$charmatrix,50,13)) 
}
\keyword{manip}% at least one, from doc/KEYWORDS

\name{hprabclust}
\alias{hprabclust}
\alias{print.comprabclust}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Clustering of species ranges from presence-absence matrices
  (hierarchical methods)}
\description{
  Clusters a presence-absence matrix object by taking the
  'h-cut'-partition of a hierarchical clustering and
  declaring all members of too small clusters as 'noise' (this gives a
  distance-based clustering method, which estimates the number of
  clusters and allows for noise/non-clustered points). Note that this
  is experimental. Often, the \code{prabclust}-solutions
  is more convincing due to higher flexibility of that method. However,
  \code{hprabclust} may be more stable sometimes.
  
  \bold{Note:} Data formats are described
  on the \code{prabinit} help page. You may also consider the example datasets
  \code{kykladspecreg.dat} and \code{nb.dat}. Take care of the
  parameter \code{rows.are.species} of \code{prabinit}.
}

\usage{
hprabclust(prabobj, cutdist=0.4, cutout=1,
method="average", nnout=2, mdsplot=TRUE, mdsmethod="classical")

\method{print}{comprabclust}(x, ...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobj}{object of class \code{prab} as
    generated by \code{prabinit}. Presence-absence data to be analyzed.}
  \item{cutdist}{non-negative integer. Cutoff distance to determine the
    partition, see \code{cutree}.}
  \item{cutout}{non-negative integer. Points that have at most
    \code{nnout} distances smaller or equal than \code{cutout} are
    treated as noise.}
  \item{method}{string. Clustering method, see \code{hclust}.}
  \item{nnout}{non-negative integer. Members of clusters with less or
    equal than \code{nnout} points or that have less or equal than
    \code{nnout} neighbors closer than \code{cutout} are treated as noise.}
  \item{mdsplot}{logical. If \code{TRUE}, the cluster solution is
    plotted on the first two MDS dimensions, see \code{mdsmethod}.}
  \item{mdsmethod}{\code{"classical"}, \code{"kruskal"}, or
    \code{"sammon"}. The MDS method
    to transform the distances to data points. \code{"classical"} indicates
    metric MDS by function \code{cmdscale}, \code{"kruskal"} is
    non-metric MDS. Note that if \code{mdsmethod!="classical"} zero
    distances between different objects are replaced by the minimum of
    the nonzero distances divided by 10 (otherwise the MDS method would
    produce an error). Note that \code{mdsmethod} is ignored if
    \code{mdsplot=FALSE}.}
  \item{x}{\code{comprabclust}-object as generated by \code{hprabclus}.}
  \item{...}{necessary for print method.}
}

\value{
  \code{hprabclust} generates an object of class \code{comprabclust}. This is a
  list with components
  \item{clustering}{vector of integers indicating the cluster memberships of
    the species (\code{cutout}-outliers are noise, but small clusters
    are allowed). Noise is coded as 0.}
  \item{rclustering}{vector of integers indicating the cluster memberships of
    the species, noise as described under \code{nnout}.
    Noise is coded as 0.}
  \item{cutdist}{see above.}
  \item{method}{see above.}
  \item{cutout}{see above.}
  \item{nnout}{see above.}
  \item{noisen}{number of points minus \code{cutout}-outliers.}
  \item{symbols}{vector of characters corresponding to \code{rclustering}, but
    estimated noise by \code{"N"}.}
  \item{points}{numerical matrix. MDS configuration (if \code{mdsplot=TRUE}).}
  \item{call}{function call.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{hclust}}, \code{\link{cutree}},
  \code{\link{prabclust}}.
}

\examples{
data(kykladspecreg)
data(nb)
data(waterdist)
x <- prabinit(prabmatrix=kykladspecreg, neighborhood=nb,
              geodist=waterdist, distance="geco")
hprabclust(x,mdsplot=FALSE)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{crmatrix}
\alias{crmatrix}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Region-wise cluster membership}
\description{
  Produces a matrix with clusters as rows and regions as columns,
  indicating how many species present in a region belong to the clusters
}
\usage{
crmatrix(x,xc,percentages=FALSE)

}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{object of class \code{prab} as
    generated by \code{prabinit}. Presence-absence data to be analyzed.}
  \item{xc}{object of class \code{prabclust} or \code{comprabclust}
    as generated by \code{prabclust} or \code{hprabclust}. The
    clustering.}
  \item{percentages}{logical. If \code{TRUE}, the output matrix will
    give the proportion of species from a certain region in the cluster.}
}

\value{
  A clusters time regions matrix as explained above.
}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}
}

\examples{
\donttest{
  options(digits=3)
  data(kykladspecreg)
  data(nb)
  set.seed(1234)
  x <- prabinit(prabmatrix=kykladspecreg, neighborhood=nb)
  xc <- prabclust(x)

  crmatrix(x,xc)
  crmatrix(x,xc, percentages=TRUE)
}
}

\keyword{spatial}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line

\name{nn}
\alias{nn}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Mean distance to kth nearest neighbor}
\description{
  Computes the mean of the distances from each point to its \code{ne}th
  nearest neighbor.
}
\usage{
nn(distmat, ne = 1)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmat}{symmetric distance matrix (not a \code{dist}-object).}
  \item{ne}{integer.}
}
\value{
  numerical.
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{\code{\link{prabtest}}}

\examples{
data(kykladspecreg)
j <- jaccard(t(kykladspecreg))
nn(j,4)
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{build.charmatrix}
\alias{build.charmatrix}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Internal: create character matrix out of allele list}
\description{
  For use in \code{\link{alleleinit}}.
  Creates a matrix of characters in which there are two rows for
    every individual corresponding to the two alleles in every locus
    (column) out of a list of lists, such as required by
    \code{\link{alleledist}}.
}

\usage{
   build.charmatrix(allelelist,n.individuals,n.variables)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{allelelist}{A list of lists. In the "outer" list, there are
  \code{n.variables} lists, one for each locus. In the "inner" list, for every
    individual there is a vector of two codes (typically characters, see
    \code{\link{alleleinit}}) for the two alleles in that locus.}  
  \item{n.individuals}{integer. Number of individuals.}
  \item{n.variables}{integer. Number of loci.}
}
  
\value{
  A matrix of characters in which there are two rows for
    every individual corresponding to the two alleles in every locus
    (column). 
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{alleleinit}}, \code{\link{unbuild.charmatrix}}}

\examples{
  alist <- list()
  alist[[1]] <- list(c("A","A"),c("B","A"),c(NA,NA))
  alist[[2]] <- list(c("A","C"),c("B","B"),c("A","D"))
  build.charmatrix(alist,3,2)
}
\keyword{manip}% at least one, from doc/KEYWORDS

\name{distratio}
\alias{distratio}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Distance ratio test statistics for distance based clustering}
\description{
  Calculates the ratio between the \code{prop} smallest and largest
  distances of a distance matrix.
}
\usage{
distratio(distmat, prop = 0.25)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmat}{symmetric distance matrix.}
  \item{prop}{numerical. Proportion between 0 and 1.}
}

\details{
  Rounding is by \code{floor} for small and \code{ceiling} for large
  distances.
}

\value{
  A list with components
  \item{dr}{ratio of \code{prop} smallest to \code{prop} largest distances.}
  \item{lowmean}{mean of \code{prop} smallest distances.}
  \item{himean}{mean of \code{prop} smallest distances.}
  \item{prop}{see above.}
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges.
\emph{Computational Statistics and Data Analysis} 45, 875-896.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{\code{\link{prabtest}}}

\examples{
options(digits=4)
data(kykladspecreg)
j <- jaccard(t(kykladspecreg))
distratio(j)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
% \keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{incmatrix}
\alias{incmatrix}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Nestedness matrix}
\description{
  Computes species*species nestedness matrix and number of nestings
  (inclusions) from regions*species presence-absence matrix.
}
\usage{
incmatrix(regmat)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
}

\value{
  A list with components
  \item{m}{0-1-matrix. \code{m[i,j]=1} means that the occupied region of
  species j is a subset (not equal) of the region of species i.}
  \item{ninc}{integer. Number of strict inclusions.}
  \item{neq}{integer. Number of region equalities between species (not
    including equality between species i and i).}
}
\references{
Hausdorf, B. and Hennig, C. (2003) Nestedness of nerth-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.

}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}



\seealso{
  \code{\link{prabtest}}
}


\examples{
data(kykladspecreg)
incmatrix(t(kykladspecreg))$ninc
}
\keyword{spatial}% at least one, from doc/KEYWORDS
\keyword{array}

\name{communities}
\alias{communities}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Construct communities from individuals}
\description{
  Construct communities from individuals using geographical distance and
  hierarchical clustering. Communities are clusters of geographically
  close individuals, formed by \code{\link{hclust}} with specified
  distance cutoff.
}

\usage{
communities(geodist,grouping=NULL,
                        cutoff=1e-5,method="single")
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{geodist}{\code{dist}-object or matrix of geographical distances
    between individuals.}
  \item{grouping}{something that can be coerced into a factor. Different
    groups indicated by \code{grouping} cannot be together in the same
    community. (If \code{NULL}, there is no constraint.)}
  \item{cutoff}{numeric; clustering distance cutoff value, passed on as
    parameter \code{h} to \code{cutree}. Note that if this is smaller
    than the smallest nonzero geographical distance, communities will be
    all sets of individuals that have zero geographical distance to each
    other.}
  \item{method}{\code{method}-parameter for \code{\link{hclust}}.}
}

\value{
  Vector of community memberships for the individuals (integer numbers
  from 1 to the number of communities without interruption.
}

    
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{communitydist}}
}

\examples{
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[1:90,],file.format="decimal2")
  species <-c(rep(1,64),rep(2,17),rep(3,9))
  communities(ver.geo,species)
  
}
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{alleledist}
\alias{alleledist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Shared allele distance for diploid loci}
\description{
  Shared allele distance for codominant markers (Bowcock et al., 1994).
  One minus proportion of alleles shared by two individuals averaged
  over loci (loci with missing values for at least one individual are
  ignored).
}
\usage{
  alleledist(allelelist,ni,np,count=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{allelelist}{a list of lists. In the "outer" list, there are
    \code{np} lists, one for each locus. In the "inner" list, for every
    individual there is a vector of two codes (typically characters, see
    \code{\link{alleleinit}}) for the two alleles in that locus. Such a
    list can be constructed by \code{\link{unbuild.charmatrix}} out of
    the \code{charmatrix} component of an output object of
    \code{\link{alleleinit}}.}
  \item{ni}{integer. Number of individuals.}
  \item{np}{integer. Number of loci.}
  \item{count}{logical. If \code{TRUE}, the number of the individual to
    be processed is printed.}
}

\value{
  A symmetrical matrix of shared allele distances between individuals.
}

\references{
  Bowcock, A. M., Ruiz-Linares, A., Tomfohrde, J., Minch, E., Kidd, J. R.,
  Cavalli-Sforza, L. L. (1994) High resolution of human evolutionary
  trees with polymorphic microsatellites. \emph{Nature} 368, 455-457.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
%-  \code{\link{chorddist}},\code{\link{neidist}},
  \code{\link{alleleinit}}, \code{\link{unbuild.charmatrix}}
}

\examples{
  data(tetragonula)
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[1:50,],cut=50,file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[1:50,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist,distance="none")
  str(alleledist((unbuild.charmatrix(tai$charmatrix,50,13)),50,13)) 
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{prabclus-package}
\alias{prabclus-package}
%- Also NEED an `\alias' for EACH other topic documented here.
\docType{package}
\title{prabclus package overview}
\description{
  Here is a list of the main functions in package prabclus. Most other
  functions are auxiliary functions for these.
}
\section{Initialisation}{
  \describe{
    \item{prabinit}{Initialises presence/absence-, abundance- and
      multilocus data with dominant markers for use with most other key
      prabclus-functions.}
    \item{alleleinit}{Initialises multilocus data with codominant
      markers for use with key prabclus-functions.}
    \item{alleleconvert}{Generates the input format required by
      \code{\link{alleleinit}}.}
    }}
\section{Tests for clustering and nestedness}{
  \describe{
    \item{prabtest}{
      Computes the tests introduced in Hausdorf and Hennig (2003) and
      Hennig and Hausdorf (2004; these tests occur in some further 
      publications of ours but this one is the most detailed statistical
      reference) for presence/absence data. Allows use of the
      geco-dissimilarity (Hennig and Hausdorf, 2006).}
    \item{abundtest}{
      Computes the test introduced in Hausdorf and Hennig (2007) for
      abundance data.}
    \item{homogen.test}{A classical distance-based test for homogeneity
      going back to Erdos and Renyi (1960) and Ling (1973).}
    }}
\section{Clustering}{
  \describe{
    \item{prabclust}{Species clustering for biotic element analysis
      (Hausdorf and Hennig, 2007, Hennig and Hausdorf, 2004 and others),
      clustering of individuals for species delimitation (Hausdorf and
      Hennig, 2010) based on Gaussian mixture model clustering with
      noise as implemented in R-package \code{mclust}, Fraley and
      Raftery (1998),  on output of
      multidimensional scaling from distances as computed by
      \code{\link{prabinit}} or \code{\link{alleleinit}}. See also
      \code{\link{stressvals}} for help with choosing the number of
      MDS-dimensions.} 
    \item{hprabclust}{An unpublished alternative to
      \code{\link{prabclust}} using hierarchical clustering methods.}
    \item{lociplots}{Visualisation of clusters of genetic markers vs.
      clusters of species.}
    \item{NNclean}{Nearest neighbor based classification of observations
      as noise/outliers according to Byers and Raftery (1998).}
}}
\section{Dissimilarity matrices}{
  \describe{
    \item{alleledist}{Shared allele distance (see the corresponding help
      pages for references).}
    \item{dicedist}{Dice distance.}
    \item{geco}{geco coefficient, taking geographical distance into account.}
    \item{jaccard}{Jaccard distance.}
    \item{kulczynski}{Kulczynski dissimilarity.}
    \item{qkulczynski}{Quantitative Kulczynski dissimilarity for
      abundance data.}
}}
\section{Communities}{
  \describe{
    \item{communities}{Constructs communities from geographical
      distances between individuals.}
    \item{communitydist}{chord-, phiPT- and various versions of the
      shared allele distance between communities.}
}}
\section{Tests for equality of dissimilarity-based regression}{
  \describe{
    \item{regeqdist}{Jackknife-based test for equality of
      two independent regressions between distances (Hausdorf and Hennig
      2019).}
    \item{regdistbetween}{Jackknife-based test for equality of
      regression involving all distances and regression involving
      within-group distances only (Hausdorf and Hennig
      2019).}
    \item{regdistbetweenone}{Jackknife-based test for equality of
      regression involving within-group distances of a reference group
      only and regression involving between-group distances (Hausdorf
      and Hennig 2019).}
}}
\section{Small conversion functions}{
  \describe{
    \item{coord2dist}{Computes geographical distances from geographical
      coordinates.}
    \item{geo2neighbor}{Computes a neighborhood list from geographical
      distances.}
    \item{alleleconvert}{A somewhat restricted function for conversion
      of different file formats used for genetic data with codominant markers.}
}}
\section{Data sets}{
      \code{\link{kykladspecreg}}, \code{\link{siskiyou}},
  \code{\link{veronica}}, \code{\link{tetragonula}}.
}

\references{
  Byers, S. and Raftery, A. E. (1998) Nearest-Neighbor Clutter
Removal for Estimating Features in Spatial Point Processes,
\emph{Journal of the American Statistical Association}, 93, 577-584.

  Erdos, P. and Renyi, A. (1960) On the evolution of random
  graphs. \emph{Publications of the Mathematical Institute of the
  Hungarian Academy of Sciences} 5, 17-61.

  Fraley, C.  and Raftery, A. E. (1998) How many clusters? Which
  clusterin method? - Answers via Model-Based Cluster Analysis.
  \emph{Computer Journal} 41, 578-588.

  Hausdorf, B. and Hennig, C. (2003) Nestedness of north-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.

  Hausdorf, B. and Hennig, C. (2007) Null model tests of clustering of
  species, negative co-occurrence patterns and nestedness in meta-communities.
  \emph{Oikos} 116, 818-828. 

  Hausdorf, B. and Hennig, C. (2010) Species Delimitation Using Dominant
  and Codominant Multilocus Markers. \emph{Systematic Biology}, 59, 491-503.

  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

  Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.

  Hennig, C. and Hausdorf, B. (2006)  A robust distance coefficient
  between distribution areas incorporating geographic distances.
  \emph{Systematic Biology} 55, 170-175.

  Ling, R. F. (1973) A probability theory of cluster
  analysis. \emph{Journal of the American Statistical Association} 68,
  159-164.

}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en/}
}

\name{tetragonula}
\alias{tetragonula}
\alias{tetragonula.coord}
\docType{data}
% \non_function{}
\title{Microsatellite genetic data of Tetragonula bees}
\description{
  Genetic data for 236 Tetragonula (Apidae) bees from Australia
  and Southeast Asia, see  Franck et al. (2004). The data give pairs of
  alleles (codominant markers) for 13 microsatellite loci.
}
\usage{data(tetragonula)}
\format{
  Two objects are generated:
  \describe{
    \item{tetragonula}{A data frame with 236 observations and 13 string
 variables. Strings consist of six digits each. The
 format is derived from the data format used by the software GENEPOP
 (Rousset 2008). Alleles have a three digit code, so a value of
 \code{"258260"} on variable V10 means that on locus 10 the two alleles have
 codes 258 and 260. \code{"000"} refers to missing values.}
\item{tetragonula.coord}{a 236*2 matrix. Coordinates of locations of
    individuals in decimal format, i.e. the first number is latitude
    (negative values are South), with minutes and seconds
    converted to fractions. The second number is longitude (negative
    values are West).}
  }
}
\source{
  Franck, P., E. Cameron, G. Good, J.-Y. Rasplus, and B. P. Oldroyd
  (2004) Nest architecture and genetic differentiation in a species
  complex of Australian stingless bees. \emph{Mol. Ecol.} 13, 2317-2331.

  Rousset, F. (2008) genepop'007: a complete re-implementation of the
  genepop software for Windows and Linux. \emph{Molecular Ecology
  Resources} 8, 103-106.
}
\details{
   Reads from example data file \code{Heterotrigona_indoFO.dat}. 
   }

\examples{
data(tetragonula)
}
\keyword{datasets}

\name{specgroups}
\alias{specgroups}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Average within-group distances for given groups}
\description{
  Generates average within-group distances (overall and group-wise) from
  a dissimilarity matrix and a given grouping.  
}
\usage{
  specgroups(distmat,groupvector, groupinfo) 
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmat}{dissimilarity matrix or \code{dist}-object.}
  \item{groupvector}{integer vector. For every row of \code{distmat},
  a number indicating the group membership.}
  \item{groupinfo}{list with components \code{lg} (levels of
    \code{groupvector}), \code{ng} (number of groups), \code{nsg}
    (vector of group sizes).}
}
\value{
  A list with parameters 
\item{overall}{overall average within-groups dissimilarity.}
\item{gr}{vector of group-wise average within-group dissimilarities
  (this will be \code{NaN} if the group size is only 1).}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\examples{
  options(digits=4)
  data(siskiyou)
  x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
              distance="logkulczynski")  
  groupvector <- as.factor(siskiyou.groups)
  ng <- length(levels(groupvector))
  lg <- levels(groupvector)
  nsg <- numeric(0)
    for (i in 1:ng) nsg[i] <- sum(groupvector==lg[i])
  groupinfo <- list(lg=lg,ng=ng,nsg=nsg)
  specgroups(x$distmat,groupvector,groupinfo)
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{alleleinit}
\alias{alleleinit}
\alias{alleleobject}
\alias{print.alleleobject}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Diploid loci matrix initialization}
\description{
  \code{alleleinit} converts genetic data with diploid loci as generated
  by \code{\link{alleleconvert}} into an object of class
  \code{alleleobject}. \code{print.alleleobject} is a print method for such
  objects.
}

\usage{
alleleinit(file = NULL, allelematrix=NULL,
                        rows.are.individuals = TRUE, 
    neighborhood = "none", distance = "alleledist", namode="variables",
                       nachar="-", distcount=FALSE) 


\method{print}{alleleobject}(x, ...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{file}{string. File name. File must be in \code{"prabclus"}
    format, see details. Either \code{file}
    or \code{allelematrix} needs to be specified.}
  \item{allelematrix}{matrix in \code{"prabclus"}-format as generated by
    \code{\link{alleleconvert}}, see details. Either \code{file}
    or \code{allelematrix} needs to be specified. }
  \item{rows.are.individuals}{logical. If \code{TRUE}, rows are interpreted
    as individuals and columns are interpreted as loci.}
  \item{neighborhood}{A string or a list with a component for
    every individual. The
    components are vectors of integers indicating
    neighboring individuals. An individual without neighbors 
    should be assigned a vector \code{numeric(0)}. If \code{neighborhood}
    is a filename, it is attempted to read such a list from a file,
    where every row should correspond to one region (such as example
    dataset \code{nb.dat}). If
    \code{neighborhood="none"}, all neighborhoods are set to
    \code{numeric(0)}. The neighborhood can be tested by
    \code{\link{nbtest}} for consistency.}
  \item{distance}{\code{"alleledist"}
%-    \code{"chord"}, \code{"nei"},
    or \code{"none"}. The distance measure
    between individuals to compute by \code{alleleinit}.}
  \item{namode}{one of \code{"single"}, \code{"individuals"},
    \code{"variables"} , or \code{"none"}. Determines whether a
    single probability for the entry to be missing is computed for a
    single locus of an individual (\code{"single"}), a vector of
    individual-wise probabilities for loci to be missing
    (\code{"individuals"}), a vector of loci-wise probabilities for
    individuals to be missing (\code{"variables"}) or no missingness
    probability at all.}
  \item{nachar}{character denoting missing values.}
  \item{distcount}{logical. If \code{TRUE}, during distance computation
    individuals are counted on the screen.} 
  \item{x}{object of class \code{alleleobject}.}
  \item{...}{necessary for print method.}
}

\details{
  The required input format is the output format \code{"prabclus"} of
  \code{\link{alleleconvert}}. Alleles are coded by a single character,
  so diploid loci need to be pairs of characters without space between
  the two alleles (e.g., "AC"). The input needs to be an
  individuals*loci matrix or data frame (or a file that produces such
  a data frame by \code{read.table(file,stringsAsFactors=FALSE)}) 
}

\value{
  \code{alleleinit} produces 
  an object of class \code{alleleobject} (note that this is similar to
  class \code{\link{prab}}; for example both can be used with
  \code{\link{prabclust}}), which is a list with components
  \item{distmat}{distance matrix between individuals.}
  \item{amatrix}{data frame of input data with string variables in the
    input format, see details.  Note that in the
    output for an individual the whole locus is declared missing if at
    least one of its alleles is missing in the input.}
  \item{charmatrix}{matrix of characters in which there are two rows for
    every individual corresponding to the two alleles in every locus
    (column). Entries are allele codes but missing values are coded as
    \code{NA}.}  
  \item{nb}{neighborhood list, see above.}
  \item{ext.nblist}{a neighborhood list in which for every row in
    \code{charmatrix} the second row number corresponding to the
    neighboring individuals is listed.} 
  \item{n.variables}{number of loci.}
  \item{n.individuals}{number of individuals.}
  \item{n.levels}{maximum number of different alleles in a locus.}
  \item{n.species}{identical to \code{n.individuals} used for
    compatibility with \code{prabclust}.}
  \item{alevels}{character vector with all used allele codes not
    including missing values.}
  \item{leveldist}{matrix in which rows are loci, columns are alleles
    and entries are frequencies of alleles per locus.}
  \item{prab}{useless matrix of number of factor levels corresponding to
    \code{amatrix} added for compatibility with objects of class
    \code{prab}.}
  \item{regperspec}{vector of row-wise sums of \code{prab} added for
    compatibility with objects of class \code{prab}.}
  \item{specperreg}{vector of column-wise sums of \code{prab} added for
    compatibility with objects of class \code{prab}.}
  \item{distance}{string denoting the chosen distance measure, see above.}
  \item{namode}{see above.}
  \item{naprob}{probability of missing values, numeric or vector, see
    documentation of argument \code{namode}.}
  \item{nasum}{number of missing entries (individual/loci) in
    \code{amatrix}.}
  \item{nachar}{see above.}
  \item{spatial}{logical. \code{TRUE} if a neighborhood was submitted.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{alleleconvert}}, \code{\link{alleledist}},
  \code{\link{prabinit}}.
%-  \code{\link{neidist}}, \code{\link{chorddist}}   
}

\examples{
# Only 50 observations are used in order to have a fast example.
  data(tetragonula)
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[1:50,],cut=50,file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[1:50,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist)
  print(tai)
}
\keyword{spatial}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line
\keyword{manip}

\name{lcomponent}
\alias{lcomponent}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Largest connectivity component}
\description{
  Computes the size of the largest connectivity component of the graph
  of \code{ncol(distmat)} vertices with edges defined by the smallest
  \code{ne} distances.
}
\usage{
lcomponent(distmat, ne = floor(3*ncol(distmat)/4))
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmat}{symmetric distance matrix.}
  \item{ne}{integer.}
}

\value{
  list with components
  \item{lc}{size of the largest connectivity component.}
  \item{ne}{see above.}
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{prabtest}}}

\examples{
data(kykladspecreg)
j <- jaccard(t(kykladspecreg))
lcomponent(j)
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{regdistbetween}
\alias{regdistbetween}
\alias{print.regdistbetween}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Testing equality of within-groups and between-groups distances regression}
\description{
  Jackknife-based test for equality of two regressions between
  distances. Given two groups of objects, this tests whether the
  regression involving all distances is compatible with the regression
  involving within-group distances only.
}

\usage{
regdistbetween(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2])

\method{print}{regdistbetween}(x,...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{dmx}{dissimilarity matrix or object of class
    \code{dist}. Explanatory dissimilarities (often these will be proper
    distances, but more general dissimilarities that do not
    necessarily fulfill the triangle inequality can be used, same for \code{dmy}).}
  \item{dmy}{dissimilarity matrix or object of class
    \code{dist}. Response dissimilarities.}
  \item{grouping}{something that can be coerced into a factor,
    defining the grouping of
    objects represented by the dissimilarities \code{dmx} and \code{dmy}
    (i.e., if \code{grouping} has length n, \code{dmx} and \code{dmy}
    must be dissimilarities between \code{n} objects).}
  \item{groups}{Vector of two levels. The two groups defining the
    regressions to be compared in the test. These can be
    factor levels, integer numbers, or strings, depending on the entries
    of \code{grouping}.}
  \item{x}{object of class \code{"regdistbetween"}.}
  \item{...}{optional arguments for print method.}
}

\details{
  The null hypothesis that the regressions based on all distances and
  based on within-group distances only are
  equal is tested using jackknife pseudovalues. This assumes that a
  single regression is appropriate at least for the within-group
  distances alone. The test statistic is the difference between fitted
  values with x (explanatory variable) fixed at the center of the
  between-group distances. The test is run one-sided, i.e., the null
  hypothesis is only rejected if the between-group distances are larger
  than expected under the null hypothesis, see below.   

  The test cannot be run in case that
  within-group regressions or jackknifed within-group regressions are
  ill-conditioned.

  This was implemented having in mind an application in which the
  explanatory distances represent geographical distances, the response
  distances are genetic distances, and groups represent species or
  species-candidates. In this application, for testing whether the
  regression patterns are compatble with the two groups behaving like a
  single species, one would first use \code{regeqdist} to test whether a
  joint regression for the within-group distances of both groups makes
  sense. If this is not rejected, \code{regdistbetween} is run to see
  whether the between-group distances are compatible with the
  within-group distances. This is only rejected if the between-group
  distances are larger than expected under equality of regressions,
  because if they are smaller, this is not an indication against the
  groups belonging together genetically.

  If a joint regression on
  within-group distances is rejected by \code{regeqdist},
  \code{regdistbetweenone} can be
  used to test whether the between-group distances are at least
  compatible with the within-group distances of one of the groups, which
  can still be the case within a single species, see Hausdorf and Hennig (2019).
}


\value{
  list of class \code{"regdistbetween"} with components
  \item{pval}{p-value.} 
  \item{coeffdiff}{difference between regression fits (all distances
    minus within-group distances only) at \code{xcenterbetween}, see below.}  
  \item{condition}{condition numbers of regressions, see \code{\link{kappa}}.}
  \item{lmfit}{list. Output objects of \code{\link{lm}} within the two groups.}
  \item{jr}{output object of \code{\link[bootstrap]{jackknife}} for difference
    between regression fitted values at \code{xcenterbetween}.}
  \item{xcenter}{mean of within-groups distances of explanatory
    variable, used for centering.}
  \item{xcenterbetween}{mean of between-groups distances of explanatory
    variable (after centering by \code{xcenter}); at this point
    regression fitted values are computed.}
  \item{tstat}{t-statistic.}
  \item{tdf}{degrees of freedom of t-statistic.}
  \item{jackest}{jackknife-estimator of difference between regression
    fitted values at \code{xcenterbetween}.} 
  \item{jackse}{jackknife-standard error for
    \code{jackest}.}
  \item{jackpseudo}{vector of jacknife pseudovalues on which the test is
    based.}
  \item{testname}{title to be printed out when using
    \code{print.regdistbetween}.}
  \item{groups}{see above.}
}
\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
   \code{\link{regeqdist}}, \code{\link{regdistbetweenone}}
}

\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[173:207,],file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[173:207,],distance="jaccard")
  loggeo <- log(ver.geo+quantile(as.vector(as.dist(ver.geo)),0.25))

  species <-c(rep(1,13),rep(2,22))
 
  rtest2 <-
  regdistbetween(dmx=loggeo,dmy=vei$distmat,grouping=species,groups=c(1,2))
  print(rtest2)
}
\keyword{htest}% __ONLY ONE__ keyword per line
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{abundtest}
\alias{abundtest}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Parametric bootstrap test for clustering in abundance matrices}
\description{
  Parametric bootstrap test of a null model of i.i.d., but spatially
  autocorrelated species against clustering of the species' population
  patterns. Note that most relevant functionality of \code{prabtest}
  (except of the use of the geco distance) is
  also included in \code{abundtest}, so that \code{abundtest} can also
  be used on binary presence-absence data.
  In spite of the lots of
  parameters, a standard execution (for the default test statistics, see
  parameter \code{teststat} below) will be \cr
  \code{prabmatrix <- prabinit(file="path/abundmatrixfile",
    neighborhood="path/neighborhoodfile")}\cr
  \code{test <- abundtest(prabmatrix)}\cr
  \code{summary(test)}\cr
  \bold{Note:} Data formats are described
  on the \code{prabinit} help page. You may also consider the example datasets
  \code{kykladspecreg.dat} and \code{nb.dat}. Take care of the
  parameter \code{rows.are.species} of \code{prabinit}.}


\usage{
abundtest(prabobj, teststat = "distratio", tuning = 0.25,
                       times = 1000, p.nb = NULL, 
                       prange = c(0, 1), nperp = 4, step = 0.1, step2 = 0.01, 
                       twostep = TRUE, species.fixed=TRUE, prab01=NULL,
                       groupvector=NULL,
                       sarestimate=prab.sarestimate(prabobj),
                       dist = prabobj$distance,
                       n.species = prabobj$n.species)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobj}{an object of class \code{prab} (presence-absence data), as
    generated by \code{prabinit}.}
  \item{teststat}{string, indicating the test statistics. \code{"isovertice"}:
    number of isolated vertices in the graph of \code{tuning}
    smallest distances
    between species. \code{"lcomponent"}: size of largest connectivity
    component in this graph. \code{"distratio"}: ratio between \code{tuning}
    smallest and largest distances. \code{"nn"}: average distance of species to
    \code{tuning}th nearest neighbor. 
    \code{"inclusions"}: number of inclusions between areas of different
    species (tests for nestedness structure, not for clustering, and
    treats abundance matrices as presence-absence-data). \code{"mean"}:
    mean of the distances between species (this is a rough measure of
    species co-occurrence).
    \code{"groups"}: this requires a specification of a vector defining
    different groups of species via parameter \code{groupvector}. The
    test statistic is then the mean of the distances between species of
    the same group. This is computed over all species, but also for
    every single group of species. It also includes the
    \code{"mean"}-test, so that the number of tests carried out is
    number of species groups with more than one element plus two.} 
  \item{tuning}{integer or (if \code{teststat="distratio"}) numerical
    between 0 and 1. Tuning constant for test statistics, see
    \code{teststat}.}
  \item{times}{integer. Number of simulation runs.}
  \item{p.nb}{numerical between 0 and 1. The probability that a new
    region is drawn from the non-neighborhood of the previous regions
    belonging to a species under generation. If \code{NULL} (the
    default), and \code{prabobj$spatial}, 
    \code{prabtest} estimates this by function
    \code{autoconst}. Otherwise the next five parameters have no effect.
    If \code{NULL}, and \code{!prabobj$spatial},
    spatial structure is ignored.}
  \item{prange}{numerical range vector, lower value not smaller than 0, larger
    value not larger than 1. Range where \code{pd} is to be found. Used
    by function \code{autoconst}.}
  \item{nperp}{integer. Number of simulations per \code{pd}-value. Used
    by function \code{autoconst}.}
  \item{step}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the first simulation. Used
    by function \code{autoconst}.}
  \item{step2}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the second simulation (see
    parameter \code{twostep}). Used
    by function \code{autoconst}.}
  \item{twostep}{logical. If \code{TRUE}, a first estimation step for
    \code{pd} is
    carried out in the whole \code{prange}, and then the final
    estimation is determined between the preliminary estimator
    \code{-5*step2} and \code{+5*step2}. Else, the first simulation
    determines the final estimator. Used
    by function \code{autoconst}.}
  \item{species.fixed}{logical. Indicates if the range sizes of the species
    are held fixed
    in the test simulation (\code{TRUE}) or generated from their empirical
    distribution in \code{x} (\code{FALSE}) for presence-absence data.
    See function \code{randpop.nb}. Use always \code{TRUE} for abundance
  data (not necessary if \code{teststat="inclusions"}).}
\item{prab01}{\code{prabinit}-object based on
  presence-absence matrix of same dimensions than the
  abundance matrix of \code{prabobj}. This specifies the presences and
  absences on which the presence/absence step of abundance-based tests
  is based (see details). If \code{NULL} (which is usually the only
  reasonable choice), \code{prab01} is computed in order to indicate
  the nonzeroes of \code{prabobj$prab}.}
\item{groupvector}{integer vector. For every species, a number
  indicating the species' group membership. Needed only if
  \code{teststat="groups"}.}
\item{sarestimate}{Estimator of the parameters of a simultaneous
  autoregression model corresponding to the null model for abundance
  data from Hausdorf and Hennig (2007) as generated by
  \code{prab.sarestimate}. This requires package \code{spdep}.
  Note that by explicitly specifying \code{sarestimate=NULL} simulation
  of 0-1 matrices can be enforced.}
\item{dist}{One of \code{"jaccard"}, \code{"kulczynski"},
  \code{"qkulczynski"} or \code{"logkulczynski"} specifying the distance
  measure on which the test is based. By default, this is taken from
  \code{prabobj}.}  
\item{n.species}{number of species. By default this is taken from
  \code{prabobj}. This should normally not be changed.}
}
\details{
  For presence-absence data, the routine is described in
  \code{\link{prabtest}}. For abundance data, the first step under the
  null model is to
  simulated presence-absence patterns as in \code{prabtest}. The second
  step is to fit a simultaneous autoregression (SAR) model (Ripley 1981,
  section 5.2) to the log-abundances, see
  \code{\link{prab.sarestimate}}. The simulation from the null model is
  implemented in \code{regpop.sar}.
  For more details see Hennig
  and Hausdorf (2004) for presence-absence data and Hausdorf and Hennig
  (2007) for abundance data and the test statistics \code{"mean"} and
  \code{"groups"}, which can also be applied to binary data.

  If \code{p.nb=NA} was
  specified, a diagnostic plot
  for the estimation of \code{pd} is plotted by \code{autoconst}.
  For details see Hennig
  and Hausdorf (2004) and the help pages of the cited functions. 
}
\value{
  An object of class \code{prabtest}, which is a list with components
  \item{results}{vector of test statistic values for all simulated
    populations. For \code{teststat="groups"} a list with components
    \code{overall} (means of within group-distances), \code{mean} (means
    of all distances), \code{gr} (matrix with a row for every group,
    giving the groupwise within-group distance means).}
  \item{p.above}{p-value against an alternative that generates large
    values of the test statistic (usually reasonable for
    \code{teststat="inclusions"}, \code{"groups"}, \code{"mean"}).}
  \item{p.below}{p-value against an alternative that generates small
    values of the test statistic (usually reasonable for
    \code{"lcomponent"}, \code{"nn"}, \code{"distratio"}; for
    \code{"isovertice"}, the two-sided p may make sense which is twice
    the smaller one of \code{p.above} and \code{p.below}). }
  \item{datac}{test statistic value for the original
    data. (\code{specgroups}-output for \code{teststat="groups"}).}
  \item{tuning}{see above.}
  \item{distance}{\code{dist} above.}
  \item{teststat}{see above.}
  \item{pd}{\code{p.nb} above.}
  \item{abund}{\code{TRUE} if simultaneous autoregression has been used
    (i.e., a \code{sarestimate} has been supplied or computed).}
  \item{sarlambda}{Estimator of the autocorrelation
    parameter \code{lambda} (see \code{\link[spdep]{errorsarlm}})
    defined so that the average weight of neighbors (see
    \code{\link[spdep]{nb2listw}}) is standardized to 1.}
  \item{sarestimate}{the output object of \code{prab.sarestimate}.}
  \item{groupinfo}{list containing information from
    \code{"groups"} tests, with components \code{lg} (levels of
    \code{groupvector}), \code{ng} (number of groups), \code{nsg}
    (vector of group sizes), \code{testm} (value of \code{"means"} test
    statistic for input \code{prabobj}), \code{pa} (group-wise
    \code{p.above}), \code{pb} (group-wise
    \code{p.below}), \code{pma} (\code{p.above} of \code{"means"} test),
    \code{pmb} (\code{p.below} of \code{"means"} test).}
}

\references{
  Hausdorf, B. and Hennig, C. (2007) Null model tests of clustering of
  species, negative co-occurrence patterns and nestedness in meta-communities.
  \emph{Oikos} 116, 818-828. 

  Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
\url{http://stat.ethz.ch/Research-Reports/110.html}.

  Ripley, B. D. (1981) \emph{Spatial Statistics}. Wiley.

}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{prabinit}} generates objects of class \code{prab}.
  
  \code{\link{autoconst}} estimates \code{pd} from such objects.

  \code{\link{prabtest}} (analogous function for presence-absence data).
  
  \code{\link{regpop.sar}} generates populations from the null model.

  \code{\link{prab.sarestimate}} (parameter estimators for simultaneous
  autoregression model). This calls

  \code{\link[spdep]{errorsarlm}} (original estimation function from
  package \code{spdep}).

  Some more information on the test statistics is given in
  \code{\link{homogen.test}}, \code{\link{lcomponent}},
  \code{\link{distratio}}, \code{\link{nn}},
  \code{\link{incmatrix}}.

  Summary and print methods: \code{\link{summary.prabtest}}.
}


\examples{
# Note: NOT RUN.
# This needs package spdep and a bunch of packages that are
# called by spdep!
# data(siskiyou)
# set.seed(1234)
# x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
#              distance="logkulczynski")
# a1 <- abundtest(x, times=5, p.nb=0.0465)
# a2 <- abundtest(x, times=5, p.nb=0.0465, teststat="groups",
#                 groupvector=siskiyou.groups)
# These settings are chosen to make the example execution
# faster; usually you will use abundtest(x).
# summary(a1)
# summary(a2)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{geo2neighbor}
\alias{geo2neighbor}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Neighborhood list from geographical distance}
\description{
  Generates a neighborhood list as required by \code{prabinit} from a
  matrix of geographical distances.
}
\usage{
geo2neighbor(geodist,cut=0.1*max(geodist))
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{geodist}{\code{dist}-object or symmetric non-negative matrix.
    Geographical distances between regions.}
  \item{cut}{non-negative numerical. All pairs of regions with
    \code{distance<=cut} are treated as neighbors.}
}
\value{
  A list of integer vectors, giving the set of neighbors for every region.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\examples{
data(waterdist)
geo2neighbor(waterdist)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{regeqdist}
\alias{regeqdist}
\alias{print.regeqdist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Testing equality of two distance-regressions}
\description{
  Jackknife-based test for equality of two regressions between
  distance matrices.
}

\usage{
regeqdist(dmx,dmy,grouping,groups=levels(as.factor(grouping))[1:2])

\method{print}{regeqdist}(x,...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{dmx}{dissimilarity matrix or object of class
    \code{dist}. Explanatory dissimilarities (often these will be proper
    distances, but more general dissimilarities that do not
    necessarily fulfill the triangle inequality can be used, same for
    \code{dmy}).}
  \item{dmy}{dissimilarity matrix or object of class
    \code{dist}. Response dissimilarities.}
  \item{grouping}{something that can be coerced into a factor,
    defining the grouping of
    objects represented by the dissimilarities \code{dmx} and \code{dmy}
    (i.e., if \code{grouping} has length n, \code{dmx} and \code{dmy}
    must be dissimilarities between \code{n} objects).}
  \item{groups}{Vector of two, indicating the two groups defining the
    regressions to be compared in the test. These can be
    factor levels, integer numbers, or strings, depending on the entries
    of \code{grouping}.}
  \item{x}{object of class \code{"regeqdist"}.}
  \item{...}{optional arguments for print method.}
}

\details{
  The null hypothesis that the regressions within the two groups are
  equal is tested using jackknife pseudovalues independently in both
  groups allowing for potentially different variances of the
  pseudovalues, and aggregating as in Welch's t-test. Tests are run
  separately for intercept and slope and aggregated by Bonferroni's
  rule.

  The test cannot be run and many components will be \code{NA} in case that
  within-group regressions or jackknifed within-group regressions are
  ill-conditioned.

  This was implemented having in mind an application in which the
  explanatory distances represent geographical distances, the response
  distances are genetic distances, and groups represent species or
  species-candidates. In this application, for testing whether the
  regression patterns are compatble with the two groups behaving like a
  single species, one would first use \code{regeqdist} to test whether a
  joint regression for the within-group distances of both groups makes
  sense. If this is not rejected, \code{regdistbetween} is run to see
  whether the between-group distances are compatible with the
  within-group distances. On the other hand, if a joint regression on
  within-group distances is rejected, \code{regdistbetweenone} can be
  used to test whether the between-group distances are at least
  compatible with the within-group distances of one of the groups, which
  can still be the case within a single species, see Hausdorf and Hennig (2019).
}

\value{
  list of class \code{"regeqdist"} with components
  \item{pval}{p-values for intercept and slope.} 
  \item{coeffdiff}{vector of differences between groups (first minus
  second) for intercept and slope.}  
  \item{condition}{condition numbers of regressions, see \code{\link{kappa}}.}
  \item{lmfit}{list. Output objects of \code{\link{lm}} within the two groups.}
  \item{jr}{list of two lists of two; output object of
    \code{\link[bootstrap]{jackknife}} within the two groups for intercept and
    slope.}
  \item{xcenter}{mean of \code{dmx} within the two groups used for centering.}
  \item{tstat}{t-statistic.}
  \item{tdf}{vector of degrees of freedom of t-statistic according to
    Welch-Sattertwaithe approximation for intercept and slope.}
  \item{jackest}{jackknife-estimator of difference between regressions; 
    vector with intercept and slope difference.}
  \item{jackse}{vector with jackknife-standard errors for
    \code{jackest}, intercept and slope.}
  \item{jackpseudo}{list of two lists of vectors; jacknife pseudovalues
    within both groups for intercept and slope estimators.} 
  \item{groups}{see above.}
}
\references{
  Hausdorf, B. and Hennig, C. (2019) Species delimitation and
  geography. Submitted.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{regdistbetween}}, \code{\link{regdistbetweenone}}
}

\examples{
  options(digits=4)
  data(veronica)
  ver.geo <- coord2dist(coordmatrix=veronica.coord[173:207,],file.format="decimal2")
  vei <- prabinit(prabmatrix=veronica[173:207,],distance="jaccard")
  loggeo <- log(ver.geo+quantile(as.vector(as.dist(ver.geo)),0.25))

  species <-c(rep(1,13),rep(2,22))
  rtest <- regeqdist(dmx=loggeo,dmy=vei$distmat,grouping=species,groups=c(1,2))
  print(rtest)
}
\keyword{htest}% __ONLY ONE__ keyword per line
\keyword{regression}% __ONLY ONE__ keyword per line
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{waterdist}
\alias{waterdist}
% \non_function{}
\title{Overwater distances between islands in the Aegean sea}
\description{
  Distance matrix of overwater distances in km between 34 islands in the
  Aegean sea.
}
\usage{data(waterdist)}
\format{
  A symmetric 34*34 distance matrix.}
\source{
  B. Hausdorf and C. Hennig (2005) The influence of recent geography,
  palaeography and climate on the composition of the faune of the
  central Aegean Islands.   \emph{Biological Journal of the Linnean
    Society} 84, 785-795.
}
\details{
  Reads from example data file \code{Waterdist.dat}, in which there is a
  35th column and line with distances to Turkey mainland.
  }

\examples{
data(waterdist)
}
\keyword{datasets}
% \keyword{spatial}

\name{nb}
\alias{nb}
% \non_function{}
\title{Neighborhood list for Aegean islands}
\description{
  List of neighboring islands for 34 Aegean islands.
}
\usage{data(nb)}
\format{
  List with 34 components, all being vetors of integers (or
  \code{numeric(0)} in case of no neighbors) indicating the neighboring
  islands.
}
\details{
  Reads from example data file \code{nb.dat}.
}

\source{
  B. Hausdorf and C. Hennig (2005) The influence of recent geography,
  palaeography and climate on the composition of the faune of the
  central Aegean Islands. \emph{Biological Journal of the Linnean
    Society} 84, 785-795. 
}
\examples{
data(nb)
# nb <- list()
# for (i in 1:34)
#   nb <- c(nb,list(scan(file="(path/)nb.dat",
#                   skip=i-1,nlines=1)))
}
\keyword{datasets}

\name{communitydist}
\alias{communitydist}

%- Also NEED an `\alias' for EACH other topic documented here.
\title{Distances between communities}
\description{
  Constructs distances between communities: chord- (Cavalli-Sforza and
  Edwards, 1967), phiPT/phiST (Peakall and Smouse, 2012, Meirmans,
  2006),
  three versions of the shared allele distance between communities,
  and geographical distance between communities.
}

\usage{
communitydist(alleleobj,comvector="auto",distance="chord",
                          compute.geodist=TRUE,out.dist=FALSE,
                          grouping=NULL,geodist=NA,diploid=TRUE,
                          phiptna=NA,...)


}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{alleleobj}{if \code{diploid=TRUE}, an object of class
    \code{alleleobject} as produced by
    function  \code{\link[prabclus]{alleleinit}}. This has the required
    information on the individuals that are grouped into communities. In
    case \code{diploid=FALSE}, a list that needs to have components
    \code{n.variables} (number of loci), \code{alevels} (vector of
    allele names, see \code{\link{alleleinit}}) and
    \code{charmatrix} (matrix of characters with one row for every
    individual and one column for every locus giving the alleles; see
    examples below for how this can be constructed for a
    \code{prabobject} with presence-absence data).}
  \item{comvector}{either a vector of integers indicating to which
    community an individual belongs (these need to be numbered from 1 to
    a maximum number without interruption), or \code{"auto"}, which
    indicates that communities are automatically generated by the
    \code{\link{communities}}-function.}
  \item{distance}{one of \code{"chord"}, \code{"phipt"},
    \code{"shared.average"}, \code{"shared.chakraborty"},
    \code{"shared.problist"}. See Details.} 
  \item{compute.geodist}{logical, indicating whether geographical
    distances between communities should be generated.}
  \item{out.dist}{logical, indicating whether \code{dist}-objects are
    given out or rather distance matrices.}
  \item{grouping}{something that can be coerced into a factor, for
    passing on to \code{\link{communities}} in case that
    \code{comvector=="auto"}. This implies that individuals in different
    groups indicated by \code{grouping} cannot be together in the same
    community. Furthermore (also if \code{comvector} is something
    else), a vector of groups of communities will be computed, see
    output component \code{comgroup}. In any case individuals in
    different groups are not allowed to be in the same community.}
  \item{geodist}{matrix or \code{dist}-object providing geographical
    distances between individuals. Required if
    \code{compute.geodist==TRUE} or \code{comvector=="auto"}.}
  \item{diploid}{logical, indicating whether loci are diploid, see
    \code{alleleobj}.}
  \item{phiptna}{if \code{distance="phipt"}, value to be given out as
    phiPT-distance in case that
    the original definition amounts to 0/0 (particularly if communities
    have just one member).}
  \item{...}{optional arguments to be passed on to \code{\link{communities}}.}
}

\details{
  All genetic distances between communities are based on the information
  given in \code{alleleobj}; either on the alleles directly or on a genetic
  distance (\code{distmat}-component, see \code{\link{alleleinit}}). 
  The possible genetic distance measures between communities are as follows:
  \itemize{
    \item \code{"chord"}: chord-distance (Cavalli-Sforza and Edwards,
    1967)
    \item \code{"phipt"}: phiPT-distance implemented according to
    Peakall and Smouse, 2012. This also appears in the literature under
    the name phiST (Meirmans, 2006, although the definition there is
    incomplete and we are not sure whether this is identical).
    \item \code{"shared.average"}: average of between-community genetic
    distances.
    \item \code{"shared.chakraborty"}: between-community shared allele
    distance according to Chakraborty and Jin (1993).
    \item \code{"shared.problist"}: this implements the shared allele
    distance (Bowcock et al., 1994) for individuals directly for
    communities (one minus proportion of alleles shared by two
    communities averaged over loci).
  }
}
  

\value{
  list with components
  \item{comvector}{integer vector of length of the number of
    individuals, indicating their community membership.}
  \item{dist}{genetic distances between communities. Parameter \code{out.dist}
    determines whether this is a \code{dist}-object or a matrix.}
  \item{cgeodist}{if \code{compute.geodist}, geographical distance
  between communities defined as average distance of all pairs of
  individuals belonging to different ones of the two communities between
  which the distance is computed. Parameter \code{out.dist}
  determines whether this is a \code{dist}-object or a matrix.}
  \item{comgroup}{vector of length of the number of communities. If
  \code{grouping} was provided, this is a vector giving the group
  memberships of all communities, otherwise it is a vector of 1s.}
}

    
\references{
  Bowcock, A. M., Ruiz-Linares, A., Tomfohrde, J., Minch, E., Kidd, J. R.,
  Cavalli-Sforza, L. L. (1994) High resolution of human evolutionary
  trees with polymorphic microsatellites. \emph{Nature} 368, 455-457.
  
  Cavalli-Sforza, L. L. and Edwards, A. W. F. (1967) Phylogenetic
  Analysis - Models and Estimation Procedures. \emph{The American Journal of
  Human Genetics} 19, 233-257.

  Chakraborty, R. and Jin, L. (1993) Determination of relatedness between
  individuals using DNA fingerprinting. \emph{Human Biology} 65, 875-895.

  Meirmans, P. G. (2006) Using the AMOVA framework to estimate a
  standardized genetic differentiation measure. \emph{Evolution} 60, 2399-2402.
  
  Peakall, R. and Smouse P.E. (2012) GenAlEx Tutorial 2.
  \url{https://biology-assets.anu.edu.au/GenAlEx/Tutorials.html}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{communities}}; refer to \code{\link{phipt}} for
  computation of distances between specific pairs of communities.
  \code{\link{diploidcomlist}} produces relative frequencies for all
  alles of all loci in all communities (on which the chord- and the
  \code{"shared.problist"}-distances are based). 
}

\examples{
  options(digits=4)
  data(tetragonula)
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[83:120,],cut=50,
    file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[83:120,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist)
  tetraspec <- c(rep(1,11),rep(2,13),rep(3,14))
  tetracoms <-
  c(rep(1:3,each=3),4,5,rep(6:11,each=2),12,rep(13:19,each=2))
  c1 <- communitydist(tai,comvector=tetracoms,distance="chord",
    geodist=tnb$distmatrix,grouping=tetraspec)
  c2 <- communitydist(tai,comvector=tetracoms,distance="phipt",
    geodist=tnb$distmatrix,grouping=tetraspec,compute.geodist=FALSE)
  c3 <- communitydist(tai,comvector=tetracoms,distance="shared.average",
    geodist=tnb$distmatrix,grouping=tetraspec,compute.geodist=FALSE)
  c4 <- communitydist(tai,comvector=tetracoms,distance="shared.chakraborty",
    geodist=tnb$distmatrix,grouping=tetraspec,compute.geodist=FALSE)
  c5 <- communitydist(tai,comvector=tetracoms,distance="shared.problist",
    geodist=tnb$distmatrix,grouping=tetraspec,compute.geodist=FALSE)
  round(c1$cgeodist,digits=1)
  c1$comvector
  c2$comvector
  c3$comvector
  c4$comvector
  c5$comvector
  round(c1$dist,digits=2)
  round(c2$dist,digits=2)
  round(c3$dist,digits=2)
  round(c4$dist,digits=2)
  round(c5$dist,digits=2)  
}
\keyword{spatial}% __ONLY ONE__ keyword per line
\keyword{multivariate}% __ONLY ONE__ keyword per line

\name{coord2dist}
\alias{coord2dist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Geographical coordinates to distances}
\description{
  Computes geographical distances from geographical coordinates
}
\usage{
  coord2dist(file=NULL, coordmatrix=NULL, cut=NULL,
                       file.format="degminsec",
                       output.dist=FALSE, radius=6378.137,
              fp=1/298.257223563, neighbors=FALSE)

}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{file}{string. A filename for the coordinate file. The file
    should have 2, 4 or 6 numeric columns and one row for each location.
    See \code{file.format}. One of \code{file} and \code{coordmatrix}
    needs to be specified (if \code{coordmatrix} is not specified,
    coordinates are read from \code{file}).}
  \item{coordmatrix}{something that can be coerced into a matrix with
    2, 4 or 6 columns. Matrix of coordinates, one row for each
    location. See \code{file.format}. One of \code{file} and
    \code{coordmatrix} needs to be specified.}
  \item{cut}{numeric. Only active if \code{neighbors==TRUE}; see
    \code{neighbors}.}
  \item{file.format}{one of \code{"degminsec"}, \code{"decimal2"} or
    \code{"decimal4"}. The format of the required file or
    \code{coordmatrix} consists of the following columns:
    \describe{
      \item{"degminsec"}{6 columns; the first three give degrees,
	minutes and seconds for latitude, columns 4-6 the same for
	longitude.  Values in column 1 and 4 can be positive or negative
	(negative means "South", "West", respectively). Values in the
	other columns should be non-negative.}
      \item{"decimal2"}{2 columns; the first one gives latitude, the
	second one longitude in proper decimal notation. Values can be
	positive or negative (negative means "South", "West",
	respectively).}
      \item{"decimal4"}{4 columns; the first two give latitude, no. 3
	and 4 give longitude. Values in column 1 and 3 can be positive
	or negative (negative means "South", "West",
	respectively). The give integer degrees. Values in the other
	columns should be non-negative. They give percentages
	(\code{<=100}).}
  }}
  \item{output.dist}{logical. If \code{TRUE}, the resulting distance
    matrix is given out as a \code{\link{dist}} object.}
  \item{radius}{numeric. Radius of the earth in km used in computation
    (the default is the equatorial radius but this is not the uniquely
    possible choice).}
  \item{fp}{flattening of the earth; the default is from WGS-84.}
  \item{neighbors}{logical. If \code{TRUE}, a neighborhood list is also
    computed, listing for every location all locations with distance
    \code{<=cut} as neighbors.}      
}
\value{
  If \code{neighbors==TRUE}, a
  list with components
  \item{distmatrix}{distance matrix between locations. See
    \code{output.dist} above. This is in km by default; the measurement
    unit is determined by the value used for \code{radius}.}
  \item{nblist}{list with a vector for every location containing the
    numbers of its neighbors, see \code{neighbors}.}
  If \code{neighbors==FALSE}, only the distance matrix.
}
\references{
  German Wikipedia from 29 August 2010:
  \url{https://de.wikipedia.org/wiki/Orthodrome}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{geo2neighbor}}
}

\examples{
  options(digits=4)
  data(veronica)
  coord2dist(coordmatrix=veronica.coord[1:20,], cut=20, file.format="decimal2",neighbors=TRUE)
}
\keyword{math}% __ONLY ONE__ keyword per line

\name{jaccard}
\alias{jaccard}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Jaccard distance matrix}
\description{
  Computes Jaccard distances between the columns of a 0-1-matrix.
}
\usage{
jaccard(regmat)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
}
\details{
  The Jaccard distance between two species is 1-(number of regions where
  both species are present)/(number of regions where at least one
  species is present). As a similarity coefficient, this is S22 in
  Shi (1993).

  Thank you to Laurent Buffat for improving this function!
}
\value{
  A symmetrical matrix of Jaccard distances.
}


\references{
  Shi, G. R. (1993) Multivariate data analysis in palaeoecology and
  palaeobiogeography - a review. \emph{Palaeogeography, 
    Palaeoclimatology, Palaeoecology} 105, 199-234.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{kulczynski}}, \code{\link{dicedist}}
}

\examples{
options(digits=4)
data(kykladspecreg)
jaccard(t(kykladspecreg))
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{regpop.sar}
\alias{regpop.sar}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Simulation of abundance matrices (non-clustered)}
\description{
  Generates a simulated matrix where the rows are interpreted as regions
  and the columns as species, and the entries are abundances.
  Species are generated i.i.d. in two steps. In the first step, a
  presence-absence matrix is generated as in \code{randpop.nb}. In the
  second step, conditionally on presence in the first step, abundance
  values are generated according to a simultaneous autoregression (SAR)
  model for the log-abundances (see \code{\link[spdep]{errorsarlm}} for
  the model; estimates are provided by the parameter
  \code{sarestimate}). Spatial autocorrelation of a species' presences
  is governed by the parameter \code{p.nb}, \code{sarestimate} and a
  list of neighbors for each region.
}
\usage{
regpop.sar(abmat, prab01=NULL, sarestimate=prab.sarestimate(abmat),
                    p.nb=NULL,
                    vector.species=prab01$regperspec,
                    pdf.regions=prab01$specperreg/(sum(prab01$specperreg)),
                   count=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{abmat}{object of class \code{prab}, containing the abundance or
    presence/absence data.}
  \item{prab01}{presence-absence matrix of same dimensions than the
  abundance matrix of \code{prabobj}. This specifies the presences and
  absences on which the presence/absence step of abundance-based tests
  is based (see details). If \code{NULL} (which is usually the only
  reasonable choice), \code{prab01} is computed in order to indicate
  the nonzeroes of \code{prabobj$prab}.}
  \item{sarestimate}{Estimator of the parameters of a simultaneous
  autoregression model corresponding to the null model for abundance
  data from Hausdorf and Hennig (2007) as generated by
  \code{prab.sarestimate}. This requires package \code{spdep}. If
  \code{sarestimate$sar=FALSE}, spatial structure is ignored for
  generating the abundance values.}
  \item{p.nb}{numeric between 0 and 1. The probability that a new
    region is drawn from the non-neighborhood of the previous regions
    belonging to a species under generation. If \code{NULL}, the spatial
    structure of the regions is ignored. Note that for a given
    presence-absence matrix, this parameter can be estimated by
    \code{autoconst} (called \code{pd} there).}
  \item{vector.species}{vector of integers. \code{vector.species} gives
    the sizes (i.e., numbers of regions) of
    the species to generate..}
  \item{pdf.regions}{numerical vector of length \code{n.species}. The
    entries must sum up to 1 and give probabilities for the regions to
    be drawn during the generation of a species. These probabilities are
    used conditional on the new region being a neighbor or a
    non-neighbor of the previous regions of the species, see
    \code{p.nb}.}
  \item{count}{logical. If \code{TRUE}, the number of the currently
    generated species is printed.}
}
\value{
  A matrix of abundance values, rows are regions, columns are species.
}
\references{
  Hausdorf, B. and Hennig, C. (2007) Null model tests of clustering of
  species, negative co-occurrence patterns and nestedness in meta-communities.
  \emph{Oikos} 116, 818-828. 
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{autoconst}} estimates \code{p.nb} from matrices of class
  \code{prab}. These are generated by \code{\link{prabinit}}.
  
  \code{\link{abundtest}} uses \code{regpop.sar} as a null model for
  tests of clustering.

  \code{\link{randpop.nb}} (analogous function for simulating
  presence-absence data)
}

\examples{
options(digits=4)
data(siskiyou)
set.seed(1234)
x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
             distance="none")
# Not run; this needs package spdep.
# regpop.sar(x, p.nb=0.046)
regpop.sar(x, p.nb=0.046, sarestimate=prab.sarestimate(x,sar=FALSE))
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{prabclust}
\alias{prabclust}
\alias{print.prabclust}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Clustering for biotic elements or for species delimitation
  (mixture method)}
\description{
  Clusters a presence-absence matrix object (for clustering
  ranges/finding biotic elements, Hennig and Hausdorf, 2004) or
  an object of genetic information (for species delimitation, Hausdorf
  and Hennig, 2010)
  by calculating an MDS from
  the distances, and applying maximum likelihood Gaussian mixtures clustering
  with "noise" (package \code{mclust}) to the MDS points. The solution
  is plotted. A standard execution (using the default distance of
  \code{prabinit}) will be \cr
  \code{prabmatrix <- prabinit(file="path/prabmatrixfile",
    neighborhood="path/neighborhoodfile")}\cr
  \code{clust <- prabclust(prabmatrix)}\cr
  \code{print(clust)} \cr
  Examples for species delimitation are given below in the examples section. 
  \bold{Note:} Data formats are described
  on the \code{\link{prabinit}} and \code{\link{alleleinit}}
  help pages. You may also consider the example datasets
  \code{kykladspecreg.dat}, \code{nb.dat},
  \code{Heterotrigona_indoFO.txt} or \code{MartinezOrtega04AFLP.dat}.
  \cr
  \bold{Note:} \code{prabclust} calls the function
  \code{\link[mclust]{mclustBIC}} in package mclust. An alternative is the use of \code{\link{hprabclust}}.
}

\usage{
prabclust(prabobj, mdsmethod = "classical", mdsdim = 4, nnk =
ceiling(prabobj$n.species/40), nclus = 0:9, modelid = "all", permutations=0)

\method{print}{prabclust}(x, bic=FALSE, ...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobj}{object of class \code{prab} as
    generated by \code{prabinit}. Presence-absence data to be analyzed.
    (This can be geographical information for range clustering  
    Can also be an object of class \code{alleleobject} as generated by
    \code{alleleinit}. 
  }
  \item{mdsmethod}{\code{"classical"}, \code{"kruskal"}, or
    \code{"sammon"}. The MDS method
    to transform the distances to data points. \code{"classical"} indicates
    metric MDS by function \code{cmdscale}, \code{"kruskal"} is
    non-metric MDS.}
  \item{mdsdim}{integer. Dimension of the MDS points. For
    \code{mdsmethod=="kruskal"}, \code{\link{stressvals}} can be used to
    see how the stress depends on \code{mdsdim} in order to choose
    \code{mdsdim} to get a small stress (smaller than 5\%, say).}
  \item{nnk}{integer. Number of nearest neighbors to determine the
    initial noise estimation by \code{NNclean}. \code{nnk=0} fits the
    model without a noise component.}
  \item{nclus}{vector of integers. Numbers of clusters to perform the
    mixture estimation.}
  \item{modelid}{string. Model name for \code{mclustBIC} (see the
    corresponding help page; all models or combinations of models
    mentioned there are possible). \code{modelid="all"} compares all possible
    models. Additionally, \code{"noVVV"} is possible, which
    fits all methods except \code{"VVV"}.}
  \item{permutations}{integer. It has been found occasionally that
    depending on the order of observations the algorithms \code{isoMDS}
    and \code{mclustBIC} converge to different solutions. This is
    because these methods require an ordering of the distances, which,
    if equal distance values are involved, may depend on the order.
    \code{prabclust} uses a standard ordering which should give a
    reproducible solution in these cases as well. However, if
    \code{permutations>0}, which gives a number of random permutations
    of the observations, the algorithm is carried out for every
    permutation and the best solution (in terms of the BIC, based on the
    lowest stress MDS configuration) is given out (for many datasets
    this won't change anything except increasing the computing time).}     
  \item{x}{object of class \code{prabclust}. Output of
    \code{prabclust}.}
  \item{bic}{logical. If \code{TRUE}, information about the BIC
    criterion to choose the model is displayed.}
  \item{...}{necessary for summary method.}
}

\details{
  Note that if \code{mdsmethod!="classical"}, zero distances between
  non-identical objects are replaced by the smallest nonzero distance
  divided by 10 to prevent the MDS methods from producing an error.
}

\value{
  \code{print.prabclust} does not produce output. 
  \code{prabclust} generates an object of class \code{prabclust}. This is a
  list with components
  \item{clustering}{vector of integers indicating the cluster memberships of
    the species. Noise can be recognized by output component \code{symbols}.}
  \item{clustsummary}{output object of \code{summary.mclustBIC}. A list
    giving the optimal (according to BIC) parameters, 
    conditional probabilities `z', and loglikelihood, together with
    the associated classification and its uncertainty. Note that the
    numbering of clusters may differ from \code{clustering}, see
    \code{csreorder}.}
  \item{bicsummary}{output object of \code{mclustBIC}. Bayesian Information
    Criterion for the specified mixture models and numbers of clusters. }
  \item{points}{numerical matrix. MDS configuration.}
  \item{nnk}{see above.}
  \item{mdsdim}{see above.}
  \item{mdsmethod}{see above.}
  \item{symbols}{vector of characters, similar to \code{clustering}, but
    indicating estimated noise and points belonging to
    one-point-components (which should be interpreted as some kind of
    noise as well) by \code{"N"}. }
  \item{permchange}{logical. If \code{TRUE}, \code{permutations>0} has
    been used and the best solution is different from the one obtained
    by the standard ordering. (This is just for information and has no
    further operational consequences.)}

}
\references{
  Fraley, C.  and Raftery, A. E. (1998) How many clusters? Which
  clustering method? - Answers via Model-Based Cluster Analysis.
  \emph{Computer Journal} 41, 578-588.

  Hausdorf, B. and Hennig, C. (2010) Species Delimitation Using Dominant
  and Codominant Multilocus Markers. \emph{Systematic Biology}, 59, 491-503.
 
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
\url{http://stat.ethz.ch/Research-Reports/110.html}.
}
\note{
  Note that we used \code{mdsmethod="kruskal"} in our publications, but
  \code{mdsmethod="classical"} is now the default, because of
  occasional numerical instabilities of the \code{isoMDS}-implementation
  for Jaccard, Kulczynski or geco distance matrices. 

  Sometimes, \code{prabclust} produces an error because \code{mclustBIC}
  cannot handle all models properly. In this case we recommend to change
  the \code{modelid} parameter. \code{"noVVV"} and \code{"VVV"} are
  reasonable alternative choices (one of these is expected to reproduce
  the error, but the other one might work).
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link[mclust]{mclustBIC}}, \code{\link[mclust]{summary.mclustBIC}},
  \code{\link{NNclean}}, \code{\link{cmdscale}},
  \code{\link[MASS]{isoMDS}}, \code{\link[MASS]{sammon}},
  \code{\link{prabinit}}, \code{\link{hprabclust}},
  \code{\link{alleleinit}}, \code{\link{stressvals}}.
}

\examples{
\donttest{
# Biotic element/range clustering:
data(kykladspecreg)
data(nb)
set.seed(1234)
x <- prabinit(prabmatrix=kykladspecreg, neighborhood=nb)
# If you want to use your own ASCII data files, use
# x <- prabinit(file="path/prabmatrixfile",
# neighborhood="path/neighborhoodfile")
print(prabclust(x))

# Here is an example for species delimitation with codominant markers;
# only 50 individuals were used in order to have a fast example. 
data(tetragonula)
ta <- alleleconvert(strmatrix=tetragonula[1:50,])
tai <- alleleinit(allelematrix=ta)
print(prabclust(tai))

# Here is an example for species delimitation with dominant markers;
# only 50 individuals were used in order to have a fast example.
# You may want to use stressvals to choose mdsdim.
data(veronica)
vei <- prabinit(prabmatrix=veronica[1:50,],distance="jaccard")
print(prabclust(vei,mdsmethod="kruskal",mdsdim=3))
}
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{NNclean}
\alias{NNclean}
\alias{print.nnclean}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Nearest neighbor based clutter/noise detection}
\description{
  Detects if data points are noise or part of a cluster,
  based on a Poisson process model.
}
\usage{
NNclean(data, k, distances = NULL, edge.correct = FALSE, wrap = 0.1,
convergence = 0.001, plot=FALSE, quiet=TRUE)

\method{print}{nnclean}(x, ...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{data}{numerical matrix or data frame.}
  \item{k}{integer. Number of considered nearest neighbors per point.}
  \item{distances}{distance matrix object of class \code{dist}. If
    specified, it is used instead of computing distances from the data.}
  \item{edge.correct}{logical. If \code{TRUE} and the data is
    two-dimensional, neighbors for points at the edges of the parent
    region of the noise Poisson process are determined after wrapping
    the region onto a toroid.}
  \item{wrap}{numerical. If \code{edge.correct=TRUE}, points in a
    strip of size \code{wrap*range} along the edge for each variable
    are candidates for
    being neighbors of points from the opposite.}
  \item{convergence}{numerical. Convergence criterion for EM-algorithm.}
  \item{plot}{logical. If \code{TRUE}, a histogram of the distance to
    kth nearest neighbor and fit is plotted.}
  \item{quiet}{logical. If \code{FALSE}, the likelihood is printed
    during the iterations.}
  \item{x}{object of class \code{nnclean}.}
  \item{...}{necessary for print methods.}
}
\details{
  The assumption is that the noise is distributed as a homogeneous
  Poisson process  on a certain region and the clusters are distributed
  as a homogeneous Poisson process with larger intensity on a
  subregion (disconnected in case of more than one cluster).
  The distances are then distributed according to a mixture of two
  transformed Gamma distributions, and this mixture is estimated via the
  EM-algorithm. The points are assigned to noise or cluster component
  by use of the estimated a posteriori probabilities. 
}
\value{
  \code{NNclean} returns a list of class \code{nnclean} with components
  \item{z}{0-1-vector of length of the number of data points. 1 means
    cluster, 0 means noise.}
  \item{probs}{vector of estimated a priori probabilities for each point
    to belong to the cluster component.}
  \item{k}{see above.}
  \item{lambda1}{intensity parameter of cluster component.}
  \item{lambda2}{intensity parameter of noise component.}
  \item{p}{estimated probability of cluster component.}
  \item{kthNND}{distance to kth nearest neighbor.}
}
\references{
Byers, S. and Raftery, A. E. (1998) Nearest-Neighbor Clutter
Removal for Estimating Features in Spatial Point Processes,
\emph{Journal of the American Statistical Association}, 93, 577-584.
}
\author{R-port by Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en},\cr
  original Splus package by S. Byers and A. E. Raftery.
}

\note{The software can be freely used for non-commercial purposes, and can
be freely distributed for non-commercial purposes only.} 

\examples{
library(mclust)
data(chevron)
nnc <-  NNclean(chevron[,2:3],15,plot=TRUE)
plot(chevron[,2:3],col=1+nnc$z)
}

\keyword{multivariate}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line

\name{toprab}
\alias{toprab}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Convert abundance matrix into presence/absence matrix}
\description{
  Converts abundance matrix into binary (logical) presence/absence
  matrix (\code{TRUE} if
  abundance>0). 
}
\usage{
toprab(prabobj)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobj}{object of class \code{prab}.}
}
\value{
  Logical matrix with same dimensions as \code{prabobj$prab} as described above.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\examples{
  data(siskiyou)
  x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
             distance="none")
  toprab(x)
}
\keyword{manip}% at least one, from doc/KEYWORDS

\name{kulczynski}
\alias{kulczynski}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Kulczynski distance matrix}
\description{
  Computes Kulczynski distances between the columns of a 0-1-matrix.
}
\usage{
kulczynski(regmat)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
}
\details{
  The Kulczynski distance between two species is 1-(mean of (number of
  regions where
  both species are present)/(number of regions where species 1 is
  present) and (number of
  regions where
  both species are present)/(number of regions where species 2 is
  present)). The similarity version of this is S28 in Shi (1993).
}
\value{
  A symmetrical matrix of Kulczynski distances.
}

\references{
  Shi, G. R. (1993) Multivariate data analysis in palaeoecology and
  palaeobiogeography - a review. \emph{Palaeogeography, 
    Palaeoclimatology, Palaeoecology} 105, 199-234.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{jaccard}}, \code{\link{geco}},\code{\link{qkulczynski}} ,
  \code{\link{dicedist}}
}

\examples{
options(digits=4)
data(kykladspecreg)
kulczynski(t(kykladspecreg))
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{randpop.nb}
\alias{randpop.nb}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Simulation of presence-absence matrices (non-clustered)}
\description{
  Generates a simulated matrix where the rows are interpreted as regions
  and the columns as species, 1 means that a species is present in the
  region and 0 means that the species is absent. Species are generated
  i.i.d.. Spatial autocorrelation of a species' presences is governed by
  the parameter \code{p.nb} and a list of neighbors for each region.
}
\usage{
randpop.nb(neighbors, p.nb = 0.5, n.species, n.regions =
length(neighbors), vector.species = rep(1, n.species),
species.fixed = FALSE, pdf.regions = rep(1/n.regions, n.regions),
count = TRUE, pdfnb = FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{neighbors}{A list with a component for every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a list \code{numeric(0)}.}
  \item{p.nb}{numerical between 0 and 1. The probability that a new
    region is drawn from the non-neighborhood of the previous regions
    belonging to a species under generation. Note that for a given
    presence-absence matrix, this parameter can be estimated by
    \code{autoconst} (called \code{pd} there).}
  \item{n.species}{integer. Number of species.}
  \item{n.regions}{integer. Number of regions.}
  \item{vector.species}{vector of integers. If
    \code{species.fixed=TRUE}, \code{vector.species} must have length
    \code{n.species} and gives the sizes (i.e., numbers of regions) of
    the species to generate. Else, the sizes are generated randomly from
    the empirical distribution of \code{vector.species}.}
  \item{species.fixed}{logical. See \code{vector.species}.}
  \item{pdf.regions}{numerical vector of length \code{n.species}. The
    entries must sum up to 1 and give probabilities for the regions to
    be drawn during the generation of a species. These probabilities are
    used conditional on the new region being a neighbor or a
    non-neighbor of the previous regions of the species, see
    \code{p.nb}.}
  \item{count}{logical. If \code{TRUE}, the number of the currently
    generated species is printed.}
  \item{pdfnb}{logical. If \code{TRUE}, the probabilities of the regions
    are modified according to the number of neighboring regions by
    dividing them relative to the others by min(1,number of neighbors).}
}
\details{
  The principle is that a single species with given size is generated
  one-by-one region. The first region is drawn according to
  \code{pdf.regions}. For all following regions, a neighbor or
  non-neighbor of the previous configuration is added (if possible),
  as explained in \code{pdf.regions}, \code{p.nb}.  
}
\value{
  A 0-1-matrix, rows are regions, columns are species.
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
\url{http://stat.ethz.ch/Research-Reports/110.html}.

Hausdorf, B. and Hennig, C. (2003)  Biotic Element Analysis in
Biogeography. \emph{Systematic Biology} 52, 717-723.

Hausdorf, B. and Hennig, C. (2003) Nestedness of nerth-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.

}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{autoconst}} estimates \code{p.nb} from matrices of class
  \code{prab}. These are generated by \code{\link{prabinit}}.
  
  \code{\link{prabtest}} uses \code{randpop.nb} as a null model for
  tests of clustering. An alternative model is given by
  \code{\link{cluspop.nb}}.  
}

\examples{
data(nb)
set.seed(2346)
randpop.nb(nb, p.nb=0.1, n.species=5, vector.species=c(1,10,20,30,34))
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{allele2zeroone}
\alias{allele2zeroone}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Converts alleleobject into binary matrix}
\description{
  Converts \code{\link{alleleobject}} with codominant markers into
  binary matrix with a column for each marker.
}

\usage{
  allele2zeroone(alleleobject)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{alleleobject}{object of class \code{\link{alleleobject}} as
  generated by \code{\link{alleleinit}}.}
}
  
\value{
  A 0-1-matrix with individuals as rows and markers (alleles) as columns. 
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\examples{
  data(tetragonula)
  ta <- alleleconvert(strmatrix=tetragonula[21:50,])
  tai <- alleleinit(allelematrix=ta)
  allele2zeroone(tai)
}
\keyword{manip}% at least one, from doc/KEYWORDS

\name{lociplots}
\alias{lociplots}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Visualises clusters of markers vs. species}
\description{
  Given a clustering of individuals from \code{\link{prabclust}} (as
  generated in species delimitation) and a clustering of markers (for
  example dominant markers of genetic loci), \code{lociplots} visualises 
  the presence of markers against the clustering of individuals and
  computes some statistics.   
}
\usage{
  lociplots(indclust,locclust,locprab,lcluster,
                      symbols=NULL,brightest.grey=0.8,darkest.grey=0,
                      mdsdim=1:2)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{indclust}{\code{\link{prabclust}}-object. Clustering of individuals.}
  \item{locclust}{vector of integers. Clustering of markers/loci.}
  \item{locprab}{\code{\link{prab}}-object in which the markers are what
    the help page of \code{\link{prabinit}} refers to as "species"
    (i.e., reverse of what is used for species delimitation clustering;
    for data sets with codominant markers, such an object can be
    constructed by use of \code{\link{allele2zeroone}} before
    \code{\link{prabinit}}.)}
  \item{lcluster}{integer. Number of cluster in \code{locclust} for
    which plot and statistics are produced.}
  \item{symbols}{vector of plot symbols. If \code{NULL},
    \code{indclust$symbols} is used.}
  \item{brightest.grey}{numeric between 0 and 1. Brightest grey value
    used in plot for individuals with smallest marker percentage, see
    details.}
  \item{darkest.grey}{numeric between 0 and 1. Darkest grey value
    used in plot for individuals with highest marker percentage, see
    details.}
  \item{mdsdim}{vector of two integers. The two MDS variables taken from
    \code{indclust} used for visualisation.}  
}

\details{
  Plot and statistics are based on the individual marker percentage,
  which is the percentage of markers present in an individual of the
  markers belonging to cluster no. \code{lcluster}. In the plot, the
  grey value visualises the marker percentage.
}
  
\value{
  list with components
  \item{locfreq}{vector of individual marker percentages.}
  \item{locfreqmin}{vector of minimum individual marker precentages for
    each cluster in \code{indclust}-clustering (the first value refers
    to the "noise component", if present).}
  \item{locfreqmax}{vector of maximum individual marker precentages for
    each cluster in \code{indclust}-clustering (the first value refers
    to the "noise component", if present).}
  \item{locfreqmean}{vector of average individual marker precentages for
    each cluster in \code{indclust}-clustering (the first value refers
    to the "noise component", if present).}  
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{prabclust}}}

\examples{
\donttest{
  options(digits=4)
  data(veronica)
  vei <- prabinit(prabmatrix=veronica[1:50,],distance="jaccard")
  ppv <- prabclust(vei)
  veloci <- prabinit(prabmatrix=veronica[1:50,],rows.are.species=FALSE)
  velociclust <- prabclust(veloci,nnk=0)
  lociplots(ppv,velociclust$clustering,veloci,lcluster=3)
}
}
\keyword{cluster}% at least one, from doc/KEYWORDS

\name{nbtest}
\alias{nbtest}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Test of neighborhood list}
\description{
  Tests a list of neighboring regions for proper format. Neighborhood is
  tested for being symmetrical. Causes an error if tests fail.
}
\usage{
nbtest(nblist, n.regions=length(nblist))
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{nblist}{A list with a component for
    every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a vector \code{numeric(0)}.}
  \item{n.regions}{Number of regions.}
}

\value{
  \code{invisible{TRUE}}.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{\code{\link{prabinit}}.}

\examples{
data(nb)
nbtest(nb)
nb[[1]][1] <- 1
try(nbtest(nb))
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{pop.sim}
\alias{pop.sim}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{p-value simulation for presence-absence matrices clustering test}
\description{
  Parametric bootstrap simulation of the p-value of a test of a
  homogeneity hypothesis against clustering (or significant nestedness).
  Designed for use within
  \code{\link{prabtest}}. The null model is defined by
  \code{\link{randpop.nb}}.
}
\usage{
pop.sim(regmat, neighbors, h0c = 1, times = 200, dist = "kulczynski",
teststat = "isovertice", testc = NULL, geodist=NULL, gtf=0.1,
n.species = ncol(regmat),
specperreg = NULL, regperspec = NULL, species.fixed=FALSE, pdfnb=FALSE,
ignore.richness=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
  \item{neighbors}{A list with a component for every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a list \code{numeric(0)}.}
  \item{h0c}{numerical. Parameter \code{p.nb} for use in \code{randpop.nb}.}
  \item{times}{integer. Number of simulation runs.}
  \item{dist}{"kulczynski", "jaccard" or "geco", see \code{kulczynski},
    \code{geco} and \code{jaccard}.}
  \item{teststat}{"isovertice", "lcomponent", "distratio", "nn" or
    "inclusions". See
    the corresponding functions, \code{homogen.test} for "isovertice",
    \code{incmatrix} for "inclusions").}
  \item{testc}{numerical. Tuning constant for the test statistics.}
  \item{geodist}{matrix of non-negative reals. Geographical distances
    between regions. Only used if \code{dist="geco"}.}
  \item{gtf}{tuning constant for geco-distance if \code{dist="geco"},
    see \code{"geco"}.}
  \item{n.species}{integer. Number of species.}
  \item{specperreg}{vector of integers. Numbers of species per region
    (is calculated from the data by default).}
  \item{regperspec}{vector of integers. Number of regions per species
    (is calculated from the data by default).}
  \item{species.fixed}{logical. If \code{TRUE}, the sizes of the species
    are taken directly from \code{regmat}. Otherwise, they are drawn by
    random from the empirical distribution of the values from
    \code{regmat}.}
  \item{pdfnb}{logical. Probability correction in \code{randpop.nb}.}
  \item{ignore.richness}{logical. If \code{TRUE}, there is no assumption
    of species richnesses to differ between regions in the null model.
    Regionwise probabilities don't differ in the generation of null
    data.}
}
\value{
  List with components
  \item{results}{vector of teststatistic values for the simulated matrices.}
  \item{p.above}{p-value if large test statistic leads to rejection.}
  \item{p.below}{p-value if small test statistic leads to rejection.}
  \item{datac}{test statistic value for the original data.}
  \item{testc}{see above.}
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
\url{http://stat.ethz.ch/Research-Reports/110.html}.

Hausdorf, B. and Hennig, C. (2003)  Biotic Element Analysis in
Biogeography. \emph{Systematic Biology} 52, 717-723.

Hausdorf, B. and Hennig, C. (2003) Nestedness of north-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.
}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{prabtest}}, \code{\link{randpop.nb}},
  \code{\link{jaccard}}, \code{\link{kulczynski}},
  \code{\link{homogen.test}}, \code{\link{lcomponent}},
  \code{\link{distratio}}, \code{\link{nn}},
  \code{\link{incmatrix}}.
}

\examples{
options(digits=4)
data(kykladspecreg)
data(nb)
set.seed(1234)
pop.sim(t(kykladspecreg), nb, times=5, h0c=0.35, teststat="nn", testc=3)
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{htest}% __ONLY ONE__ keyword per line

\name{homogen.test}
\alias{homogen.test}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Classical distance-based test for homogeneity against clustering}
\description{
  Classical distance-based test for homogeneity against clustering. Test
  statistics is number of isolated vertices in the graph of smallest
  distances. The homogeneity model is a random graph model where \code{ne}
  edges are drawn from all possible edges.
}
\usage{
homogen.test(distmat, ne = ncol(distmat), testdist = "erdos")
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{distmat}{numeric symmetric distance matrix.}
  \item{ne}{integer. Number of edges in the data graph, corresponding to
    smallest distances.}
  \item{testdist}{string. If \code{testdist="erdos"}, the test
    distribution is a Poisson asymptotic distibution as given by Erdos
    and Renyi (1960). If \code{testdist="ling"}, the test distribution
    is exact as given by Ling (1973), which needs much more computing time.}
}

\details{
  The "ling"-test is one-sided (rejection if the number of isolated vertices
  is too large), the "erdos"-test computes a one-sided as well as a
  two-sided p-value.
}

\value{
  A list with components
  \item{p}{p-value for one-sided test.}
  \item{p.twoside}{p-value for two-sided test, only if \code{testdist="erdos"}.}
  \item{iv}{number of isolated vertices in the data.}
  \item{lambda}{parameter of the Poisson test distribution, only if
    \code{testdist="erdos"}.}
  \item{distcut}{largest distance value for which an edge has been
    drawn.}
  \item{ne}{see above.}
}
\references{
  Erdos, P. and Renyi, A. (1960) On the evolution of random
  graphs. \emph{Publications of the Mathematical Institute of the
  Hungarian Academy of Sciences} 5, 17-61.

  Godehardt, E. and Horsch, A. (1995) Graph-Theoretic Models for Testing
  the Homogeneity of Data. In Gaul, W. and Pfeifer, D. (Eds.) \emph{From
  Data to Knowledge}, Springer, Berlin, 167-176.
  
  Ling, R. F. (1973) A probability theory of cluster
  analysis. \emph{Journal of the American Statistical Association} 68,
  159-164.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{\code{\link{prabtest}}}

\examples{
options(digits=4)
data(kykladspecreg)
j <- jaccard(t(kykladspecreg))
homogen.test(j, testdist="erdos")
homogen.test(j, testdist="ling")
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{htest}% __ONLY ONE__ keyword per line

\name{kykladspecreg}
\alias{kykladspecreg}
% \non_function{}
\title{Snail presence-absence data from Aegean sea}
\description{
  0-1-matrix where rows are snail species and columns are islands in the
  Aegean sea. An entry of 1 means that the species is present in the
  region.     
}
\usage{data(kykladspecreg)}
\format{
  A 0-1 matrix with 80 rows and 34 columns.}
\source{
  B. Hausdorf and C. Hennig (2005) The influence of recent geography,
  palaeography and climate on the composition of the faune of the
  central Aegean Islands. \emph{Biological Journal of the Linnean
    Society} 84, 785-795.
}
\details{
  Reads from example data file \code{kykladspecreg.dat}.
  }

\seealso{
  \code{\link{nb}} provides neighborhood information about the 34
  islands. \code{\link{waterdist}} provides a geographical distance
  matrix between the islands. 
  }
\examples{
data(kykladspecreg)
}
\keyword{datasets}
% \keyword{spatial}

\name{veronica}
\alias{veronica}
\alias{veronica.coord}
\docType{data}
% \non_function{}
\title{Genetic AFLP data of Veronica plants}
\description{
  0-1 data indicating whether dominant markers are present for 583
  different AFLP bands ranging from 61 to 454 bp of 207 plant
  individuals of Veronica (Pentasepalae) from the Iberian Peninsula and
  Morocco (Martinez-Ortega et al., 2004). 
}
\usage{data(veronica)}
\format{
  Two objects are generated:
  \describe{
  \item{veronica}{0-1 matrix with 207 individuals (rows) and 583 AFLP
    bands (columns).}
  \item{veronica.coord}{a 207*2 matrix. Coordinates of locations of
    individuals in decimal format, i.e. the first number is latitude
    (negative values are South), with minutes and seconds
    converted to fractions. The second number is longitude (negative
    values are West).}
  }
}
\source{
   Martinez-Ortega, M. M., L. Delgado, D. C. Albach,
   J. A. Elena-Rossello, and E. Rico (2004). Species boundaries
   and phylogeographic patterns in cryptic taxa inferred from AFLP
   markers: Veronica subgen. Pentasepalae (Scrophulariaceae) in the
   Western Mediterranean.\emph{Syst. Bot.} 29, 965-986.
}
\details{
  Reads from example data files \code{MartinezOrtega04AFLP.dat,
    MartinezKoord.dat}. 
  }

\examples{
data(veronica)
}
\keyword{datasets}

\name{stressvals}
\alias{stressvals}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Stress values for different dimensions of Kruskal's MDS}
\description{
  Computes Kruskal's nonmetric multidimensional scaling
  \code{\link[MASS]{isoMDS}} on \code{\link{alleleobject}} or
  \code{\link{prab}}-objects for
  different output dimensions in order to compare stress values.  
}

\usage{
  stressvals(x,mdsdim=1:12,trace=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{object of class \code{\link{alleleobject}} or \code{link{prab}}.
    generated by \code{\link{alleleinit}} or \code{\link{prabinit}}.}
  \item{mdsdim}{integer vector of MDS numbers of dimensions to be
    tried.}
  \item{trace}{logical. \code{trace}-argument for \code{\link[MASS]{isoMDS}}
    (should trace information be printed during execution?).}
}


\details{
  Note that zero distances between
  non-identical objects are replaced by the smallest nonzero distance
  divided by 10 to prevent \code{\link[MASS]{isoMDS}} from producing an error.
}

\value{
  A list with components
  \item{MDSstress}{vector of stress values.}
  \item{mdsout}{list of full outputs of \code{\link[MASS]{isoMDS}}.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\examples{
  options(digits=4)
  data(tetragonula)
  set.seed(112233)
  taiselect <- sample(236,40)
# Use data subset to make execution faster.
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[taiselect,],
    cut=50,file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[taiselect,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist)
  stressvals(tai,mdsdim=1:3)$MDSstress
}
\keyword{multivariate}% at least one, from doc/KEYWORDS

\name{dicedist}
\alias{dicedist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Dice distance matrix}
\description{
  Computes a distance derived from Dice's coincidence index
  between the columns of a 0-1-matrix.
}
\usage{
  dicedist(regmat)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{regmat}{0-1-matrix. Columns are species, rows are regions.}
}
\details{
  The Dice distance between two species is 1 minus the Coincidence
  Index, which is (2*number of regions where
  both species are present)/(2*number of regions where
  both species are present plus number of regions where at least one
  species is present). This is S23 in Shi (1993).
}
\value{
  A symmetrical matrix of Dice distances.
}

\references{
  Shi, G. R. (1993) Multivariate data analysis in palaeoecology and
  palaeobiogeography - a review. \emph{Palaeogeography, 
    Palaeoclimatology, Palaeoecology} 105, 199-234.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{kulczynski}},\code{\link{jaccard}}
}

\examples{
options(digits=4)
data(kykladspecreg)
dicedist(t(kykladspecreg))
}
\keyword{cluster}% at least one, from doc/KEYWORDS
\keyword{spatial}% __ONLY ONE__ keyword per line

\name{autoconst}
\alias{autoconst}
\alias{autoreg}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Spatial autocorrelation parameter estimation}
\description{
  Monte Carlo estimation of the disjunction/spatial autocorrelation
  parameter \code{pd} for the simulation model used in
  \code{randpop.nb}, used for tests for clustering of presence-absence data.

  \code{autoconst} is the main function; \code{autoreg} performs the
  simulation and is executed within \code{autoconst}.
}
\usage{
autoconst(x, prange = c(0, 1), twostep = TRUE, step1 = 0.1,
step2 = 0.01, plot = TRUE, nperp = 4, ejprob = NULL,
species.fixed = TRUE, pdfnb=FALSE, ignore.richness=FALSE)

autoreg(x, probs, ejprob, plot = TRUE, nperp = 4, species.fixed = TRUE,
pdfnb=FALSE, ignore.richness=FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{x}{object of class \code{prab} as generated by \code{prabinit}.
    Presence-absence data to be analyzed.}
  \item{prange}{numerical range vector, lower value not smaller than 0, larger
    value not larger than 1. Range where the parameter is to be found.}
  \item{twostep}{logical. If \code{TRUE}, a first estimation step is
    carried out in the whole \code{prange}, and then the final
    estimation is determined between the preliminary estimator
    \code{-5*step2} and \code{+5*step2}. Else, the first simulation
    determines the final estimator.}
  \item{step1}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the first simulation.}
  \item{step2}{numerical between 0 and 1. Interval length between
    subsequent choices of \code{pd} for the second simulation in case of
    \code{twostep=TRUE}.}
  \item{plot}{logical. If \code{TRUE}, a scatterplot of \code{pd}-values
    against resulting \code{ejprob} values (see below), with regression
    line and data value of \code{ejprob} is shown.}
  \item{nperp}{integer. Number of simulations per \code{pd}-value.}
  \item{ejprob}{numerical between 0 and 1. Observed disjunction
    probability for data \code{x}; if not specified in advance,
    it will be computed by \code{autoconst}.}
  \item{species.fixed}{logical. If \code{TRUE}, sizes of generated
    species match the species sizes in \code{x}, else they are generated
    from the empirical distribution of species sizes in \code{x}.}
  \item{probs}{vector of numericals between 0 and 1. \code{pd} values
    for the simulation.}
  \item{pdfnb}{logical. If \code{TRUE}, the probabilities of the regions
    are modified according to the number of neighboring regions in
    \code{randpop.nb}, see Hennig and Hausdorf (2002), p. 5.}
  \item{ignore.richness}{logical. If \code{TRUE}, there is no assumption
    of species richnesses to differ between regions in the null model.
    Regionwise probabilities don't differ in the generation of null
    data.}
}
\details{
  The spatial autocorrelation parameter \code{pd}
  of the model for the generation of
  presence-absence data sets used by \code{randpop.nb} can be estimated
  by use of the observed disjuction probability \code{ejprob} which is
  the sum of
  all species' connectivity components minus the number of species
  divided by the number of "presence" entries minus the number of
  species. This is done by a simulation of artificial data sets with
  characteristics of \code{x} and different \code{pd}-values, governed
  by \code{prange, step1, step2} and \code{nperp}. \code{ejprob} is then
  calculated for all simulated populations. A linear regression of
  \code{ejprob} on \code{pd} is performed and the estimator of \code{pd}
  is determined by computing the inverse of the regression function for
  the \code{ejprob}-value of \code{x}. 
}
\value{
  \code{autoconst} produces the same list as \code{autoreg} with
  additional component \code{ejprob}. The components are 
  \item{pd}{(eventually) estimated parameter \code{pd}.}
  \item{coef}{(eventually) estimated regression coefficients.}
  \item{ejprob}{see above.}
}
\references{
Hausdorf, B. and Hennig, C. (2003)  Biotic Element Analysis in
Biogeography. To appear in  \emph{Systematic Biology}.

Hausdorf, B. and Hennig, C. (2003) Nestedness of north-west European
land snail ranges as a consequence of differential immigration from
Pleistocene glacial refuges. \emph{Oecologia} 135, 102-109.

Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{randpop.nb}}, \code{\link{prabinit}}, \code{\link{con.comp}} 
}

\examples{
options(digits=4)
data(kykladspecreg)
data(nb)
set.seed(1234)
x <- prabinit(prabmatrix=kykladspecreg, neighborhood=nb)
ax <- autoconst(x,nperp=2,step1=0.3,twostep=FALSE)
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{phipt}
\alias{phipt}
\alias{cfchord}
\alias{shared.problist}
\alias{diploidcomlist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Distances between communities, auxiliary functions}
\description{
  Auxiliary functions for \code{\link{communitydist}}. \code{phipt}
  computes phiPT/phiST (Peakall and Smouse, 2012, Meirmans,
  2006) between two communities. \code{cfchord} computes the
  chord-distance (Cavalli-Sforza and Edwards, 1967) between two lists or
  locus-wise relative allele frequencies. \code{shared.problist}
  computes a straightforward generalisation of the shared allele
  distance (Bowcock et al., 1994) between
  individuals for communities, namely the `overlap', i.e., sum of the
  minima of the
  allele relative frequencies. \code{diploidcomlist} constructs the
  input lists for \code{cfchord} and \code{shared.problist} from an
  \code{alleleobject}. It provides relative frequencies for all
  alles of all loci in all communities. 
}

\usage{

phipt(alleleobj,comvector,i,j)
cfchord(p1,p2)
shared.problist(p1,p2)
diploidcomlist(alleleobj,comvector,diploid=TRUE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{alleleobj}{if \code{diploid=TRUE}, an object of class
    \code{alleleobject} as produced by
    function  \code{\link[prabclus]{alleleinit}}. This has the required
    information on the individuals that are grouped into communities. In
    case \code{diploid=FALSE}, a list that needs to have components
    \code{n.variables} (number of loci), \code{alevels} (vector of
    allele names, see \code{\link{alleleinit}}) and
    \code{charmatrix} (matrix of characters with one row for every
    individual and one column for every locus giving the alleles; see
    examples below for how this can be constructed for a
    \code{prabobject} with presence-absence data).}
  \item{comvector}{vector of integers indicating to which
    community an individual belongs.}
  \item{i}{integer. Number of community.}
  \item{j}{integer. Number of community. The phiPT-distance is computed
    between the communities numbered \code{i} and \code{j}}
  \item{p1}{list. Every list entry refers to a locus and is a vector of
    relative frequencies of the alleles present in that locus in a
    community.} 
  \item{p2}{list. Every list entry refers to a locus and is a vector of
    relative frequencies of the alleles present in that locus in a
    community. The chord or shared allele distance is computed between
    the communities encoded by \code{p1} and \code{p2}.} 
  \item{diploid}{logical, indicating whether loci are diploid, see
    \code{alleleobj}.}

}

  

\value{
  \code{cfchord} gives out the value of the chord
  distance. \code{shared.problist} gives out the distance
  value. \code{diploidcomlist} gives out a two-dimensional list. The
  list has one entry for each community, which is itself a list. This
  community list has one entry for each locus, which is a vector that
  gives the relative frequencies of the different alleles in    
  \code{phipt} gives out a list with components \code{phipt, vap, n0,
  sst, ssg, msa, msw}. These refer to the notation on p.2.12 and 2.15 of
  Peakall and Smouse (2012).
  \item{phipt}{value of phiPT.}
  \item{vap}{variance among (between) populations (communities).}
  \item{n0}{standardisation factor N0, see  p.2.12 of Peakall and Smouse (2012).}
  \item{sst}{total distances sum of squares.}
  \item{ssg}{vector with two non-\code{NA} entriesm, within community
    sums of squares for communities \code{i} and \code{j}.}
  \item{msa}{mean square between communities.}
  \item{msw}{mean square within communities.}
}

    
\references{
  Bowcock, A. M., Ruiz-Linares, A., Tomfohrde, J., Minch, E., Kidd, J. R.,
  Cavalli-Sforza, L. L. (1994) High resolution of human evolutionary
  trees with polymorphic microsatellites. \emph{Nature} 368, 455-457.
  
  Cavalli-Sforza, L. L. and Edwards, A. W. F. (1967) Phylogenetic
  Analysis - Models and Estimation Procedures. \emph{The American Journal of
  Human Genetics} 19, 233-257.

  Meirmans, P. G. (2006) Using the AMOVA framework to estimate a
  standardized genetic differentiation measure. \emph{Evolution} 60, 2399-2402.
  
  Peakall, R. and Smouse P.E. (2012) GenAlEx Tutorial 2.
  \url{https://biology-assets.anu.edu.au/GenAlEx/Tutorials.html}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{communitydist}}
}

\examples{
  options(digits=4)
  data(tetragonula)
  tnb <-
  coord2dist(coordmatrix=tetragonula.coord[83:120,],cut=50,file.format="decimal2",neighbors=TRUE)
  ta <- alleleconvert(strmatrix=tetragonula[83:120,])
  tai <- alleleinit(allelematrix=ta,neighborhood=tnb$nblist)
  tetracoms <-
  c(rep(1:3,each=3),4,5,rep(6:11,each=2),12,rep(13:19,each=2))
  phipt(tai,tetracoms,4,6)
  tdip <- diploidcomlist(tai,tetracoms,diploid=TRUE)
  cfchord(tdip[[4]],tdip[[6]])
  shared.problist(tdip[[4]],tdip[[6]])
  
}
\keyword{spatial}% __ONLY ONE__ keyword per line
\keyword{multivariate}% __ONLY ONE__ keyword per line

\name{comp.test}
\alias{comp.test}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Compare species clustering and species groups}
\description{
  Tests for independence between a clustering and another grouping of species.
  This is simply an interface to \code{chisq.test}.
}

\usage{
comp.test(cl,spg)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{cl}{a vector of integers. Clustering of species (may be taken
    from \code{prabclust}).}
  \item{spg}{a vector of integers of the same length, groups of species.}
}
\details{
  \code{chisq.test} with simulated p-value is used.
}
\value{
  Output of \code{chisq.test}.
}

\references{
Hausdorf, B. and Hennig, C. (2003)  Biotic Element Analysis in
Biogeography. \emph{Systematic Biology} 52, 717-723.
}
\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}


\seealso{
  \code{\link{chisq.test}}, \code{\link{prabclust}}.
}


\examples{
set.seed(1234)
g1 <- c(rep(1,34),rep(2,12),rep(3,15))
g2 <- sample(3,61,replace=TRUE)
comp.test(g1,g2)
}
\keyword{htest}% at least one, from doc/KEYWORDS

\name{prabinit}
\alias{prabinit}
\alias{print.prab}
\alias{prab}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Presence-absence/abundance matrix initialization}
\description{
  \code{prabinit} converts a matrix into an object
  of class \code{prab} (presence-absence). The matrix may be read from a
  file or an R-object. It may be a 0-1 matrix or a matrix with
  non-negative entries (usually abundances).
  \code{print.prab} is a print method for such
  objects.

  Documentation here is in terms of biotic elements analysis (species
  are to be clustered). For species delimitation with dominant markers,
  see Hausdorf and Hennig (2010), individuals take the role of species
  and loci take the role of regions.
}
\usage{
prabinit(file = NULL, prabmatrix = NULL, rows.are.species = TRUE,
neighborhood = "none", nbbetweenregions=TRUE, geodist=NULL, gtf=0.1,
distance = "kulczynski", toprab = FALSE, toprabp
= 0.05, outc = 5.2)

\method{print}{prab}(x, ...)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{file}{string. non-negative matrix ASCII file (such as example dataset
    \code{kykladspecreg.dat}) from which the
    matrix is read by \code{read.table}. The usual interpretation is
    that it is a species-by-regions matrix of species presences/absences
    (0-1 matrix) or abundances.}
  \item{prabmatrix}{matrix with non-negative entries. Either \code{file}
    or \code{prabmatrix} should be \code{NA}.}
  \item{rows.are.species}{logical. If \code{TRUE}, rows are interpreted
    as species and columns are interpreted as regions. In this case,
    rows and columns are interchanged by \code{prabinit}.}
  \item{neighborhood}{A string or a list with a component for
    every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a vector \code{numeric(0)}. If \code{neighborhood}
    is a filename, it is attempted to read such a list from a file,
    where every row should correspond to one region (such as example
    dataset \code{nb.dat}). If
    \code{neighborhood="none"}, all neighborhoods are set to
    \code{numeric(0)}. The neighborhood can be tested by
    \code{\link{nbtest}} for consistency.}
  \item{nbbetweenregions}{logical. If \code{TRUE}, the neighborhood is
    defined between regions as explained above. Otherwise it is defined
    between species (or individuals, if this is used for species
    delimitation).}
  \item{geodist}{matrix of non-negative reals. Geographical distances
    between regions. Only used if \code{distance="geco"}.}
  \item{gtf}{tuning constant for geco-distance if \code{distance="geco"},
    see \code{geco}.}
  \item{distance}{\code{"kulczynski"}, \code{"jaccard"}, \code{"geco"},
    \code{"qkulczynski"}, \code{"logkulczynski"} (this calls function
    \code{qkulczynski} with \code{log.distance=TRUE}), \code{"dice"}, or
    \code{"none"}. The distance measure
    between species to compute by \code{prabinit}.}
  \item{toprab}{logical. If \code{TRUE}, a presence-absence matrix is
    computed from the non-negative input matrix. "Absence", i.e., the
    entry 0, is chosen if the original entry is 0, or the original entry
    is smaller than or equal to \code{toprabp} times the
    sum of entries in the
    corresponding region, and log(original entry) is considered to be a
    lower outlier compared with the other entries of the corresponding
    species (see \code{outc}). "Presence", i.e., the entry 1, thus
    means that the original
    entry is non-negligible w.r.t. the species or w.r.t. the region.}
  \item{toprabp}{numerical between 0 and 1, see \code{toprab}.}
  \item{outc}{numerical. Tuning constant for the outlier identification
    associated with \code{toprab=TRUE}. An entry smaller than or equal to
    \code{outc*mad} times the median is considered as a lower outlier.}
  \item{x}{object of class \code{prab}.}
  \item{...}{necessary for print method.}
}

\details{
  Species that are absent in all regions are omitted.}
 
\value{
  \code{prabinit} produces
  an object of class \code{prab}, which is a list with components
  \item{distmat}{distance matrix between species.}
  \item{prab}{abundance or presence/absence matrix (if presence/absence,
    the entries are logical). Rows are regions, columns are
    species.}
  \item{nb}{neighborhood list, see above.}
  \item{regperspec}{vector of the number of regions occupied by a
    species.}
  \item{specperreg}{vector of the number of species present in a region.}
  \item{n.species}{number of species (in the \code{prab}-object, see 
    \code{nonzero}).}
  \item{n.regions}{number of regions.}
  \item{distance}{string denoting the chosen distance measure.}
  \item{geodist}{non-negative matrix. see above.}
  \item{gtf}{numeric. see above.}
  \item{spatial}{\code{TRUE}, if there is a specified neighborhood
    structure.} 
  \item{nonempty.species}{logical vector. The length is the number of species
    in the original file/matrix. If \code{FALSE}, the corresponding species 
    had only zero entries and was therefore absent. Note that these species
    are not included in any other component of a \code{prab} object, i.e.,
    \code{n.species} is the number of \code{TRUE}-entries in
    \code{nonzero}.}
  \item{nbbetweenregions}{see above.}
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\references{
  Hausdorf, B. and Hennig, C. (2010) Species Delimitation Using Dominant
  and Codominant Multilocus Markers. \emph{Systematic Biology}, 59, 491-503.
}

\seealso{\code{\link{read.table}}, \code{\link{jaccard}},
  \code{\link{kulczynski}}, \code{\link{geco}},
  \code{\link{qkulczynski}}, \code{\link{nbtest}},
  \code{\link{alleleinit}}
  }

\examples{
# If you want to use your own ASCII data files, use
# x <- prabinit(file="path/prabmatrixfile",
# neighborhood="path/neighborhoodfile")
data(kykladspecreg)
data(nb)
prabinit(prabmatrix=kykladspecreg, neighborhood=nb)
}
\keyword{spatial}% at least one, from doc/KEYWORDS
\keyword{cluster}% __ONLY ONE__ keyword per line

\name{build.nblist}
\alias{build.nblist}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Generate spatial weights from prabclus neighborhood list}
\description{
  This generates a \code{listw}-object as needed for estimation of a
  simultaneous autoregression model in package \code{spdep} from a
  neighborhood list of the type generated in \code{prabinit}.  
}
\usage{
build.nblist(prabobj,prab01=NULL,style="C")
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{prabobj}{object of class \code{prab}.}
  \item{prab01}{presence-absence matrix of same dimensions than the
  abundance matrix of \code{prabobj}. This specifies the presences and
  absences on which the presence/absence step of abundance-based tests
  is based (see details). If \code{NULL} (which is usually the only
  reasonable choice), \code{prab01} is computed in order to indicate
  the nonzeroes of \code{prabobj$prab}.}
  \item{style}{can take values "W", "B", "C", "U", and "S" though tests
    suggest that "C" should be chosen. See \code{\link[spdep]{nb2listw}}.} 
}
\value{
  A 'listw' object with the following members: 
\item{style}{see above.}
\item{neighbours}{the neighbours list in \code{spdep}-format.}
\item{weights}{the weights for the neighbours and chosen style, with
          attributes set to report the type of relationships (binary or
          general, if general the form of the glist argument), and
          style as above.} 
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link[spdep]{nb2listw}} (which is called)
}

\examples{
# Not run; requires package spdep
# data(siskiyou)
# x <- prabinit(prabmatrix=siskiyou, neighborhood=siskiyou.nb,
#             distance="logkulczynski")
# build.nblist(x)
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{cluspop.nb}
\alias{cluspop.nb}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Simulation of presence-absence matrices (clustered)}
\description{
  Generates a simulated matrix where the rows are interpreted as regions
  and the columns as species, 1 means that a species is present in the
  region and 0 means that the species is absent. Species are generated
  in order to produce 2 clusters of species with similar ranges.
  Spatial autocorrelation of a species' presences is governed by
  the parameter \code{p.nb} and a list of neighbors for each region.
}
\usage{
cluspop.nb(neighbors, p.nb = 0.5, n.species, clus.specs, reg.group,
grouppf = 10, n.regions = length(neighbors),
vector.species = rep(1, n.species), pdf.regions = rep(1/n.regions,
n.regions), count = TRUE, pdfnb = FALSE)
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{neighbors}{A list with a component for every region. The
    components are vectors of integers indicating
    neighboring regions. A region without neighbors (e.g., an island)
    should be assigned a list \code{numeric(0)}.}
  \item{p.nb}{numerical between 0 and 1. The probability that a new
    region is drawn from the non-neighborhood of the previous regions
    belonging to a species under generation. Note that for a given
    presence-absence matrix, this parameter can be estimated by
    \code{autoconst} (called \code{pd} there).}
  \item{n.species}{integer. Number of species.}
  \item{clus.specs}{integer not larger than \code{n.species}. Number of
    species restricted to one of the two groups of regions defined by
    \code{reg.group} (called "clustered species" because this leads to
    more similar species ranges).}
  \item{reg.group}{vector of pairwise distinct integers not larger than
    \code{n. regions}. Defines a group of regions to which a part of the
    \code{clus.specs} clustered species is restricted (more or less, see
    \code{grouppf}). The other clustered species are restricted to the
    complementary regions.}
  \item{grouppf}{numerical. The probability of the region of
    a clustered species to belong to the corresponding group of regions
    is up-weighted by factor \code{grouppf} compared to the generation
    of "non-clustered" species.}
  \item{n.regions}{integer. Number of regions.}
  \item{vector.species}{vector of integers. The sizes
    (i.e., numbers of regions)
    of the species are generated randomly from
    the empirical distribution of \code{vector.species}.}
  \item{pdf.regions}{numerical vector of length \code{n.species}. The
    entries must sum up to 1 and give probabilities for the regions to
    be drawn during the generation of a species. These probabilities are
    used conditional on the new region being a neighbor or a
    non-neighbor of the previous regions of the species, see
    \code{p.nb}, modified by \code{grouppf} for the clustered species.}
  \item{count}{logical. If \code{TRUE}, the number of the currently
    generated species is printed.}
  \item{pdfnb}{logical. If \code{TRUE}, the probabilities of the regions
    are modified according to the number of neighboring regions by
    dividing them relative to the others by min(1,number of neighbors).}
}
\details{
  The non-clustered species are generated as explained on the help page
  for \code{randpop.nb}. The general principle for the clustered species
  is the same, but with modified probabilities for the regions. For each
  clustered species, one of the two groups of regions is drawn,
  distributed according to the sum of its regions' probability given by
  \code{pdf.regions}. The first region of such a species is only drawn
  from the regions of this group.
}
\value{
  A 0-1-matrix, rows are regions, columns are species.
}
\references{
Hennig, C. and Hausdorf, B. (2004) Distance-based parametric bootstrap
tests for clustering of species ranges. \emph{Computational Statistics
  and
  Data Analysis} 45, 875-896.
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{randpop.nb}},
  
  \code{\link{autoconst}} estimates \code{p.nb} from matrices of class
  \code{prab}. These are generated by \code{\link{prabinit}}.
}

\examples{
data(nb)
set.seed(888)
cluspop.nb(nb, p.nb=0.1, n.species=10, clus.specs=9, reg.group=1:17,
vector.species=c(10))
}
\keyword{spatial}% at least one, from doc/KEYWORDS

\name{allelepaircomp}
\alias{allelepaircomp}
%- Also NEED an `\alias' for EACH other topic documented here.
\title{Internal: compares two pairs of alleles}
\description{
  Used for computation of the genetic distances \code{\link{alleledist}}.
%-  \code{\link{neidist}}, \code{\link{chorddist}}.
}
\usage{
  allelepaircomp(allelepair1,allelepair2,method="sum")
}
%- maybe also `usage' for other objects documented here.
\arguments{
  \item{allelepair1}{vector of two allele codes (usually characters), or
    \code{NA}.}
  \item{allelepair2}{vector of two allele codes (usually characters), or
    \code{NA}.}
  \item{method}{one of \code{"sum"} or \code{"geometrical"}.}
}

\value{
  If \code{method=="sum"}, number of shared alleles (0, 1 or 2), or
  \code{NA}. If \code{method=="geometrical"}, 0, 0.5, \code{sqrt(0.5)}
  (in case that one of the allelepairs is double such as in
  \code{c("A","B"),c("A","A")}) or 1, or
  \code{NA}. 
}

\author{Christian Hennig
  \email{christian.hennig@unibo.it}
  \url{https://www.unibo.it/sitoweb/christian.hennig/en}}

\seealso{
  \code{\link{alleledist}}
%-  , \code{\link{neidist}}, \code{\link{chorddist}}.
}

\examples{
  allelepaircomp(c("A","B"),c("A","C"))
}
\keyword{cluster}% at least one, from doc/KEYWORDS
